# coding=utf-8
# pylint: disable=too-many-lines
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

import datetime
from typing import Any, Dict, List, Optional, TYPE_CHECKING, Union

from .. import _serialization

if TYPE_CHECKING:
    # pylint: disable=unused-import,ungrouped-imports
    from .. import models as _models


class AcceptSupplierInviteRequest(_serialization.Model):
    """AcceptSupplierInviteRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar tenant_id: Required.
    :vartype tenant_id: str
    :ivar existing_company_id:
    :vartype existing_company_id: str
    :ivar company_name:
    :vartype company_name: str
    :ivar organization_number:
    :vartype organization_number: str
    :ivar three_letter_iso_country:
    :vartype three_letter_iso_country: str
    """

    _validation = {
        "tenant_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "tenant_id": {"key": "tenantId", "type": "str"},
        "existing_company_id": {"key": "existingCompanyId", "type": "str"},
        "company_name": {"key": "companyName", "type": "str"},
        "organization_number": {"key": "organizationNumber", "type": "str"},
        "three_letter_iso_country": {"key": "threeLetterIsoCountry", "type": "str"},
    }

    def __init__(
        self,
        *,
        tenant_id: str,
        existing_company_id: Optional[str] = None,
        company_name: Optional[str] = None,
        organization_number: Optional[str] = None,
        three_letter_iso_country: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword tenant_id: Required.
        :paramtype tenant_id: str
        :keyword existing_company_id:
        :paramtype existing_company_id: str
        :keyword company_name:
        :paramtype company_name: str
        :keyword organization_number:
        :paramtype organization_number: str
        :keyword three_letter_iso_country:
        :paramtype three_letter_iso_country: str
        """
        super().__init__(**kwargs)
        self.tenant_id = tenant_id
        self.existing_company_id = existing_company_id
        self.company_name = company_name
        self.organization_number = organization_number
        self.three_letter_iso_country = three_letter_iso_country


class AddResourceTypeForNeedsGenerator(_serialization.Model):
    """AddResourceTypeForNeedsGenerator.

    All required parameters must be populated in order to send to Azure.

    :ivar resource_type: Required.
    :vartype resource_type: str
    """

    _validation = {
        "resource_type": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "resource_type": {"key": "resourceType", "type": "str"},
    }

    def __init__(self, *, resource_type: str, **kwargs):
        """
        :keyword resource_type: Required.
        :paramtype resource_type: str
        """
        super().__init__(**kwargs)
        self.resource_type = resource_type


class AssetComsumptionDto(_serialization.Model):
    """AssetComsumptionDto.

    :ivar timeseries_id:
    :vartype timeseries_id: int
    :ivar timeseries_name:
    :vartype timeseries_name: str
    :ivar kwh:
    :vartype kwh: float
    :ivar asset_id:
    :vartype asset_id: int
    :ivar asset_name:
    :vartype asset_name: str
    :ivar co2_equivalent:
    :vartype co2_equivalent: float
    """

    _attribute_map = {
        "timeseries_id": {"key": "timeseriesId", "type": "int"},
        "timeseries_name": {"key": "timeseriesName", "type": "str"},
        "kwh": {"key": "kwh", "type": "float"},
        "asset_id": {"key": "assetId", "type": "int"},
        "asset_name": {"key": "assetName", "type": "str"},
        "co2_equivalent": {"key": "co2Equivalent", "type": "float"},
    }

    def __init__(
        self,
        *,
        timeseries_id: Optional[int] = None,
        timeseries_name: Optional[str] = None,
        kwh: Optional[float] = None,
        asset_id: Optional[int] = None,
        asset_name: Optional[str] = None,
        co2_equivalent: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword timeseries_id:
        :paramtype timeseries_id: int
        :keyword timeseries_name:
        :paramtype timeseries_name: str
        :keyword kwh:
        :paramtype kwh: float
        :keyword asset_id:
        :paramtype asset_id: int
        :keyword asset_name:
        :paramtype asset_name: str
        :keyword co2_equivalent:
        :paramtype co2_equivalent: float
        """
        super().__init__(**kwargs)
        self.timeseries_id = timeseries_id
        self.timeseries_name = timeseries_name
        self.kwh = kwh
        self.asset_id = asset_id
        self.asset_name = asset_name
        self.co2_equivalent = co2_equivalent


class AssetDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """AssetDto.

    :ivar external_id:
    :vartype external_id: str
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar metadata: Dictionary of :code:`<string>`.
    :vartype metadata: dict[str, str]
    :ivar aggregates: Anything.
    :vartype aggregates: any
    :ivar parent_id:
    :vartype parent_id: int
    :ivar source:
    :vartype source: str
    :ivar id:
    :vartype id: int
    :ivar created_time:
    :vartype created_time: int
    :ivar last_updated_time:
    :vartype last_updated_time: int
    :ivar root_id:
    :vartype root_id: int
    """

    _attribute_map = {
        "external_id": {"key": "externalId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "description": {"key": "description", "type": "str"},
        "metadata": {"key": "metadata", "type": "{str}"},
        "aggregates": {"key": "aggregates", "type": "object"},
        "parent_id": {"key": "parentId", "type": "int"},
        "source": {"key": "source", "type": "str"},
        "id": {"key": "id", "type": "int"},
        "created_time": {"key": "createdTime", "type": "int"},
        "last_updated_time": {"key": "lastUpdatedTime", "type": "int"},
        "root_id": {"key": "rootId", "type": "int"},
    }

    def __init__(
        self,
        *,
        external_id: Optional[str] = None,
        name: Optional[str] = None,
        description: Optional[str] = None,
        metadata: Optional[Dict[str, str]] = None,
        aggregates: Optional[Any] = None,
        parent_id: Optional[int] = None,
        source: Optional[str] = None,
        id: Optional[int] = None,  # pylint: disable=redefined-builtin
        created_time: Optional[int] = None,
        last_updated_time: Optional[int] = None,
        root_id: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword external_id:
        :paramtype external_id: str
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword metadata: Dictionary of :code:`<string>`.
        :paramtype metadata: dict[str, str]
        :keyword aggregates: Anything.
        :paramtype aggregates: any
        :keyword parent_id:
        :paramtype parent_id: int
        :keyword source:
        :paramtype source: str
        :keyword id:
        :paramtype id: int
        :keyword created_time:
        :paramtype created_time: int
        :keyword last_updated_time:
        :paramtype last_updated_time: int
        :keyword root_id:
        :paramtype root_id: int
        """
        super().__init__(**kwargs)
        self.external_id = external_id
        self.name = name
        self.description = description
        self.metadata = metadata
        self.aggregates = aggregates
        self.parent_id = parent_id
        self.source = source
        self.id = id
        self.created_time = created_time
        self.last_updated_time = last_updated_time
        self.root_id = root_id


class AssetDtoPagedResult(_serialization.Model):
    """AssetDtoPagedResult.

    All required parameters must be populated in order to send to Azure.

    :ivar results: Required.
    :vartype results: list[~ignos.api.client.models.AssetDto]
    :ivar continuation_token:
    :vartype continuation_token: str
    """

    _validation = {
        "results": {"required": True},
    }

    _attribute_map = {
        "results": {"key": "results", "type": "[AssetDto]"},
        "continuation_token": {"key": "continuationToken", "type": "str"},
    }

    def __init__(self, *, results: List["_models.AssetDto"], continuation_token: Optional[str] = None, **kwargs):
        """
        :keyword results: Required.
        :paramtype results: list[~ignos.api.client.models.AssetDto]
        :keyword continuation_token:
        :paramtype continuation_token: str
        """
        super().__init__(**kwargs)
        self.results = results
        self.continuation_token = continuation_token


class AssetPowerDto(_serialization.Model):
    """AssetPowerDto.

    :ivar timeseries_id:
    :vartype timeseries_id: int
    :ivar timeseries_name:
    :vartype timeseries_name: str
    :ivar asset_id:
    :vartype asset_id: int
    :ivar asset_name:
    :vartype asset_name: str
    :ivar time_series_data_points:
    :vartype time_series_data_points: list[~ignos.api.client.models.NumericDataPointDto]
    """

    _attribute_map = {
        "timeseries_id": {"key": "timeseriesId", "type": "int"},
        "timeseries_name": {"key": "timeseriesName", "type": "str"},
        "asset_id": {"key": "assetId", "type": "int"},
        "asset_name": {"key": "assetName", "type": "str"},
        "time_series_data_points": {"key": "timeSeriesDataPoints", "type": "[NumericDataPointDto]"},
    }

    def __init__(
        self,
        *,
        timeseries_id: Optional[int] = None,
        timeseries_name: Optional[str] = None,
        asset_id: Optional[int] = None,
        asset_name: Optional[str] = None,
        time_series_data_points: Optional[List["_models.NumericDataPointDto"]] = None,
        **kwargs
    ):
        """
        :keyword timeseries_id:
        :paramtype timeseries_id: int
        :keyword timeseries_name:
        :paramtype timeseries_name: str
        :keyword asset_id:
        :paramtype asset_id: int
        :keyword asset_name:
        :paramtype asset_name: str
        :keyword time_series_data_points:
        :paramtype time_series_data_points: list[~ignos.api.client.models.NumericDataPointDto]
        """
        super().__init__(**kwargs)
        self.timeseries_id = timeseries_id
        self.timeseries_name = timeseries_name
        self.asset_id = asset_id
        self.asset_name = asset_name
        self.time_series_data_points = time_series_data_points


class AssetSimpleStructureDto(_serialization.Model):
    """AssetSimpleStructureDto.

    :ivar external_id:
    :vartype external_id: str
    :ivar name:
    :vartype name: str
    :ivar id:
    :vartype id: int
    """

    _attribute_map = {
        "external_id": {"key": "externalId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "id": {"key": "id", "type": "int"},
    }

    def __init__(
        self,
        *,
        external_id: Optional[str] = None,
        name: Optional[str] = None,
        id: Optional[int] = None,  # pylint: disable=redefined-builtin
        **kwargs
    ):
        """
        :keyword external_id:
        :paramtype external_id: str
        :keyword name:
        :paramtype name: str
        :keyword id:
        :paramtype id: int
        """
        super().__init__(**kwargs)
        self.external_id = external_id
        self.name = name
        self.id = id


class AssetStructureDto(_serialization.Model):
    """AssetStructureDto.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar external_id:
    :vartype external_id: str
    :ivar name:
    :vartype name: str
    :ivar aggregates_display:
    :vartype aggregates_display: str
    :ivar aggregates:
    :vartype aggregates: list[~ignos.api.client.models.AssetSimpleStructureDto]
    :ivar id:
    :vartype id: int
    :ivar created_time:
    :vartype created_time: int
    :ivar last_updated_time:
    :vartype last_updated_time: int
    """

    _validation = {
        "aggregates_display": {"readonly": True},
    }

    _attribute_map = {
        "external_id": {"key": "externalId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "aggregates_display": {"key": "aggregatesDisplay", "type": "str"},
        "aggregates": {"key": "aggregates", "type": "[AssetSimpleStructureDto]"},
        "id": {"key": "id", "type": "int"},
        "created_time": {"key": "createdTime", "type": "int"},
        "last_updated_time": {"key": "lastUpdatedTime", "type": "int"},
    }

    def __init__(
        self,
        *,
        external_id: Optional[str] = None,
        name: Optional[str] = None,
        aggregates: Optional[List["_models.AssetSimpleStructureDto"]] = None,
        id: Optional[int] = None,  # pylint: disable=redefined-builtin
        created_time: Optional[int] = None,
        last_updated_time: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword external_id:
        :paramtype external_id: str
        :keyword name:
        :paramtype name: str
        :keyword aggregates:
        :paramtype aggregates: list[~ignos.api.client.models.AssetSimpleStructureDto]
        :keyword id:
        :paramtype id: int
        :keyword created_time:
        :paramtype created_time: int
        :keyword last_updated_time:
        :paramtype last_updated_time: int
        """
        super().__init__(**kwargs)
        self.external_id = external_id
        self.name = name
        self.aggregates_display = None
        self.aggregates = aggregates
        self.id = id
        self.created_time = created_time
        self.last_updated_time = last_updated_time


class AttachCalibrationCertificateRequest(_serialization.Model):
    """AttachCalibrationCertificateRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar upload_key: Required.
    :vartype upload_key: str
    :ivar filename: Required.
    :vartype filename: str
    """

    _validation = {
        "upload_key": {"required": True, "min_length": 1},
        "filename": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "upload_key": {"key": "uploadKey", "type": "str"},
        "filename": {"key": "filename", "type": "str"},
    }

    def __init__(self, *, upload_key: str, filename: str, **kwargs):
        """
        :keyword upload_key: Required.
        :paramtype upload_key: str
        :keyword filename: Required.
        :paramtype filename: str
        """
        super().__init__(**kwargs)
        self.upload_key = upload_key
        self.filename = filename


class AzureRegionDto(_serialization.Model):
    """AzureRegionDto.

    All required parameters must be populated in order to send to Azure.

    :ivar display_name: Required.
    :vartype display_name: str
    :ivar name: Required.
    :vartype name: str
    :ivar region_display_name: Required.
    :vartype region_display_name: str
    """

    _validation = {
        "display_name": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "region_display_name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "display_name": {"key": "displayName", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "region_display_name": {"key": "regionDisplayName", "type": "str"},
    }

    def __init__(self, *, display_name: str, name: str, region_display_name: str, **kwargs):
        """
        :keyword display_name: Required.
        :paramtype display_name: str
        :keyword name: Required.
        :paramtype name: str
        :keyword region_display_name: Required.
        :paramtype region_display_name: str
        """
        super().__init__(**kwargs)
        self.display_name = display_name
        self.name = name
        self.region_display_name = region_display_name


class BatchInsertValueRequest(_serialization.Model):
    """BatchInsertValueRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar element_id: Required.
    :vartype element_id: str
    :ivar operation:
    :vartype operation: int
    :ivar value:
    :vartype value: str
    :ivar tools:
    :vartype tools: list[str]
    """

    _validation = {
        "schema_id": {"required": True, "min_length": 1},
        "element_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "schema_id": {"key": "schemaId", "type": "str"},
        "element_id": {"key": "elementId", "type": "str"},
        "operation": {"key": "operation", "type": "int"},
        "value": {"key": "value", "type": "str"},
        "tools": {"key": "tools", "type": "[str]"},
    }

    def __init__(
        self,
        *,
        schema_id: str,
        element_id: str,
        operation: Optional[int] = None,
        value: Optional[str] = None,
        tools: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword element_id: Required.
        :paramtype element_id: str
        :keyword operation:
        :paramtype operation: int
        :keyword value:
        :paramtype value: str
        :keyword tools:
        :paramtype tools: list[str]
        """
        super().__init__(**kwargs)
        self.schema_id = schema_id
        self.element_id = element_id
        self.operation = operation
        self.value = value
        self.tools = tools


class BatchInsertValuesResponseDto(_serialization.Model):
    """BatchInsertValuesResponseDto.

    All required parameters must be populated in order to send to Azure.

    :ivar element_with_values: Required.
    :vartype element_with_values: ~ignos.api.client.models.MeasurementFormInstanceElementDto
    :ivar tool_warning:
    :vartype tool_warning: str
    """

    _validation = {
        "element_with_values": {"required": True},
    }

    _attribute_map = {
        "element_with_values": {"key": "elementWithValues", "type": "MeasurementFormInstanceElementDto"},
        "tool_warning": {"key": "toolWarning", "type": "str"},
    }

    def __init__(
        self,
        *,
        element_with_values: "_models.MeasurementFormInstanceElementDto",
        tool_warning: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword element_with_values: Required.
        :paramtype element_with_values: ~ignos.api.client.models.MeasurementFormInstanceElementDto
        :keyword tool_warning:
        :paramtype tool_warning: str
        """
        super().__init__(**kwargs)
        self.element_with_values = element_with_values
        self.tool_warning = tool_warning


class CalibrationListToolDto(_serialization.Model):
    """CalibrationListToolDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar tool_id: Required.
    :vartype tool_id: str
    :ivar name: Required.
    :vartype name: str
    :ivar type: Required.
    :vartype type: str
    :ivar sub_type:
    :vartype sub_type: str
    :ivar last_calibration_date:
    :vartype last_calibration_date: ~datetime.datetime
    :ivar next_calibration_date:
    :vartype next_calibration_date: ~datetime.datetime
    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar last_location:
    :vartype last_location: str
    :ivar last_location_date:
    :vartype last_location_date: ~datetime.datetime
    """

    _validation = {
        "id": {"required": True},
        "tool_id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "type": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "tool_id": {"key": "toolId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "type": {"key": "type", "type": "str"},
        "sub_type": {"key": "subType", "type": "str"},
        "last_calibration_date": {"key": "lastCalibrationDate", "type": "iso-8601"},
        "next_calibration_date": {"key": "nextCalibrationDate", "type": "iso-8601"},
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "last_location": {"key": "lastLocation", "type": "str"},
        "last_location_date": {"key": "lastLocationDate", "type": "iso-8601"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        tool_id: str,
        name: str,
        type: str,
        sub_type: Optional[str] = None,
        last_calibration_date: Optional[datetime.datetime] = None,
        next_calibration_date: Optional[datetime.datetime] = None,
        calibration_interval: Optional[int] = None,
        last_location: Optional[str] = None,
        last_location_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword tool_id: Required.
        :paramtype tool_id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword type: Required.
        :paramtype type: str
        :keyword sub_type:
        :paramtype sub_type: str
        :keyword last_calibration_date:
        :paramtype last_calibration_date: ~datetime.datetime
        :keyword next_calibration_date:
        :paramtype next_calibration_date: ~datetime.datetime
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword last_location:
        :paramtype last_location: str
        :keyword last_location_date:
        :paramtype last_location_date: ~datetime.datetime
        """
        super().__init__(**kwargs)
        self.id = id
        self.tool_id = tool_id
        self.name = name
        self.type = type
        self.sub_type = sub_type
        self.last_calibration_date = last_calibration_date
        self.next_calibration_date = next_calibration_date
        self.calibration_interval = calibration_interval
        self.last_location = last_location
        self.last_location_date = last_location_date


class CdfConfigDto(_serialization.Model):
    """CdfConfigDto.

    :ivar tenant_id:
    :vartype tenant_id: str
    :ivar client_id:
    :vartype client_id: str
    :ivar client_secret_exists:
    :vartype client_secret_exists: bool
    """

    _attribute_map = {
        "tenant_id": {"key": "tenantId", "type": "str"},
        "client_id": {"key": "clientId", "type": "str"},
        "client_secret_exists": {"key": "clientSecretExists", "type": "bool"},
    }

    def __init__(
        self,
        *,
        tenant_id: Optional[str] = None,
        client_id: Optional[str] = None,
        client_secret_exists: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword tenant_id:
        :paramtype tenant_id: str
        :keyword client_id:
        :paramtype client_id: str
        :keyword client_secret_exists:
        :paramtype client_secret_exists: bool
        """
        super().__init__(**kwargs)
        self.tenant_id = tenant_id
        self.client_id = client_id
        self.client_secret_exists = client_secret_exists


class CompanyCustomerDto(_serialization.Model):
    """CompanyCustomerDto.

    :ivar customer_tenant_id:
    :vartype customer_tenant_id: str
    :ivar customer_azure_ad_tenant_id:
    :vartype customer_azure_ad_tenant_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar supplier_id:
    :vartype supplier_id: str
    :ivar supplier_name:
    :vartype supplier_name: str
    """

    _attribute_map = {
        "customer_tenant_id": {"key": "customerTenantId", "type": "str"},
        "customer_azure_ad_tenant_id": {"key": "customerAzureAdTenantId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "supplier_id": {"key": "supplierId", "type": "str"},
        "supplier_name": {"key": "supplierName", "type": "str"},
    }

    def __init__(
        self,
        *,
        customer_tenant_id: Optional[str] = None,
        customer_azure_ad_tenant_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        supplier_id: Optional[str] = None,
        supplier_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword customer_tenant_id:
        :paramtype customer_tenant_id: str
        :keyword customer_azure_ad_tenant_id:
        :paramtype customer_azure_ad_tenant_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword supplier_id:
        :paramtype supplier_id: str
        :keyword supplier_name:
        :paramtype supplier_name: str
        """
        super().__init__(**kwargs)
        self.customer_tenant_id = customer_tenant_id
        self.customer_azure_ad_tenant_id = customer_azure_ad_tenant_id
        self.customer_name = customer_name
        self.supplier_id = supplier_id
        self.supplier_name = supplier_name


class CompanyDto(_serialization.Model):
    """CompanyDto.

    :ivar id:
    :vartype id: str
    :ivar name:
    :vartype name: str
    :ivar organization_number:
    :vartype organization_number: str
    :ivar country:
    :vartype country: str
    """

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "organization_number": {"key": "organizationNumber", "type": "str"},
        "country": {"key": "country", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        name: Optional[str] = None,
        organization_number: Optional[str] = None,
        country: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword name:
        :paramtype name: str
        :keyword organization_number:
        :paramtype organization_number: str
        :keyword country:
        :paramtype country: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name
        self.organization_number = organization_number
        self.country = country


class CompanyUserDto(_serialization.Model):
    """CompanyUserDto.

    :ivar company_id:
    :vartype company_id: str
    :ivar username:
    :vartype username: str
    :ivar name:
    :vartype name: str
    :ivar roles:
    :vartype roles: list[str]
    """

    _attribute_map = {
        "company_id": {"key": "companyId", "type": "str"},
        "username": {"key": "username", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "roles": {"key": "roles", "type": "[str]"},
    }

    def __init__(
        self,
        *,
        company_id: Optional[str] = None,
        username: Optional[str] = None,
        name: Optional[str] = None,
        roles: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword company_id:
        :paramtype company_id: str
        :keyword username:
        :paramtype username: str
        :keyword name:
        :paramtype name: str
        :keyword roles:
        :paramtype roles: list[str]
        """
        super().__init__(**kwargs)
        self.company_id = company_id
        self.username = username
        self.name = name
        self.roles = roles


class ComponentSettingsDto(_serialization.Model):
    """ComponentSettingsDto.

    :ivar component_id:
    :vartype component_id: str
    :ivar disabled_fields:
    :vartype disabled_fields: list[str]
    """

    _attribute_map = {
        "component_id": {"key": "componentId", "type": "str"},
        "disabled_fields": {"key": "disabledFields", "type": "[str]"},
    }

    def __init__(self, *, component_id: Optional[str] = None, disabled_fields: Optional[List[str]] = None, **kwargs):
        """
        :keyword component_id:
        :paramtype component_id: str
        :keyword disabled_fields:
        :paramtype disabled_fields: list[str]
        """
        super().__init__(**kwargs)
        self.component_id = component_id
        self.disabled_fields = disabled_fields


class ConsumptionDto(_serialization.Model):
    """ConsumptionDto.

    :ivar asset_name:
    :vartype asset_name: str
    :ivar kwh:
    :vartype kwh: float
    :ivar co2_equivalent:
    :vartype co2_equivalent: float
    :ivar items:
    :vartype items: list[~ignos.api.client.models.AssetComsumptionDto]
    """

    _attribute_map = {
        "asset_name": {"key": "assetName", "type": "str"},
        "kwh": {"key": "kwh", "type": "float"},
        "co2_equivalent": {"key": "co2Equivalent", "type": "float"},
        "items": {"key": "items", "type": "[AssetComsumptionDto]"},
    }

    def __init__(
        self,
        *,
        asset_name: Optional[str] = None,
        kwh: Optional[float] = None,
        co2_equivalent: Optional[float] = None,
        items: Optional[List["_models.AssetComsumptionDto"]] = None,
        **kwargs
    ):
        """
        :keyword asset_name:
        :paramtype asset_name: str
        :keyword kwh:
        :paramtype kwh: float
        :keyword co2_equivalent:
        :paramtype co2_equivalent: float
        :keyword items:
        :paramtype items: list[~ignos.api.client.models.AssetComsumptionDto]
        """
        super().__init__(**kwargs)
        self.asset_name = asset_name
        self.kwh = kwh
        self.co2_equivalent = co2_equivalent
        self.items = items


class CountryDto(_serialization.Model):
    """CountryDto.

    All required parameters must be populated in order to send to Azure.

    :ivar two_letter_iso_region_name: Required.
    :vartype two_letter_iso_region_name: str
    :ivar three_letter_iso_region_name: Required.
    :vartype three_letter_iso_region_name: str
    :ivar name: Required.
    :vartype name: str
    """

    _validation = {
        "two_letter_iso_region_name": {"required": True, "min_length": 1},
        "three_letter_iso_region_name": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "two_letter_iso_region_name": {"key": "twoLetterISORegionName", "type": "str"},
        "three_letter_iso_region_name": {"key": "threeLetterISORegionName", "type": "str"},
        "name": {"key": "name", "type": "str"},
    }

    def __init__(self, *, two_letter_iso_region_name: str, three_letter_iso_region_name: str, name: str, **kwargs):
        """
        :keyword two_letter_iso_region_name: Required.
        :paramtype two_letter_iso_region_name: str
        :keyword three_letter_iso_region_name: Required.
        :paramtype three_letter_iso_region_name: str
        :keyword name: Required.
        :paramtype name: str
        """
        super().__init__(**kwargs)
        self.two_letter_iso_region_name = two_letter_iso_region_name
        self.three_letter_iso_region_name = three_letter_iso_region_name
        self.name = name


class CreateAsset(_serialization.Model):
    """CreateAsset.

    :ivar parent_id:
    :vartype parent_id: int
    """

    _attribute_map = {
        "parent_id": {"key": "parentId", "type": "int"},
    }

    def __init__(self, *, parent_id: Optional[int] = None, **kwargs):
        """
        :keyword parent_id:
        :paramtype parent_id: int
        """
        super().__init__(**kwargs)
        self.parent_id = parent_id


class CreateCompanyUserRequest(_serialization.Model):
    """CreateCompanyUserRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar username: Required.
    :vartype username: str
    :ivar name: Required.
    :vartype name: str
    :ivar roles: Required.
    :vartype roles: list[str]
    """

    _validation = {
        "username": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "roles": {"required": True},
    }

    _attribute_map = {
        "username": {"key": "username", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "roles": {"key": "roles", "type": "[str]"},
    }

    def __init__(self, *, username: str, name: str, roles: List[str], **kwargs):
        """
        :keyword username: Required.
        :paramtype username: str
        :keyword name: Required.
        :paramtype name: str
        :keyword roles: Required.
        :paramtype roles: list[str]
        """
        super().__init__(**kwargs)
        self.username = username
        self.name = name
        self.roles = roles


class CreateCustomerOrderLineGhgReport(_serialization.Model):
    """CreateCustomerOrderLineGhgReport.

    All required parameters must be populated in order to send to Azure.

    :ivar customer_order: Required.
    :vartype customer_order: ~ignos.api.client.models.SustainabilityCustomerOrderDto
    :ivar nodes: Required.
    :vartype nodes: list[~ignos.api.client.models.SustainabilityNodeDto]
    """

    _validation = {
        "customer_order": {"required": True},
        "nodes": {"required": True},
    }

    _attribute_map = {
        "customer_order": {"key": "customerOrder", "type": "SustainabilityCustomerOrderDto"},
        "nodes": {"key": "nodes", "type": "[SustainabilityNodeDto]"},
    }

    def __init__(
        self,
        *,
        customer_order: "_models.SustainabilityCustomerOrderDto",
        nodes: List["_models.SustainabilityNodeDto"],
        **kwargs
    ):
        """
        :keyword customer_order: Required.
        :paramtype customer_order: ~ignos.api.client.models.SustainabilityCustomerOrderDto
        :keyword nodes: Required.
        :paramtype nodes: list[~ignos.api.client.models.SustainabilityNodeDto]
        """
        super().__init__(**kwargs)
        self.customer_order = customer_order
        self.nodes = nodes


class CreateElectricalIotConfig(_serialization.Model):
    """CreateElectricalIotConfig.

    :ivar type_id:
    :vartype type_id: str
    :ivar serial_number:
    :vartype serial_number: str
    :ivar asset_id:
    :vartype asset_id: int
    :ivar asset_external_id:
    :vartype asset_external_id: str
    """

    _attribute_map = {
        "type_id": {"key": "typeId", "type": "str"},
        "serial_number": {"key": "serialNumber", "type": "str"},
        "asset_id": {"key": "assetId", "type": "int"},
        "asset_external_id": {"key": "assetExternalId", "type": "str"},
    }

    def __init__(
        self,
        *,
        type_id: Optional[str] = None,
        serial_number: Optional[str] = None,
        asset_id: Optional[int] = None,
        asset_external_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword type_id:
        :paramtype type_id: str
        :keyword serial_number:
        :paramtype serial_number: str
        :keyword asset_id:
        :paramtype asset_id: int
        :keyword asset_external_id:
        :paramtype asset_external_id: str
        """
        super().__init__(**kwargs)
        self.type_id = type_id
        self.serial_number = serial_number
        self.asset_id = asset_id
        self.asset_external_id = asset_external_id


class CreateLinkRequest(_serialization.Model):
    """CreateLinkRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar uri: Required.
    :vartype uri: str
    :ivar name: Required.
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar new_tab:
    :vartype new_tab: bool
    :ivar color:
    :vartype color: str
    :ivar icon_name:
    :vartype icon_name: str
    """

    _validation = {
        "uri": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "uri": {"key": "uri", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "description": {"key": "description", "type": "str"},
        "new_tab": {"key": "newTab", "type": "bool"},
        "color": {"key": "color", "type": "str"},
        "icon_name": {"key": "iconName", "type": "str"},
    }

    def __init__(
        self,
        *,
        uri: str,
        name: str,
        description: Optional[str] = None,
        new_tab: Optional[bool] = None,
        color: Optional[str] = None,
        icon_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword uri: Required.
        :paramtype uri: str
        :keyword name: Required.
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword new_tab:
        :paramtype new_tab: bool
        :keyword color:
        :paramtype color: str
        :keyword icon_name:
        :paramtype icon_name: str
        """
        super().__init__(**kwargs)
        self.uri = uri
        self.name = name
        self.description = description
        self.new_tab = new_tab
        self.color = color
        self.icon_name = icon_name


class CreateMeasurementFormInstanceRequest(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """CreateMeasurementFormInstanceRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_group_id:
    :vartype customer_group_id: str
    :ivar validation_rule_id:
    :vartype validation_rule_id: str
    :ivar quantity: Required.
    :vartype quantity: int
    :ivar schema_ids: Required.
    :vartype schema_ids: list[str]
    :ivar sequences: Required.
    :vartype sequences: list[~ignos.api.client.models.MeasurementFormWorkorderSequenceDto]
    :ivar suppliers: Required.
    :vartype suppliers: list[~ignos.api.client.models.MeasurementFormWorkorderSupplierDto]
    """

    _validation = {
        "quantity": {"required": True},
        "schema_ids": {"required": True},
        "sequences": {"required": True},
        "suppliers": {"required": True},
    }

    _attribute_map = {
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_group_id": {"key": "customerGroupId", "type": "str"},
        "validation_rule_id": {"key": "validationRuleId", "type": "str"},
        "quantity": {"key": "quantity", "type": "int"},
        "schema_ids": {"key": "schemaIds", "type": "[str]"},
        "sequences": {"key": "sequences", "type": "[MeasurementFormWorkorderSequenceDto]"},
        "suppliers": {"key": "suppliers", "type": "[MeasurementFormWorkorderSupplierDto]"},
    }

    def __init__(
        self,
        *,
        quantity: int,
        schema_ids: List[str],
        sequences: List["_models.MeasurementFormWorkorderSequenceDto"],
        suppliers: List["_models.MeasurementFormWorkorderSupplierDto"],
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        customer_id: Optional[str] = None,
        customer_group_id: Optional[str] = None,
        validation_rule_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_group_id:
        :paramtype customer_group_id: str
        :keyword validation_rule_id:
        :paramtype validation_rule_id: str
        :keyword quantity: Required.
        :paramtype quantity: int
        :keyword schema_ids: Required.
        :paramtype schema_ids: list[str]
        :keyword sequences: Required.
        :paramtype sequences: list[~ignos.api.client.models.MeasurementFormWorkorderSequenceDto]
        :keyword suppliers: Required.
        :paramtype suppliers: list[~ignos.api.client.models.MeasurementFormWorkorderSupplierDto]
        """
        super().__init__(**kwargs)
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.customer_id = customer_id
        self.customer_group_id = customer_group_id
        self.validation_rule_id = validation_rule_id
        self.quantity = quantity
        self.schema_ids = schema_ids
        self.sequences = sequences
        self.suppliers = suppliers


class CreateMeasurementFormMapping(_serialization.Model):
    """CreateMeasurementFormMapping.

    All required parameters must be populated in order to send to Azure.

    :ivar source_id: Required.
    :vartype source_id: str
    :ivar target_id: Required.
    :vartype target_id: str
    """

    _validation = {
        "source_id": {"required": True, "min_length": 1},
        "target_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "source_id": {"key": "sourceId", "type": "str"},
        "target_id": {"key": "targetId", "type": "str"},
    }

    def __init__(self, *, source_id: str, target_id: str, **kwargs):
        """
        :keyword source_id: Required.
        :paramtype source_id: str
        :keyword target_id: Required.
        :paramtype target_id: str
        """
        super().__init__(**kwargs)
        self.source_id = source_id
        self.target_id = target_id


class CreateMeasurementFormSchema(_serialization.Model):
    """CreateMeasurementFormSchema.

    All required parameters must be populated in order to send to Azure.

    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing: Required.
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    """

    _validation = {
        "drawing": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
    }

    def __init__(
        self,
        *,
        drawing: str,
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing: Required.
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        """
        super().__init__(**kwargs)
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision


class CreateMeasurementFormSchemaFeedbackRequest(_serialization.Model):
    """CreateMeasurementFormSchemaFeedbackRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar balloon_id:
    :vartype balloon_id: str
    :ivar feedback: Required.
    :vartype feedback: str
    """

    _validation = {
        "feedback": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "balloon_id": {"key": "balloonId", "type": "str"},
        "feedback": {"key": "feedback", "type": "str"},
    }

    def __init__(self, *, feedback: str, balloon_id: Optional[str] = None, **kwargs):
        """
        :keyword balloon_id:
        :paramtype balloon_id: str
        :keyword feedback: Required.
        :paramtype feedback: str
        """
        super().__init__(**kwargs)
        self.balloon_id = balloon_id
        self.feedback = feedback


class CreateMeasurementFormSchemaLinkRequest(_serialization.Model):
    """CreateMeasurementFormSchemaLinkRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar link_schema_id: Required.
    :vartype link_schema_id: str
    """

    _validation = {
        "link_schema_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "link_schema_id": {"key": "linkSchemaId", "type": "str"},
    }

    def __init__(self, *, link_schema_id: str, **kwargs):
        """
        :keyword link_schema_id: Required.
        :paramtype link_schema_id: str
        """
        super().__init__(**kwargs)
        self.link_schema_id = link_schema_id


class CreateMeasuringToolManufacturer(_serialization.Model):
    """CreateMeasuringToolManufacturer.

    All required parameters must be populated in order to send to Azure.

    :ivar name: Required.
    :vartype name: str
    """

    _validation = {
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "name": {"key": "name", "type": "str"},
    }

    def __init__(self, *, name: str, **kwargs):
        """
        :keyword name: Required.
        :paramtype name: str
        """
        super().__init__(**kwargs)
        self.name = name


class CreateMeasuringToolRequest(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """CreateMeasuringToolRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar tool_id:
    :vartype tool_id: str
    :ivar name: Required.
    :vartype name: str
    :ivar manufacturer: Required.
    :vartype manufacturer: str
    :ivar type_id: Required.
    :vartype type_id: str
    :ivar sub_type_id:
    :vartype sub_type_id: str
    :ivar unit_id:
    :vartype unit_id: str
    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar non_calibration_tool: Required.
    :vartype non_calibration_tool: bool
    :ivar min:
    :vartype min: float
    :ivar max:
    :vartype max: float
    :ivar serial_number:
    :vartype serial_number: str
    :ivar default_location:
    :vartype default_location: str
    :ivar precision:
    :vartype precision: str
    :ivar upload_key:
    :vartype upload_key: str
    :ivar filename:
    :vartype filename: str
    """

    _validation = {
        "name": {"required": True, "min_length": 1},
        "manufacturer": {"required": True, "min_length": 1},
        "type_id": {"required": True},
        "non_calibration_tool": {"required": True},
    }

    _attribute_map = {
        "tool_id": {"key": "toolId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "manufacturer": {"key": "manufacturer", "type": "str"},
        "type_id": {"key": "typeId", "type": "str"},
        "sub_type_id": {"key": "subTypeId", "type": "str"},
        "unit_id": {"key": "unitId", "type": "str"},
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "non_calibration_tool": {"key": "nonCalibrationTool", "type": "bool"},
        "min": {"key": "min", "type": "float"},
        "max": {"key": "max", "type": "float"},
        "serial_number": {"key": "serialNumber", "type": "str"},
        "default_location": {"key": "defaultLocation", "type": "str"},
        "precision": {"key": "precision", "type": "str"},
        "upload_key": {"key": "uploadKey", "type": "str"},
        "filename": {"key": "filename", "type": "str"},
    }

    def __init__(
        self,
        *,
        name: str,
        manufacturer: str,
        type_id: str,
        non_calibration_tool: bool,
        tool_id: Optional[str] = None,
        sub_type_id: Optional[str] = None,
        unit_id: Optional[str] = None,
        calibration_interval: Optional[int] = None,
        min: Optional[float] = None,  # pylint: disable=redefined-builtin
        max: Optional[float] = None,  # pylint: disable=redefined-builtin
        serial_number: Optional[str] = None,
        default_location: Optional[str] = None,
        precision: Optional[str] = None,
        upload_key: Optional[str] = None,
        filename: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword tool_id:
        :paramtype tool_id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword manufacturer: Required.
        :paramtype manufacturer: str
        :keyword type_id: Required.
        :paramtype type_id: str
        :keyword sub_type_id:
        :paramtype sub_type_id: str
        :keyword unit_id:
        :paramtype unit_id: str
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword non_calibration_tool: Required.
        :paramtype non_calibration_tool: bool
        :keyword min:
        :paramtype min: float
        :keyword max:
        :paramtype max: float
        :keyword serial_number:
        :paramtype serial_number: str
        :keyword default_location:
        :paramtype default_location: str
        :keyword precision:
        :paramtype precision: str
        :keyword upload_key:
        :paramtype upload_key: str
        :keyword filename:
        :paramtype filename: str
        """
        super().__init__(**kwargs)
        self.tool_id = tool_id
        self.name = name
        self.manufacturer = manufacturer
        self.type_id = type_id
        self.sub_type_id = sub_type_id
        self.unit_id = unit_id
        self.calibration_interval = calibration_interval
        self.non_calibration_tool = non_calibration_tool
        self.min = min
        self.max = max
        self.serial_number = serial_number
        self.default_location = default_location
        self.precision = precision
        self.upload_key = upload_key
        self.filename = filename


class CreateMeasuringToolSubTypeRequest(_serialization.Model):
    """CreateMeasuringToolSubTypeRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar name: Required.
    :vartype name: str
    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar max_number_of_usages_between_calibration:
    :vartype max_number_of_usages_between_calibration: int
    """

    _validation = {
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "name": {"key": "name", "type": "str"},
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "max_number_of_usages_between_calibration": {"key": "maxNumberOfUsagesBetweenCalibration", "type": "int"},
    }

    def __init__(
        self,
        *,
        name: str,
        calibration_interval: Optional[int] = None,
        max_number_of_usages_between_calibration: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword name: Required.
        :paramtype name: str
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword max_number_of_usages_between_calibration:
        :paramtype max_number_of_usages_between_calibration: int
        """
        super().__init__(**kwargs)
        self.name = name
        self.calibration_interval = calibration_interval
        self.max_number_of_usages_between_calibration = max_number_of_usages_between_calibration


class CreateMeasuringToolType(_serialization.Model):
    """CreateMeasuringToolType.

    All required parameters must be populated in order to send to Azure.

    :ivar name: Required.
    :vartype name: str
    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar max_number_of_usages_between_calibration:
    :vartype max_number_of_usages_between_calibration: int
    """

    _validation = {
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "name": {"key": "name", "type": "str"},
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "max_number_of_usages_between_calibration": {"key": "maxNumberOfUsagesBetweenCalibration", "type": "int"},
    }

    def __init__(
        self,
        *,
        name: str,
        calibration_interval: Optional[int] = None,
        max_number_of_usages_between_calibration: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword name: Required.
        :paramtype name: str
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword max_number_of_usages_between_calibration:
        :paramtype max_number_of_usages_between_calibration: int
        """
        super().__init__(**kwargs)
        self.name = name
        self.calibration_interval = calibration_interval
        self.max_number_of_usages_between_calibration = max_number_of_usages_between_calibration


class CreateMeasuringUnit(_serialization.Model):
    """CreateMeasuringUnit.

    All required parameters must be populated in order to send to Azure.

    :ivar unit: Required.
    :vartype unit: str
    """

    _validation = {
        "unit": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "unit": {"key": "unit", "type": "str"},
    }

    def __init__(self, *, unit: str, **kwargs):
        """
        :keyword unit: Required.
        :paramtype unit: str
        """
        super().__init__(**kwargs)
        self.unit = unit


class CreateSchemaElement(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """CreateSchemaElement.

    :ivar balloon_id:
    :vartype balloon_id: str
    :ivar section:
    :vartype section: str
    :ivar page_number:
    :vartype page_number: int
    :ivar sheet_zone:
    :vartype sheet_zone: str
    :ivar places:
    :vartype places: int
    :ivar nominal:
    :vartype nominal: float
    :ivar nominal_text:
    :vartype nominal_text: str
    :ivar type:
    :vartype type: str
    :ivar sub_type:
    :vartype sub_type: str
    :ivar unit_of_measure:
    :vartype unit_of_measure: str
    :ivar plus_tolerance:
    :vartype plus_tolerance: float
    :ivar minus_tolerance:
    :vartype minus_tolerance: float
    :ivar upper_limit:
    :vartype upper_limit: float
    :ivar lower_limit:
    :vartype lower_limit: float
    :ivar inspection_method:
    :vartype inspection_method: str
    :ivar process:
    :vartype process: str
    :ivar classification:
    :vartype classification: str
    :ivar comments:
    :vartype comments: str
    :ivar frequency:
    :vartype frequency: int
    :ivar frequency_parameter:
    :vartype frequency_parameter: int
    :ivar include_in_customer_documentation:
    :vartype include_in_customer_documentation: bool
    :ivar balloon_sequence:
    :vartype balloon_sequence: int
    :ivar balloon_quantity:
    :vartype balloon_quantity: int
    :ivar plus_tolerance_text:
    :vartype plus_tolerance_text: str
    :ivar minus_tolerance_text:
    :vartype minus_tolerance_text: str
    :ivar coating_thickness:
    :vartype coating_thickness: int
    """

    _attribute_map = {
        "balloon_id": {"key": "balloonId", "type": "str"},
        "section": {"key": "section", "type": "str"},
        "page_number": {"key": "pageNumber", "type": "int"},
        "sheet_zone": {"key": "sheetZone", "type": "str"},
        "places": {"key": "places", "type": "int"},
        "nominal": {"key": "nominal", "type": "float"},
        "nominal_text": {"key": "nominalText", "type": "str"},
        "type": {"key": "type", "type": "str"},
        "sub_type": {"key": "subType", "type": "str"},
        "unit_of_measure": {"key": "unitOfMeasure", "type": "str"},
        "plus_tolerance": {"key": "plusTolerance", "type": "float"},
        "minus_tolerance": {"key": "minusTolerance", "type": "float"},
        "upper_limit": {"key": "upperLimit", "type": "float"},
        "lower_limit": {"key": "lowerLimit", "type": "float"},
        "inspection_method": {"key": "inspectionMethod", "type": "str"},
        "process": {"key": "process", "type": "str"},
        "classification": {"key": "classification", "type": "str"},
        "comments": {"key": "comments", "type": "str"},
        "frequency": {"key": "frequency", "type": "int"},
        "frequency_parameter": {"key": "frequencyParameter", "type": "int"},
        "include_in_customer_documentation": {"key": "includeInCustomerDocumentation", "type": "bool"},
        "balloon_sequence": {"key": "balloonSequence", "type": "int"},
        "balloon_quantity": {"key": "balloonQuantity", "type": "int"},
        "plus_tolerance_text": {"key": "plusToleranceText", "type": "str"},
        "minus_tolerance_text": {"key": "minusToleranceText", "type": "str"},
        "coating_thickness": {"key": "coatingThickness", "type": "int"},
    }

    def __init__(  # pylint: disable=too-many-locals
        self,
        *,
        balloon_id: Optional[str] = None,
        section: Optional[str] = None,
        page_number: Optional[int] = None,
        sheet_zone: Optional[str] = None,
        places: Optional[int] = None,
        nominal: Optional[float] = None,
        nominal_text: Optional[str] = None,
        type: Optional[str] = None,
        sub_type: Optional[str] = None,
        unit_of_measure: Optional[str] = None,
        plus_tolerance: Optional[float] = None,
        minus_tolerance: Optional[float] = None,
        upper_limit: Optional[float] = None,
        lower_limit: Optional[float] = None,
        inspection_method: Optional[str] = None,
        process: Optional[str] = None,
        classification: Optional[str] = None,
        comments: Optional[str] = None,
        frequency: Optional[int] = None,
        frequency_parameter: Optional[int] = None,
        include_in_customer_documentation: Optional[bool] = None,
        balloon_sequence: Optional[int] = None,
        balloon_quantity: Optional[int] = None,
        plus_tolerance_text: Optional[str] = None,
        minus_tolerance_text: Optional[str] = None,
        coating_thickness: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword balloon_id:
        :paramtype balloon_id: str
        :keyword section:
        :paramtype section: str
        :keyword page_number:
        :paramtype page_number: int
        :keyword sheet_zone:
        :paramtype sheet_zone: str
        :keyword places:
        :paramtype places: int
        :keyword nominal:
        :paramtype nominal: float
        :keyword nominal_text:
        :paramtype nominal_text: str
        :keyword type:
        :paramtype type: str
        :keyword sub_type:
        :paramtype sub_type: str
        :keyword unit_of_measure:
        :paramtype unit_of_measure: str
        :keyword plus_tolerance:
        :paramtype plus_tolerance: float
        :keyword minus_tolerance:
        :paramtype minus_tolerance: float
        :keyword upper_limit:
        :paramtype upper_limit: float
        :keyword lower_limit:
        :paramtype lower_limit: float
        :keyword inspection_method:
        :paramtype inspection_method: str
        :keyword process:
        :paramtype process: str
        :keyword classification:
        :paramtype classification: str
        :keyword comments:
        :paramtype comments: str
        :keyword frequency:
        :paramtype frequency: int
        :keyword frequency_parameter:
        :paramtype frequency_parameter: int
        :keyword include_in_customer_documentation:
        :paramtype include_in_customer_documentation: bool
        :keyword balloon_sequence:
        :paramtype balloon_sequence: int
        :keyword balloon_quantity:
        :paramtype balloon_quantity: int
        :keyword plus_tolerance_text:
        :paramtype plus_tolerance_text: str
        :keyword minus_tolerance_text:
        :paramtype minus_tolerance_text: str
        :keyword coating_thickness:
        :paramtype coating_thickness: int
        """
        super().__init__(**kwargs)
        self.balloon_id = balloon_id
        self.section = section
        self.page_number = page_number
        self.sheet_zone = sheet_zone
        self.places = places
        self.nominal = nominal
        self.nominal_text = nominal_text
        self.type = type
        self.sub_type = sub_type
        self.unit_of_measure = unit_of_measure
        self.plus_tolerance = plus_tolerance
        self.minus_tolerance = minus_tolerance
        self.upper_limit = upper_limit
        self.lower_limit = lower_limit
        self.inspection_method = inspection_method
        self.process = process
        self.classification = classification
        self.comments = comments
        self.frequency = frequency
        self.frequency_parameter = frequency_parameter
        self.include_in_customer_documentation = include_in_customer_documentation
        self.balloon_sequence = balloon_sequence
        self.balloon_quantity = balloon_quantity
        self.plus_tolerance_text = plus_tolerance_text
        self.minus_tolerance_text = minus_tolerance_text
        self.coating_thickness = coating_thickness


class CreateSupplierInvite(_serialization.Model):
    """CreateSupplierInvite.

    All required parameters must be populated in order to send to Azure.

    :ivar supplier_id: Required.
    :vartype supplier_id: str
    :ivar name: Required.
    :vartype name: str
    :ivar username: Required.
    :vartype username: str
    :ivar deadline: Required.
    :vartype deadline: ~datetime.datetime
    """

    _validation = {
        "supplier_id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "username": {"required": True, "min_length": 1},
        "deadline": {"required": True},
    }

    _attribute_map = {
        "supplier_id": {"key": "supplierId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "username": {"key": "username", "type": "str"},
        "deadline": {"key": "deadline", "type": "iso-8601"},
    }

    def __init__(self, *, supplier_id: str, name: str, username: str, deadline: datetime.datetime, **kwargs):
        """
        :keyword supplier_id: Required.
        :paramtype supplier_id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword username: Required.
        :paramtype username: str
        :keyword deadline: Required.
        :paramtype deadline: ~datetime.datetime
        """
        super().__init__(**kwargs)
        self.supplier_id = supplier_id
        self.name = name
        self.username = username
        self.deadline = deadline


class CustomerDto(_serialization.Model):
    """CustomerDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name: Required.
    :vartype name: str
    :ivar group_id:
    :vartype group_id: str
    :ivar group_name:
    :vartype group_name: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "group_id": {"key": "groupId", "type": "str"},
        "group_name": {"key": "groupName", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        name: str,
        group_id: Optional[str] = None,
        group_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword group_id:
        :paramtype group_id: str
        :keyword group_name:
        :paramtype group_name: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name
        self.group_id = group_id
        self.group_name = group_name


class CustomerDtoPagedResult(_serialization.Model):
    """CustomerDtoPagedResult.

    All required parameters must be populated in order to send to Azure.

    :ivar results: Required.
    :vartype results: list[~ignos.api.client.models.CustomerDto]
    :ivar continuation_token:
    :vartype continuation_token: str
    """

    _validation = {
        "results": {"required": True},
    }

    _attribute_map = {
        "results": {"key": "results", "type": "[CustomerDto]"},
        "continuation_token": {"key": "continuationToken", "type": "str"},
    }

    def __init__(self, *, results: List["_models.CustomerDto"], continuation_token: Optional[str] = None, **kwargs):
        """
        :keyword results: Required.
        :paramtype results: list[~ignos.api.client.models.CustomerDto]
        :keyword continuation_token:
        :paramtype continuation_token: str
        """
        super().__init__(**kwargs)
        self.results = results
        self.continuation_token = continuation_token


class CustomerOrderConsumptionRequest(_serialization.Model):
    """CustomerOrderConsumptionRequest.

    :ivar customer_order_lines:
    :vartype customer_order_lines: list[int]
    """

    _attribute_map = {
        "customer_order_lines": {"key": "customerOrderLines", "type": "[int]"},
    }

    def __init__(self, *, customer_order_lines: Optional[List[int]] = None, **kwargs):
        """
        :keyword customer_order_lines:
        :paramtype customer_order_lines: list[int]
        """
        super().__init__(**kwargs)
        self.customer_order_lines = customer_order_lines


class CustomerOrderInfoDto(_serialization.Model):
    """CustomerOrderInfoDto.

    :ivar id:
    :vartype id: str
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    """

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.customer_id = customer_id
        self.customer_name = customer_name


class CustomerOrderLineDto(_serialization.Model):
    """CustomerOrderLineDto.

    All required parameters must be populated in order to send to Azure.

    :ivar line: Required.
    :vartype line: int
    :ivar quantity: Required.
    :vartype quantity: float
    :ivar remaining_quantity: Required.
    :vartype remaining_quantity: float
    :ivar delivered_quantity: Required.
    :vartype delivered_quantity: float
    :ivar unit: Required.
    :vartype unit: str
    :ivar status: Required. Known values are: "Draft", "Ready", "Ongoing", "Completed", and
     "Deleted".
    :vartype status: str or ~ignos.api.client.models.CustomerOrderLineStatus
    :ivar part: Required.
    :vartype part: ~ignos.api.client.models.PartDto
    :ivar delivery_date:
    :vartype delivery_date: ~datetime.datetime
    :ivar workorder_hiearchy: Required.
    :vartype workorder_hiearchy: list[~ignos.api.client.models.WorkorderHierarchyDto]
    """

    _validation = {
        "line": {"required": True},
        "quantity": {"required": True},
        "remaining_quantity": {"required": True},
        "delivered_quantity": {"required": True},
        "unit": {"required": True, "min_length": 1},
        "status": {"required": True},
        "part": {"required": True},
        "workorder_hiearchy": {"required": True},
    }

    _attribute_map = {
        "line": {"key": "line", "type": "int"},
        "quantity": {"key": "quantity", "type": "float"},
        "remaining_quantity": {"key": "remainingQuantity", "type": "float"},
        "delivered_quantity": {"key": "deliveredQuantity", "type": "float"},
        "unit": {"key": "unit", "type": "str"},
        "status": {"key": "status", "type": "str"},
        "part": {"key": "part", "type": "PartDto"},
        "delivery_date": {"key": "deliveryDate", "type": "iso-8601"},
        "workorder_hiearchy": {"key": "workorderHiearchy", "type": "[WorkorderHierarchyDto]"},
    }

    def __init__(
        self,
        *,
        line: int,
        quantity: float,
        remaining_quantity: float,
        delivered_quantity: float,
        unit: str,
        status: Union[str, "_models.CustomerOrderLineStatus"],
        part: "_models.PartDto",
        workorder_hiearchy: List["_models.WorkorderHierarchyDto"],
        delivery_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword line: Required.
        :paramtype line: int
        :keyword quantity: Required.
        :paramtype quantity: float
        :keyword remaining_quantity: Required.
        :paramtype remaining_quantity: float
        :keyword delivered_quantity: Required.
        :paramtype delivered_quantity: float
        :keyword unit: Required.
        :paramtype unit: str
        :keyword status: Required. Known values are: "Draft", "Ready", "Ongoing", "Completed", and
         "Deleted".
        :paramtype status: str or ~ignos.api.client.models.CustomerOrderLineStatus
        :keyword part: Required.
        :paramtype part: ~ignos.api.client.models.PartDto
        :keyword delivery_date:
        :paramtype delivery_date: ~datetime.datetime
        :keyword workorder_hiearchy: Required.
        :paramtype workorder_hiearchy: list[~ignos.api.client.models.WorkorderHierarchyDto]
        """
        super().__init__(**kwargs)
        self.line = line
        self.quantity = quantity
        self.remaining_quantity = remaining_quantity
        self.delivered_quantity = delivered_quantity
        self.unit = unit
        self.status = status
        self.part = part
        self.delivery_date = delivery_date
        self.workorder_hiearchy = workorder_hiearchy


class DeprecateToolRequest(_serialization.Model):
    """DeprecateToolRequest.

    :ivar date:
    :vartype date: ~datetime.datetime
    """

    _attribute_map = {
        "date": {"key": "date", "type": "iso-8601"},
    }

    def __init__(self, *, date: Optional[datetime.datetime] = None, **kwargs):
        """
        :keyword date:
        :paramtype date: ~datetime.datetime
        """
        super().__init__(**kwargs)
        self.date = date


class DownloadDto(_serialization.Model):
    """DownloadDto.

    All required parameters must be populated in order to send to Azure.

    :ivar url: Required.
    :vartype url: str
    :ivar expires: Required.
    :vartype expires: ~datetime.datetime
    """

    _validation = {
        "url": {"required": True, "min_length": 1},
        "expires": {"required": True},
    }

    _attribute_map = {
        "url": {"key": "url", "type": "str"},
        "expires": {"key": "expires", "type": "iso-8601"},
    }

    def __init__(self, *, url: str, expires: datetime.datetime, **kwargs):
        """
        :keyword url: Required.
        :paramtype url: str
        :keyword expires: Required.
        :paramtype expires: ~datetime.datetime
        """
        super().__init__(**kwargs)
        self.url = url
        self.expires = expires


class ElectricalIotConfigDto(_serialization.Model):
    """ElectricalIotConfigDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar type_id: Required.
    :vartype type_id: str
    :ivar serial_number:
    :vartype serial_number: str
    :ivar asset_id: Required.
    :vartype asset_id: int
    :ivar asset_external_id:
    :vartype asset_external_id: str
    :ivar phases:
    :vartype phases: int
    :ivar electrical_asset_id:
    :vartype electrical_asset_id: int
    :ivar electrical_asset_external_id:
    :vartype electrical_asset_external_id: str
    :ivar electrical_timeseries_id:
    :vartype electrical_timeseries_id: int
    :ivar electrical_timeseries_external_id:
    :vartype electrical_timeseries_external_id: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "type_id": {"required": True, "min_length": 1},
        "asset_id": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "type_id": {"key": "typeId", "type": "str"},
        "serial_number": {"key": "serialNumber", "type": "str"},
        "asset_id": {"key": "assetId", "type": "int"},
        "asset_external_id": {"key": "assetExternalId", "type": "str"},
        "phases": {"key": "phases", "type": "int"},
        "electrical_asset_id": {"key": "electricalAssetId", "type": "int"},
        "electrical_asset_external_id": {"key": "electricalAssetExternalId", "type": "str"},
        "electrical_timeseries_id": {"key": "electricalTimeseriesId", "type": "int"},
        "electrical_timeseries_external_id": {"key": "electricalTimeseriesExternalId", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        type_id: str,
        asset_id: int,
        serial_number: Optional[str] = None,
        asset_external_id: Optional[str] = None,
        phases: Optional[int] = None,
        electrical_asset_id: Optional[int] = None,
        electrical_asset_external_id: Optional[str] = None,
        electrical_timeseries_id: Optional[int] = None,
        electrical_timeseries_external_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword type_id: Required.
        :paramtype type_id: str
        :keyword serial_number:
        :paramtype serial_number: str
        :keyword asset_id: Required.
        :paramtype asset_id: int
        :keyword asset_external_id:
        :paramtype asset_external_id: str
        :keyword phases:
        :paramtype phases: int
        :keyword electrical_asset_id:
        :paramtype electrical_asset_id: int
        :keyword electrical_asset_external_id:
        :paramtype electrical_asset_external_id: str
        :keyword electrical_timeseries_id:
        :paramtype electrical_timeseries_id: int
        :keyword electrical_timeseries_external_id:
        :paramtype electrical_timeseries_external_id: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.type_id = type_id
        self.serial_number = serial_number
        self.asset_id = asset_id
        self.asset_external_id = asset_external_id
        self.phases = phases
        self.electrical_asset_id = electrical_asset_id
        self.electrical_asset_external_id = electrical_asset_external_id
        self.electrical_timeseries_id = electrical_timeseries_id
        self.electrical_timeseries_external_id = electrical_timeseries_external_id


class EmployeeDto(_serialization.Model):
    """EmployeeDto.

    :ivar id:
    :vartype id: str
    :ivar name:
    :vartype name: str
    """

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
    }

    def __init__(
        self, *, id: Optional[str] = None, name: Optional[str] = None, **kwargs  # pylint: disable=redefined-builtin
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword name:
        :paramtype name: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name


class ExportDimensionReportRequest(_serialization.Model):
    """ExportDimensionReportRequest.

    :ivar tenant_id:
    :vartype tenant_id: str
    :ivar supplier_edition:
    :vartype supplier_edition: bool
    :ivar sequences:
    :vartype sequences: list[str]
    """

    _attribute_map = {
        "tenant_id": {"key": "tenantId", "type": "str"},
        "supplier_edition": {"key": "supplierEdition", "type": "bool"},
        "sequences": {"key": "sequences", "type": "[str]"},
    }

    def __init__(
        self,
        *,
        tenant_id: Optional[str] = None,
        supplier_edition: Optional[bool] = None,
        sequences: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword tenant_id:
        :paramtype tenant_id: str
        :keyword supplier_edition:
        :paramtype supplier_edition: bool
        :keyword sequences:
        :paramtype sequences: list[str]
        """
        super().__init__(**kwargs)
        self.tenant_id = tenant_id
        self.supplier_edition = supplier_edition
        self.sequences = sequences


class ExternalRoleDto(_serialization.Model):
    """ExternalRoleDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name: Required.
    :vartype name: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
    }

    def __init__(self, *, id: str, name: str, **kwargs):  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name: Required.
        :paramtype name: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name


class ExternalSupplierDto(_serialization.Model):
    """ExternalSupplierDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name: Required.
    :vartype name: str
    :ivar company_id: Required.
    :vartype company_id: str
    :ivar active: Required.
    :vartype active: bool
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "company_id": {"required": True, "min_length": 1},
        "active": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "company_id": {"key": "companyId", "type": "str"},
        "active": {"key": "active", "type": "bool"},
    }

    def __init__(
        self, *, id: str, name: str, company_id: str, active: bool, **kwargs  # pylint: disable=redefined-builtin
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword company_id: Required.
        :paramtype company_id: str
        :keyword active: Required.
        :paramtype active: bool
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name
        self.company_id = company_id
        self.active = active


class FilterWorkorderOperationEvents(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """FilterWorkorderOperationEvents.

    :ivar workorder:
    :vartype workorder: str
    :ivar operation:
    :vartype operation: int
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar resource_id:
    :vartype resource_id: str
    :ivar external_id_prefix:
    :vartype external_id_prefix: str
    :ivar operator_employee_id:
    :vartype operator_employee_id: str
    :ivar operator_name:
    :vartype operator_name: str
    :ivar customer_order:
    :vartype customer_order: str
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer:
    :vartype customer: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_name:
    :vartype part_name: str
    :ivar material_part_number:
    :vartype material_part_number: str
    :ivar material_part_name:
    :vartype material_part_name: str
    :ivar material_item_group:
    :vartype material_item_group: str
    :ivar workorder_quantity:
    :vartype workorder_quantity: float
    :ivar is_setup:
    :vartype is_setup: bool
    """

    _attribute_map = {
        "workorder": {"key": "workorder", "type": "str"},
        "operation": {"key": "operation", "type": "int"},
        "start_time": {"key": "startTime", "type": "iso-8601"},
        "end_time": {"key": "endTime", "type": "iso-8601"},
        "resource_id": {"key": "resourceId", "type": "str"},
        "external_id_prefix": {"key": "externalIdPrefix", "type": "str"},
        "operator_employee_id": {"key": "operatorEmployeeId", "type": "str"},
        "operator_name": {"key": "operatorName", "type": "str"},
        "customer_order": {"key": "customerOrder", "type": "str"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer": {"key": "customer", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_name": {"key": "partName", "type": "str"},
        "material_part_number": {"key": "materialPartNumber", "type": "str"},
        "material_part_name": {"key": "materialPartName", "type": "str"},
        "material_item_group": {"key": "materialItemGroup", "type": "str"},
        "workorder_quantity": {"key": "workorderQuantity", "type": "float"},
        "is_setup": {"key": "isSetup", "type": "bool"},
    }

    def __init__(
        self,
        *,
        workorder: Optional[str] = None,
        operation: Optional[int] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        resource_id: Optional[str] = None,
        external_id_prefix: Optional[str] = None,
        operator_employee_id: Optional[str] = None,
        operator_name: Optional[str] = None,
        customer_order: Optional[str] = None,
        customer_id: Optional[str] = None,
        customer: Optional[str] = None,
        part_number: Optional[str] = None,
        part_name: Optional[str] = None,
        material_part_number: Optional[str] = None,
        material_part_name: Optional[str] = None,
        material_item_group: Optional[str] = None,
        workorder_quantity: Optional[float] = None,
        is_setup: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword workorder:
        :paramtype workorder: str
        :keyword operation:
        :paramtype operation: int
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        :keyword resource_id:
        :paramtype resource_id: str
        :keyword external_id_prefix:
        :paramtype external_id_prefix: str
        :keyword operator_employee_id:
        :paramtype operator_employee_id: str
        :keyword operator_name:
        :paramtype operator_name: str
        :keyword customer_order:
        :paramtype customer_order: str
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer:
        :paramtype customer: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_name:
        :paramtype part_name: str
        :keyword material_part_number:
        :paramtype material_part_number: str
        :keyword material_part_name:
        :paramtype material_part_name: str
        :keyword material_item_group:
        :paramtype material_item_group: str
        :keyword workorder_quantity:
        :paramtype workorder_quantity: float
        :keyword is_setup:
        :paramtype is_setup: bool
        """
        super().__init__(**kwargs)
        self.workorder = workorder
        self.operation = operation
        self.start_time = start_time
        self.end_time = end_time
        self.resource_id = resource_id
        self.external_id_prefix = external_id_prefix
        self.operator_employee_id = operator_employee_id
        self.operator_name = operator_name
        self.customer_order = customer_order
        self.customer_id = customer_id
        self.customer = customer
        self.part_number = part_number
        self.part_name = part_name
        self.material_part_number = material_part_number
        self.material_part_name = material_part_name
        self.material_item_group = material_item_group
        self.workorder_quantity = workorder_quantity
        self.is_setup = is_setup


class GetConsumption(_serialization.Model):
    """GetConsumption.

    :ivar asset_id:
    :vartype asset_id: int
    :ivar start:
    :vartype start: ~datetime.datetime
    :ivar end:
    :vartype end: ~datetime.datetime
    """

    _attribute_map = {
        "asset_id": {"key": "assetId", "type": "int"},
        "start": {"key": "start", "type": "iso-8601"},
        "end": {"key": "end", "type": "iso-8601"},
    }

    def __init__(
        self,
        *,
        asset_id: Optional[int] = None,
        start: Optional[datetime.datetime] = None,
        end: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword asset_id:
        :paramtype asset_id: int
        :keyword start:
        :paramtype start: ~datetime.datetime
        :keyword end:
        :paramtype end: ~datetime.datetime
        """
        super().__init__(**kwargs)
        self.asset_id = asset_id
        self.start = start
        self.end = end


class GetConsumptionAutoGranularity(_serialization.Model):
    """GetConsumptionAutoGranularity.

    :ivar asset_id:
    :vartype asset_id: int
    :ivar start:
    :vartype start: ~datetime.datetime
    :ivar end:
    :vartype end: ~datetime.datetime
    """

    _attribute_map = {
        "asset_id": {"key": "assetId", "type": "int"},
        "start": {"key": "start", "type": "iso-8601"},
        "end": {"key": "end", "type": "iso-8601"},
    }

    def __init__(
        self,
        *,
        asset_id: Optional[int] = None,
        start: Optional[datetime.datetime] = None,
        end: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword asset_id:
        :paramtype asset_id: int
        :keyword start:
        :paramtype start: ~datetime.datetime
        :keyword end:
        :paramtype end: ~datetime.datetime
        """
        super().__init__(**kwargs)
        self.asset_id = asset_id
        self.start = start
        self.end = end


class GetPower(_serialization.Model):
    """GetPower.

    All required parameters must be populated in order to send to Azure.

    :ivar asset_id: Required.
    :vartype asset_id: int
    :ivar granularity:
    :vartype granularity: str
    :ivar start:
    :vartype start: ~datetime.datetime
    :ivar end:
    :vartype end: ~datetime.datetime
    """

    _validation = {
        "asset_id": {"required": True},
    }

    _attribute_map = {
        "asset_id": {"key": "assetId", "type": "int"},
        "granularity": {"key": "granularity", "type": "str"},
        "start": {"key": "start", "type": "iso-8601"},
        "end": {"key": "end", "type": "iso-8601"},
    }

    def __init__(
        self,
        *,
        asset_id: int,
        granularity: Optional[str] = None,
        start: Optional[datetime.datetime] = None,
        end: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword asset_id: Required.
        :paramtype asset_id: int
        :keyword granularity:
        :paramtype granularity: str
        :keyword start:
        :paramtype start: ~datetime.datetime
        :keyword end:
        :paramtype end: ~datetime.datetime
        """
        super().__init__(**kwargs)
        self.asset_id = asset_id
        self.granularity = granularity
        self.start = start
        self.end = end


class GranluarConsumptionDto(_serialization.Model):
    """GranluarConsumptionDto.

    :ivar asset_id:
    :vartype asset_id: int
    :ivar asset_name:
    :vartype asset_name: str
    :ivar granularity:
    :vartype granularity: str
    :ivar consumption:
    :vartype consumption: list[~ignos.api.client.models.SubConsumptionDto]
    """

    _attribute_map = {
        "asset_id": {"key": "assetId", "type": "int"},
        "asset_name": {"key": "assetName", "type": "str"},
        "granularity": {"key": "granularity", "type": "str"},
        "consumption": {"key": "consumption", "type": "[SubConsumptionDto]"},
    }

    def __init__(
        self,
        *,
        asset_id: Optional[int] = None,
        asset_name: Optional[str] = None,
        granularity: Optional[str] = None,
        consumption: Optional[List["_models.SubConsumptionDto"]] = None,
        **kwargs
    ):
        """
        :keyword asset_id:
        :paramtype asset_id: int
        :keyword asset_name:
        :paramtype asset_name: str
        :keyword granularity:
        :paramtype granularity: str
        :keyword consumption:
        :paramtype consumption: list[~ignos.api.client.models.SubConsumptionDto]
        """
        super().__init__(**kwargs)
        self.asset_id = asset_id
        self.asset_name = asset_name
        self.granularity = granularity
        self.consumption = consumption


class ImportMeasurementFormInstanceRequest(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """ImportMeasurementFormInstanceRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar part_info: Required.
    :vartype part_info: ~ignos.api.client.models.ImportMeasurementFormPartDto
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_group_id:
    :vartype customer_group_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar external_order_number:
    :vartype external_order_number: str
    :ivar quantity: Required.
    :vartype quantity: int
    :ivar sequences: Required.
    :vartype sequences: list[~ignos.api.client.models.WorkorderImportTraceItemDto]
    :ivar validation_rule_id:
    :vartype validation_rule_id: str
    :ivar status: Required. Known values are: "Active", "Cancelled", "Completed", and "Approved".
    :vartype status: str or ~ignos.api.client.models.MeasurementFormInstanceStatus
    :ivar status_changed_by:
    :vartype status_changed_by: str
    :ivar status_changed_date:
    :vartype status_changed_date: ~datetime.datetime
    :ivar created: Required.
    :vartype created: ~datetime.datetime
    :ivar created_by:
    :vartype created_by: str
    :ivar updated_by:
    :vartype updated_by: str
    :ivar schemas: Required.
    :vartype schemas: list[~ignos.api.client.models.ImportMeasurementSchemaInstanceDto]
    """

    _validation = {
        "part_info": {"required": True},
        "quantity": {"required": True},
        "sequences": {"required": True},
        "status": {"required": True},
        "created": {"required": True},
        "schemas": {"required": True},
    }

    _attribute_map = {
        "part_info": {"key": "partInfo", "type": "ImportMeasurementFormPartDto"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_group_id": {"key": "customerGroupId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "external_order_number": {"key": "externalOrderNumber", "type": "str"},
        "quantity": {"key": "quantity", "type": "int"},
        "sequences": {"key": "sequences", "type": "[WorkorderImportTraceItemDto]"},
        "validation_rule_id": {"key": "validationRuleId", "type": "str"},
        "status": {"key": "status", "type": "str"},
        "status_changed_by": {"key": "statusChangedBy", "type": "str"},
        "status_changed_date": {"key": "statusChangedDate", "type": "iso-8601"},
        "created": {"key": "created", "type": "iso-8601"},
        "created_by": {"key": "createdBy", "type": "str"},
        "updated_by": {"key": "updatedBy", "type": "str"},
        "schemas": {"key": "schemas", "type": "[ImportMeasurementSchemaInstanceDto]"},
    }

    def __init__(
        self,
        *,
        part_info: "_models.ImportMeasurementFormPartDto",
        quantity: int,
        sequences: List["_models.WorkorderImportTraceItemDto"],
        status: Union[str, "_models.MeasurementFormInstanceStatus"],
        created: datetime.datetime,
        schemas: List["_models.ImportMeasurementSchemaInstanceDto"],
        customer_id: Optional[str] = None,
        customer_group_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        external_order_number: Optional[str] = None,
        validation_rule_id: Optional[str] = None,
        status_changed_by: Optional[str] = None,
        status_changed_date: Optional[datetime.datetime] = None,
        created_by: Optional[str] = None,
        updated_by: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword part_info: Required.
        :paramtype part_info: ~ignos.api.client.models.ImportMeasurementFormPartDto
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_group_id:
        :paramtype customer_group_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword external_order_number:
        :paramtype external_order_number: str
        :keyword quantity: Required.
        :paramtype quantity: int
        :keyword sequences: Required.
        :paramtype sequences: list[~ignos.api.client.models.WorkorderImportTraceItemDto]
        :keyword validation_rule_id:
        :paramtype validation_rule_id: str
        :keyword status: Required. Known values are: "Active", "Cancelled", "Completed", and
         "Approved".
        :paramtype status: str or ~ignos.api.client.models.MeasurementFormInstanceStatus
        :keyword status_changed_by:
        :paramtype status_changed_by: str
        :keyword status_changed_date:
        :paramtype status_changed_date: ~datetime.datetime
        :keyword created: Required.
        :paramtype created: ~datetime.datetime
        :keyword created_by:
        :paramtype created_by: str
        :keyword updated_by:
        :paramtype updated_by: str
        :keyword schemas: Required.
        :paramtype schemas: list[~ignos.api.client.models.ImportMeasurementSchemaInstanceDto]
        """
        super().__init__(**kwargs)
        self.part_info = part_info
        self.customer_id = customer_id
        self.customer_group_id = customer_group_id
        self.customer_name = customer_name
        self.external_order_number = external_order_number
        self.quantity = quantity
        self.sequences = sequences
        self.validation_rule_id = validation_rule_id
        self.status = status
        self.status_changed_by = status_changed_by
        self.status_changed_date = status_changed_date
        self.created = created
        self.created_by = created_by
        self.updated_by = updated_by
        self.schemas = schemas


class ImportMeasurementFormInstanceSchemaToolDto(_serialization.Model):
    """ImportMeasurementFormInstanceSchemaToolDto.

    :ivar tool:
    :vartype tool: str
    :ivar tool_type:
    :vartype tool_type: str
    """

    _attribute_map = {
        "tool": {"key": "tool", "type": "str"},
        "tool_type": {"key": "toolType", "type": "str"},
    }

    def __init__(self, *, tool: Optional[str] = None, tool_type: Optional[str] = None, **kwargs):
        """
        :keyword tool:
        :paramtype tool: str
        :keyword tool_type:
        :paramtype tool_type: str
        """
        super().__init__(**kwargs)
        self.tool = tool
        self.tool_type = tool_type


class ImportMeasurementFormInstanceSchemaValueDto(_serialization.Model):
    """ImportMeasurementFormInstanceSchemaValueDto.

    All required parameters must be populated in order to send to Azure.

    :ivar element_id: Required.
    :vartype element_id: str
    :ivar sequence: Required.
    :vartype sequence: str
    :ivar operation:
    :vartype operation: int
    :ivar value:
    :vartype value: str
    :ivar bonus:
    :vartype bonus: float
    :ivar tools:
    :vartype tools: list[~ignos.api.client.models.ImportMeasurementFormInstanceSchemaToolDto]
    :ivar created: Required.
    :vartype created: ~datetime.datetime
    :ivar created_by: Required.
    :vartype created_by: str
    """

    _validation = {
        "element_id": {"required": True, "min_length": 1},
        "sequence": {"required": True, "min_length": 1},
        "created": {"required": True},
        "created_by": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "element_id": {"key": "elementId", "type": "str"},
        "sequence": {"key": "sequence", "type": "str"},
        "operation": {"key": "operation", "type": "int"},
        "value": {"key": "value", "type": "str"},
        "bonus": {"key": "bonus", "type": "float"},
        "tools": {"key": "tools", "type": "[ImportMeasurementFormInstanceSchemaToolDto]"},
        "created": {"key": "created", "type": "iso-8601"},
        "created_by": {"key": "createdBy", "type": "str"},
    }

    def __init__(
        self,
        *,
        element_id: str,
        sequence: str,
        created: datetime.datetime,
        created_by: str,
        operation: Optional[int] = None,
        value: Optional[str] = None,
        bonus: Optional[float] = None,
        tools: Optional[List["_models.ImportMeasurementFormInstanceSchemaToolDto"]] = None,
        **kwargs
    ):
        """
        :keyword element_id: Required.
        :paramtype element_id: str
        :keyword sequence: Required.
        :paramtype sequence: str
        :keyword operation:
        :paramtype operation: int
        :keyword value:
        :paramtype value: str
        :keyword bonus:
        :paramtype bonus: float
        :keyword tools:
        :paramtype tools: list[~ignos.api.client.models.ImportMeasurementFormInstanceSchemaToolDto]
        :keyword created: Required.
        :paramtype created: ~datetime.datetime
        :keyword created_by: Required.
        :paramtype created_by: str
        """
        super().__init__(**kwargs)
        self.element_id = element_id
        self.sequence = sequence
        self.operation = operation
        self.value = value
        self.bonus = bonus
        self.tools = tools
        self.created = created
        self.created_by = created_by


class ImportMeasurementFormInstanceSchemaValuesDto(_serialization.Model):
    """ImportMeasurementFormInstanceSchemaValuesDto.

    All required parameters must be populated in order to send to Azure.

    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar values:
    :vartype values: list[~ignos.api.client.models.ImportMeasurementFormInstanceSchemaValueDto]
    """

    _validation = {
        "schema_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "schema_id": {"key": "schemaId", "type": "str"},
        "values": {"key": "values", "type": "[ImportMeasurementFormInstanceSchemaValueDto]"},
    }

    def __init__(
        self,
        *,
        schema_id: str,
        values: Optional[List["_models.ImportMeasurementFormInstanceSchemaValueDto"]] = None,
        **kwargs
    ):
        """
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword values:
        :paramtype values: list[~ignos.api.client.models.ImportMeasurementFormInstanceSchemaValueDto]
        """
        super().__init__(**kwargs)
        self.schema_id = schema_id
        self.values = values


class ImportMeasurementFormInstanceValueRequest(_serialization.Model):
    """ImportMeasurementFormInstanceValueRequest.

    :ivar schema_values:
    :vartype schema_values:
     list[~ignos.api.client.models.ImportMeasurementFormInstanceSchemaValuesDto]
    """

    _attribute_map = {
        "schema_values": {"key": "schemaValues", "type": "[ImportMeasurementFormInstanceSchemaValuesDto]"},
    }

    def __init__(
        self, *, schema_values: Optional[List["_models.ImportMeasurementFormInstanceSchemaValuesDto"]] = None, **kwargs
    ):
        """
        :keyword schema_values:
        :paramtype schema_values:
         list[~ignos.api.client.models.ImportMeasurementFormInstanceSchemaValuesDto]
        """
        super().__init__(**kwargs)
        self.schema_values = schema_values


class ImportMeasurementFormPartDto(_serialization.Model):
    """ImportMeasurementFormPartDto.

    All required parameters must be populated in order to send to Azure.

    :ivar part_number:
    :vartype part_number: str
    :ivar part_name:
    :vartype part_name: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing: Required.
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    """

    _validation = {
        "drawing": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "part_number": {"key": "partNumber", "type": "str"},
        "part_name": {"key": "partName", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
    }

    def __init__(
        self,
        *,
        drawing: str,
        part_number: Optional[str] = None,
        part_name: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_name:
        :paramtype part_name: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing: Required.
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        """
        super().__init__(**kwargs)
        self.part_number = part_number
        self.part_name = part_name
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision


class ImportMeasurementFormSchema(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """ImportMeasurementFormSchema.

    All required parameters must be populated in order to send to Azure.

    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar part_number: Required.
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar created:
    :vartype created: ~datetime.datetime
    :ivar created_by:
    :vartype created_by: str
    :ivar updated_by:
    :vartype updated_by: str
    :ivar exclude_from_customer_documentation: Required.
    :vartype exclude_from_customer_documentation: bool
    :ivar source: Required. Known values are: "Unknown", "InspectionXpert", "Excel", and "Manual".
    :vartype source: str or ~ignos.api.client.models.MeasurementFormSource
    :ivar extra_schemas:
    :vartype extra_schemas: list[~ignos.api.client.models.MeasurementFormImportLinkedSchemaDto]
    :ivar versions: Required.
    :vartype versions: list[~ignos.api.client.models.MeasurementFormVersionImportDto]
    :ivar validation_rule_id:
    :vartype validation_rule_id: str
    """

    _validation = {
        "part_number": {"required": True, "min_length": 1},
        "exclude_from_customer_documentation": {"required": True},
        "source": {"required": True},
        "versions": {"required": True},
    }

    _attribute_map = {
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "created": {"key": "created", "type": "iso-8601"},
        "created_by": {"key": "createdBy", "type": "str"},
        "updated_by": {"key": "updatedBy", "type": "str"},
        "exclude_from_customer_documentation": {"key": "excludeFromCustomerDocumentation", "type": "bool"},
        "source": {"key": "source", "type": "str"},
        "extra_schemas": {"key": "extraSchemas", "type": "[MeasurementFormImportLinkedSchemaDto]"},
        "versions": {"key": "versions", "type": "[MeasurementFormVersionImportDto]"},
        "validation_rule_id": {"key": "validationRuleId", "type": "str"},
    }

    def __init__(
        self,
        *,
        part_number: str,
        exclude_from_customer_documentation: bool,
        source: Union[str, "_models.MeasurementFormSource"],
        versions: List["_models.MeasurementFormVersionImportDto"],
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        created: Optional[datetime.datetime] = None,
        created_by: Optional[str] = None,
        updated_by: Optional[str] = None,
        extra_schemas: Optional[List["_models.MeasurementFormImportLinkedSchemaDto"]] = None,
        validation_rule_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword part_number: Required.
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword created:
        :paramtype created: ~datetime.datetime
        :keyword created_by:
        :paramtype created_by: str
        :keyword updated_by:
        :paramtype updated_by: str
        :keyword exclude_from_customer_documentation: Required.
        :paramtype exclude_from_customer_documentation: bool
        :keyword source: Required. Known values are: "Unknown", "InspectionXpert", "Excel", and
         "Manual".
        :paramtype source: str or ~ignos.api.client.models.MeasurementFormSource
        :keyword extra_schemas:
        :paramtype extra_schemas: list[~ignos.api.client.models.MeasurementFormImportLinkedSchemaDto]
        :keyword versions: Required.
        :paramtype versions: list[~ignos.api.client.models.MeasurementFormVersionImportDto]
        :keyword validation_rule_id:
        :paramtype validation_rule_id: str
        """
        super().__init__(**kwargs)
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.created = created
        self.created_by = created_by
        self.updated_by = updated_by
        self.exclude_from_customer_documentation = exclude_from_customer_documentation
        self.source = source
        self.extra_schemas = extra_schemas
        self.versions = versions
        self.validation_rule_id = validation_rule_id


class ImportMeasurementSchemaInstanceDto(_serialization.Model):
    """ImportMeasurementSchemaInstanceDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar version: Required.
    :vartype version: int
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "version": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "version": {"key": "version", "type": "int"},
    }

    def __init__(self, *, id: str, version: int, **kwargs):  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword version: Required.
        :paramtype version: int
        """
        super().__init__(**kwargs)
        self.id = id
        self.version = version


class ImportMeasuringTool(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """ImportMeasuringTool.

    All required parameters must be populated in order to send to Azure.

    :ivar tool_id: Required.
    :vartype tool_id: str
    :ivar name: Required.
    :vartype name: str
    :ivar manufacturer: Required.
    :vartype manufacturer: str
    :ivar type_id: Required.
    :vartype type_id: str
    :ivar sub_type_id:
    :vartype sub_type_id: str
    :ivar unit_id:
    :vartype unit_id: str
    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar non_calibration_tool: Required.
    :vartype non_calibration_tool: bool
    :ivar min:
    :vartype min: float
    :ivar max:
    :vartype max: float
    :ivar serial_number:
    :vartype serial_number: str
    :ivar default_location:
    :vartype default_location: str
    :ivar precision:
    :vartype precision: str
    :ivar last_calibration_date:
    :vartype last_calibration_date: ~datetime.datetime
    :ivar deprecated_date:
    :vartype deprecated_date: ~datetime.datetime
    :ivar last_location:
    :vartype last_location: str
    :ivar last_location_date:
    :vartype last_location_date: ~datetime.datetime
    :ivar calibrations: Required.
    :vartype calibrations: list[~ignos.api.client.models.MeasuringToolCalibrationImportDto]
    :ivar created: Required.
    :vartype created: ~datetime.datetime
    :ivar created_by: Required.
    :vartype created_by: str
    :ivar updated:
    :vartype updated: ~datetime.datetime
    :ivar updated_by:
    :vartype updated_by: str
    """

    _validation = {
        "tool_id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "manufacturer": {"required": True, "min_length": 1},
        "type_id": {"required": True},
        "non_calibration_tool": {"required": True},
        "calibrations": {"required": True},
        "created": {"required": True},
        "created_by": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "tool_id": {"key": "toolId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "manufacturer": {"key": "manufacturer", "type": "str"},
        "type_id": {"key": "typeId", "type": "str"},
        "sub_type_id": {"key": "subTypeId", "type": "str"},
        "unit_id": {"key": "unitId", "type": "str"},
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "non_calibration_tool": {"key": "nonCalibrationTool", "type": "bool"},
        "min": {"key": "min", "type": "float"},
        "max": {"key": "max", "type": "float"},
        "serial_number": {"key": "serialNumber", "type": "str"},
        "default_location": {"key": "defaultLocation", "type": "str"},
        "precision": {"key": "precision", "type": "str"},
        "last_calibration_date": {"key": "lastCalibrationDate", "type": "iso-8601"},
        "deprecated_date": {"key": "deprecatedDate", "type": "iso-8601"},
        "last_location": {"key": "lastLocation", "type": "str"},
        "last_location_date": {"key": "lastLocationDate", "type": "iso-8601"},
        "calibrations": {"key": "calibrations", "type": "[MeasuringToolCalibrationImportDto]"},
        "created": {"key": "created", "type": "iso-8601"},
        "created_by": {"key": "createdBy", "type": "str"},
        "updated": {"key": "updated", "type": "iso-8601"},
        "updated_by": {"key": "updatedBy", "type": "str"},
    }

    def __init__(
        self,
        *,
        tool_id: str,
        name: str,
        manufacturer: str,
        type_id: str,
        non_calibration_tool: bool,
        calibrations: List["_models.MeasuringToolCalibrationImportDto"],
        created: datetime.datetime,
        created_by: str,
        sub_type_id: Optional[str] = None,
        unit_id: Optional[str] = None,
        calibration_interval: Optional[int] = None,
        min: Optional[float] = None,  # pylint: disable=redefined-builtin
        max: Optional[float] = None,  # pylint: disable=redefined-builtin
        serial_number: Optional[str] = None,
        default_location: Optional[str] = None,
        precision: Optional[str] = None,
        last_calibration_date: Optional[datetime.datetime] = None,
        deprecated_date: Optional[datetime.datetime] = None,
        last_location: Optional[str] = None,
        last_location_date: Optional[datetime.datetime] = None,
        updated: Optional[datetime.datetime] = None,
        updated_by: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword tool_id: Required.
        :paramtype tool_id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword manufacturer: Required.
        :paramtype manufacturer: str
        :keyword type_id: Required.
        :paramtype type_id: str
        :keyword sub_type_id:
        :paramtype sub_type_id: str
        :keyword unit_id:
        :paramtype unit_id: str
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword non_calibration_tool: Required.
        :paramtype non_calibration_tool: bool
        :keyword min:
        :paramtype min: float
        :keyword max:
        :paramtype max: float
        :keyword serial_number:
        :paramtype serial_number: str
        :keyword default_location:
        :paramtype default_location: str
        :keyword precision:
        :paramtype precision: str
        :keyword last_calibration_date:
        :paramtype last_calibration_date: ~datetime.datetime
        :keyword deprecated_date:
        :paramtype deprecated_date: ~datetime.datetime
        :keyword last_location:
        :paramtype last_location: str
        :keyword last_location_date:
        :paramtype last_location_date: ~datetime.datetime
        :keyword calibrations: Required.
        :paramtype calibrations: list[~ignos.api.client.models.MeasuringToolCalibrationImportDto]
        :keyword created: Required.
        :paramtype created: ~datetime.datetime
        :keyword created_by: Required.
        :paramtype created_by: str
        :keyword updated:
        :paramtype updated: ~datetime.datetime
        :keyword updated_by:
        :paramtype updated_by: str
        """
        super().__init__(**kwargs)
        self.tool_id = tool_id
        self.name = name
        self.manufacturer = manufacturer
        self.type_id = type_id
        self.sub_type_id = sub_type_id
        self.unit_id = unit_id
        self.calibration_interval = calibration_interval
        self.non_calibration_tool = non_calibration_tool
        self.min = min
        self.max = max
        self.serial_number = serial_number
        self.default_location = default_location
        self.precision = precision
        self.last_calibration_date = last_calibration_date
        self.deprecated_date = deprecated_date
        self.last_location = last_location
        self.last_location_date = last_location_date
        self.calibrations = calibrations
        self.created = created
        self.created_by = created_by
        self.updated = updated
        self.updated_by = updated_by


class ImportSupplier(_serialization.Model):
    """ImportSupplier.

    All required parameters must be populated in order to send to Azure.

    :ivar supplier_id: Required.
    :vartype supplier_id: str
    :ivar name: Required.
    :vartype name: str
    :ivar organization_number:
    :vartype organization_number: str
    :ivar three_letter_iso_country: Required.
    :vartype three_letter_iso_country: str
    :ivar users: Required.
    :vartype users: list[~ignos.api.client.models.ImportSupplierUserDto]
    """

    _validation = {
        "supplier_id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "three_letter_iso_country": {"required": True, "min_length": 1},
        "users": {"required": True},
    }

    _attribute_map = {
        "supplier_id": {"key": "supplierId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "organization_number": {"key": "organizationNumber", "type": "str"},
        "three_letter_iso_country": {"key": "threeLetterIsoCountry", "type": "str"},
        "users": {"key": "users", "type": "[ImportSupplierUserDto]"},
    }

    def __init__(
        self,
        *,
        supplier_id: str,
        name: str,
        three_letter_iso_country: str,
        users: List["_models.ImportSupplierUserDto"],
        organization_number: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword supplier_id: Required.
        :paramtype supplier_id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword organization_number:
        :paramtype organization_number: str
        :keyword three_letter_iso_country: Required.
        :paramtype three_letter_iso_country: str
        :keyword users: Required.
        :paramtype users: list[~ignos.api.client.models.ImportSupplierUserDto]
        """
        super().__init__(**kwargs)
        self.supplier_id = supplier_id
        self.name = name
        self.organization_number = organization_number
        self.three_letter_iso_country = three_letter_iso_country
        self.users = users


class ImportSupplierUserDto(_serialization.Model):
    """ImportSupplierUserDto.

    All required parameters must be populated in order to send to Azure.

    :ivar username: Required.
    :vartype username: str
    :ivar name: Required.
    :vartype name: str
    :ivar roles: Required.
    :vartype roles: list[str]
    """

    _validation = {
        "username": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "roles": {"required": True},
    }

    _attribute_map = {
        "username": {"key": "username", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "roles": {"key": "roles", "type": "[str]"},
    }

    def __init__(self, *, username: str, name: str, roles: List[str], **kwargs):
        """
        :keyword username: Required.
        :paramtype username: str
        :keyword name: Required.
        :paramtype name: str
        :keyword roles: Required.
        :paramtype roles: list[str]
        """
        super().__init__(**kwargs)
        self.username = username
        self.name = name
        self.roles = roles


class InviteDto(_serialization.Model):
    """InviteDto.

    All required parameters must be populated in order to send to Azure.

    :ivar tenant_id: Required.
    :vartype tenant_id: str
    :ivar company_name: Required.
    :vartype company_name: str
    :ivar id: Required.
    :vartype id: str
    :ivar supplier_id: Required.
    :vartype supplier_id: str
    :ivar supplier_name: Required.
    :vartype supplier_name: str
    :ivar username: Required.
    :vartype username: str
    :ivar deadline: Required.
    :vartype deadline: ~datetime.datetime
    :ivar created_time: Required.
    :vartype created_time: ~datetime.datetime
    :ivar created_by: Required.
    :vartype created_by: str
    """

    _validation = {
        "tenant_id": {"required": True, "min_length": 1},
        "company_name": {"required": True, "min_length": 1},
        "id": {"required": True, "min_length": 1},
        "supplier_id": {"required": True, "min_length": 1},
        "supplier_name": {"required": True, "min_length": 1},
        "username": {"required": True, "min_length": 1},
        "deadline": {"required": True},
        "created_time": {"required": True},
        "created_by": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "tenant_id": {"key": "tenantId", "type": "str"},
        "company_name": {"key": "companyName", "type": "str"},
        "id": {"key": "id", "type": "str"},
        "supplier_id": {"key": "supplierId", "type": "str"},
        "supplier_name": {"key": "supplierName", "type": "str"},
        "username": {"key": "username", "type": "str"},
        "deadline": {"key": "deadline", "type": "iso-8601"},
        "created_time": {"key": "createdTime", "type": "iso-8601"},
        "created_by": {"key": "createdBy", "type": "str"},
    }

    def __init__(
        self,
        *,
        tenant_id: str,
        company_name: str,
        id: str,  # pylint: disable=redefined-builtin
        supplier_id: str,
        supplier_name: str,
        username: str,
        deadline: datetime.datetime,
        created_time: datetime.datetime,
        created_by: str,
        **kwargs
    ):
        """
        :keyword tenant_id: Required.
        :paramtype tenant_id: str
        :keyword company_name: Required.
        :paramtype company_name: str
        :keyword id: Required.
        :paramtype id: str
        :keyword supplier_id: Required.
        :paramtype supplier_id: str
        :keyword supplier_name: Required.
        :paramtype supplier_name: str
        :keyword username: Required.
        :paramtype username: str
        :keyword deadline: Required.
        :paramtype deadline: ~datetime.datetime
        :keyword created_time: Required.
        :paramtype created_time: ~datetime.datetime
        :keyword created_by: Required.
        :paramtype created_by: str
        """
        super().__init__(**kwargs)
        self.tenant_id = tenant_id
        self.company_name = company_name
        self.id = id
        self.supplier_id = supplier_id
        self.supplier_name = supplier_name
        self.username = username
        self.deadline = deadline
        self.created_time = created_time
        self.created_by = created_by


class IotTypeSourceDto(_serialization.Model):
    """IotTypeSourceDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name: Required.
    :vartype name: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
    }

    def __init__(self, *, id: str, name: str, **kwargs):  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name: Required.
        :paramtype name: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name


class LinkDto(_serialization.Model):
    """LinkDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar uri: Required.
    :vartype uri: str
    :ivar name: Required.
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar new_tab:
    :vartype new_tab: bool
    :ivar color:
    :vartype color: str
    :ivar icon_name:
    :vartype icon_name: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "uri": {"required": True},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "uri": {"key": "uri", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "description": {"key": "description", "type": "str"},
        "new_tab": {"key": "newTab", "type": "bool"},
        "color": {"key": "color", "type": "str"},
        "icon_name": {"key": "iconName", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        uri: str,
        name: str,
        description: Optional[str] = None,
        new_tab: Optional[bool] = None,
        color: Optional[str] = None,
        icon_name: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword uri: Required.
        :paramtype uri: str
        :keyword name: Required.
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword new_tab:
        :paramtype new_tab: bool
        :keyword color:
        :paramtype color: str
        :keyword icon_name:
        :paramtype icon_name: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.uri = uri
        self.name = name
        self.description = description
        self.new_tab = new_tab
        self.color = color
        self.icon_name = icon_name


class Machine(_serialization.Model):
    """Machine.

    :ivar external_id:
    :vartype external_id: str
    :ivar id:
    :vartype id: int
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar datapoints:
    :vartype datapoints: list[~ignos.api.client.models.NumericNullableValueWithTimestamp]
    """

    _attribute_map = {
        "external_id": {"key": "externalId", "type": "str"},
        "id": {"key": "id", "type": "int"},
        "name": {"key": "name", "type": "str"},
        "description": {"key": "description", "type": "str"},
        "datapoints": {"key": "datapoints", "type": "[NumericNullableValueWithTimestamp]"},
    }

    def __init__(
        self,
        *,
        external_id: Optional[str] = None,
        id: Optional[int] = None,  # pylint: disable=redefined-builtin
        name: Optional[str] = None,
        description: Optional[str] = None,
        datapoints: Optional[List["_models.NumericNullableValueWithTimestamp"]] = None,
        **kwargs
    ):
        """
        :keyword external_id:
        :paramtype external_id: str
        :keyword id:
        :paramtype id: int
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword datapoints:
        :paramtype datapoints: list[~ignos.api.client.models.NumericNullableValueWithTimestamp]
        """
        super().__init__(**kwargs)
        self.external_id = external_id
        self.id = id
        self.name = name
        self.description = description
        self.datapoints = datapoints


class MachineAlarmDetailsDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MachineAlarmDetailsDto.

    Variables are only populated by the server, and will be ignored when sending a request.

    :ivar id:
    :vartype id: int
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar native_code:
    :vartype native_code: str
    :ivar native_severity:
    :vartype native_severity: int
    :ivar description:
    :vartype description: str
    :ivar name:
    :vartype name: str
    :ivar type:
    :vartype type: str
    :ivar machine_name:
    :vartype machine_name: str
    :ivar asset_external_id:
    :vartype asset_external_id: str
    :ivar timeseries_groups:
    :vartype timeseries_groups: list[~ignos.api.client.models.MachineAlarmTimeseriesGroupDto]
    """

    _validation = {
        "id": {"readonly": True},
        "start_time": {"readonly": True},
        "end_time": {"readonly": True},
        "native_code": {"readonly": True},
        "native_severity": {"readonly": True},
        "description": {"readonly": True},
        "name": {"readonly": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "int"},
        "start_time": {"key": "startTime", "type": "iso-8601"},
        "end_time": {"key": "endTime", "type": "iso-8601"},
        "native_code": {"key": "nativeCode", "type": "str"},
        "native_severity": {"key": "nativeSeverity", "type": "int"},
        "description": {"key": "description", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "type": {"key": "type", "type": "str"},
        "machine_name": {"key": "machineName", "type": "str"},
        "asset_external_id": {"key": "assetExternalId", "type": "str"},
        "timeseries_groups": {"key": "timeseriesGroups", "type": "[MachineAlarmTimeseriesGroupDto]"},
    }

    def __init__(
        self,
        *,
        type: Optional[str] = None,
        machine_name: Optional[str] = None,
        asset_external_id: Optional[str] = None,
        timeseries_groups: Optional[List["_models.MachineAlarmTimeseriesGroupDto"]] = None,
        **kwargs
    ):
        """
        :keyword type:
        :paramtype type: str
        :keyword machine_name:
        :paramtype machine_name: str
        :keyword asset_external_id:
        :paramtype asset_external_id: str
        :keyword timeseries_groups:
        :paramtype timeseries_groups: list[~ignos.api.client.models.MachineAlarmTimeseriesGroupDto]
        """
        super().__init__(**kwargs)
        self.id = None
        self.start_time = None
        self.end_time = None
        self.native_code = None
        self.native_severity = None
        self.description = None
        self.name = None
        self.type = type
        self.machine_name = machine_name
        self.asset_external_id = asset_external_id
        self.timeseries_groups = timeseries_groups


class MachineAlarmDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MachineAlarmDto.

    All required parameters must be populated in order to send to Azure.

    :ivar alarm_type: Required. Known values are: "Fault" and "Warning".
    :vartype alarm_type: str or ~ignos.api.client.models.MachineAlarmType
    :ivar id: Required.
    :vartype id: int
    :ivar type: Required.
    :vartype type: str
    :ivar sub_type: Required.
    :vartype sub_type: str
    :ivar description:
    :vartype description: str
    :ivar native_code: Required.
    :vartype native_code: str
    :ivar native_severity:
    :vartype native_severity: int
    :ivar name:
    :vartype name: str
    :ivar sequence:
    :vartype sequence: str
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    """

    _validation = {
        "alarm_type": {"required": True},
        "id": {"required": True},
        "type": {"required": True, "min_length": 1},
        "sub_type": {"required": True, "min_length": 1},
        "native_code": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "alarm_type": {"key": "alarmType", "type": "str"},
        "id": {"key": "id", "type": "int"},
        "type": {"key": "type", "type": "str"},
        "sub_type": {"key": "subType", "type": "str"},
        "description": {"key": "description", "type": "str"},
        "native_code": {"key": "nativeCode", "type": "str"},
        "native_severity": {"key": "nativeSeverity", "type": "int"},
        "name": {"key": "name", "type": "str"},
        "sequence": {"key": "sequence", "type": "str"},
        "start_time": {"key": "startTime", "type": "iso-8601"},
        "end_time": {"key": "endTime", "type": "iso-8601"},
    }

    def __init__(
        self,
        *,
        alarm_type: Union[str, "_models.MachineAlarmType"],
        id: int,  # pylint: disable=redefined-builtin
        type: str,
        sub_type: str,
        native_code: str,
        description: Optional[str] = None,
        native_severity: Optional[int] = None,
        name: Optional[str] = None,
        sequence: Optional[str] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword alarm_type: Required. Known values are: "Fault" and "Warning".
        :paramtype alarm_type: str or ~ignos.api.client.models.MachineAlarmType
        :keyword id: Required.
        :paramtype id: int
        :keyword type: Required.
        :paramtype type: str
        :keyword sub_type: Required.
        :paramtype sub_type: str
        :keyword description:
        :paramtype description: str
        :keyword native_code: Required.
        :paramtype native_code: str
        :keyword native_severity:
        :paramtype native_severity: int
        :keyword name:
        :paramtype name: str
        :keyword sequence:
        :paramtype sequence: str
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        """
        super().__init__(**kwargs)
        self.alarm_type = alarm_type
        self.id = id
        self.type = type
        self.sub_type = sub_type
        self.description = description
        self.native_code = native_code
        self.native_severity = native_severity
        self.name = name
        self.sequence = sequence
        self.start_time = start_time
        self.end_time = end_time


class MachineAlarmSeverityOccurenceDto(_serialization.Model):
    """MachineAlarmSeverityOccurenceDto.

    All required parameters must be populated in order to send to Azure.

    :ivar native_severity: Required.
    :vartype native_severity: int
    :ivar quantity: Required.
    :vartype quantity: int
    :ivar alarm_type: Required. Known values are: "Fault" and "Warning".
    :vartype alarm_type: str or ~ignos.api.client.models.MachineAlarmType
    """

    _validation = {
        "native_severity": {"required": True},
        "quantity": {"required": True},
        "alarm_type": {"required": True},
    }

    _attribute_map = {
        "native_severity": {"key": "nativeSeverity", "type": "int"},
        "quantity": {"key": "quantity", "type": "int"},
        "alarm_type": {"key": "alarmType", "type": "str"},
    }

    def __init__(
        self, *, native_severity: int, quantity: int, alarm_type: Union[str, "_models.MachineAlarmType"], **kwargs
    ):
        """
        :keyword native_severity: Required.
        :paramtype native_severity: int
        :keyword quantity: Required.
        :paramtype quantity: int
        :keyword alarm_type: Required. Known values are: "Fault" and "Warning".
        :paramtype alarm_type: str or ~ignos.api.client.models.MachineAlarmType
        """
        super().__init__(**kwargs)
        self.native_severity = native_severity
        self.quantity = quantity
        self.alarm_type = alarm_type


class MachineAlarmSummaryDto(_serialization.Model):
    """MachineAlarmSummaryDto.

    Variables are only populated by the server, and will be ignored when sending a request.

    All required parameters must be populated in order to send to Azure.

    :ivar asset_id: Required.
    :vartype asset_id: int
    :ivar asset_name: Required.
    :vartype asset_name: str
    :ivar asset_external_id:
    :vartype asset_external_id: str
    :ivar warning_duration: Required.
    :vartype warning_duration: int
    :ivar warning_quantity: Required.
    :vartype warning_quantity: int
    :ivar warning_quantity_open: Required.
    :vartype warning_quantity_open: int
    :ivar fault_duration: Required.
    :vartype fault_duration: int
    :ivar fault_quantity: Required.
    :vartype fault_quantity: int
    :ivar fault_quantity_open: Required.
    :vartype fault_quantity_open: int
    """

    _validation = {
        "asset_id": {"required": True, "readonly": True},
        "asset_name": {"required": True, "readonly": True, "min_length": 1},
        "asset_external_id": {"readonly": True},
        "warning_duration": {"required": True, "readonly": True},
        "warning_quantity": {"required": True, "readonly": True},
        "warning_quantity_open": {"required": True, "readonly": True},
        "fault_duration": {"required": True, "readonly": True},
        "fault_quantity": {"required": True, "readonly": True},
        "fault_quantity_open": {"required": True, "readonly": True},
    }

    _attribute_map = {
        "asset_id": {"key": "assetId", "type": "int"},
        "asset_name": {"key": "assetName", "type": "str"},
        "asset_external_id": {"key": "assetExternalId", "type": "str"},
        "warning_duration": {"key": "warningDuration", "type": "int"},
        "warning_quantity": {"key": "warningQuantity", "type": "int"},
        "warning_quantity_open": {"key": "warningQuantityOpen", "type": "int"},
        "fault_duration": {"key": "faultDuration", "type": "int"},
        "fault_quantity": {"key": "faultQuantity", "type": "int"},
        "fault_quantity_open": {"key": "faultQuantityOpen", "type": "int"},
    }

    def __init__(self, **kwargs):
        """ """
        super().__init__(**kwargs)
        self.asset_id = None
        self.asset_name = None
        self.asset_external_id = None
        self.warning_duration = None
        self.warning_quantity = None
        self.warning_quantity_open = None
        self.fault_duration = None
        self.fault_quantity = None
        self.fault_quantity_open = None


class MachineAlarmTimeserieDto(_serialization.Model):
    """MachineAlarmTimeserieDto.

    :ivar label:
    :vartype label: str
    :ivar unit:
    :vartype unit: str
    :ivar data_points:
    :vartype data_points: list[~ignos.api.client.models.NumericDataPointDto]
    """

    _attribute_map = {
        "label": {"key": "label", "type": "str"},
        "unit": {"key": "unit", "type": "str"},
        "data_points": {"key": "dataPoints", "type": "[NumericDataPointDto]"},
    }

    def __init__(
        self,
        *,
        label: Optional[str] = None,
        unit: Optional[str] = None,
        data_points: Optional[List["_models.NumericDataPointDto"]] = None,
        **kwargs
    ):
        """
        :keyword label:
        :paramtype label: str
        :keyword unit:
        :paramtype unit: str
        :keyword data_points:
        :paramtype data_points: list[~ignos.api.client.models.NumericDataPointDto]
        """
        super().__init__(**kwargs)
        self.label = label
        self.unit = unit
        self.data_points = data_points


class MachineAlarmTimeseriesGroupDto(_serialization.Model):
    """MachineAlarmTimeseriesGroupDto.

    All required parameters must be populated in order to send to Azure.

    :ivar title: Required.
    :vartype title: str
    :ivar timeseries:
    :vartype timeseries: list[~ignos.api.client.models.MachineAlarmTimeserieDto]
    """

    _validation = {
        "title": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "title": {"key": "title", "type": "str"},
        "timeseries": {"key": "timeseries", "type": "[MachineAlarmTimeserieDto]"},
    }

    def __init__(self, *, title: str, timeseries: Optional[List["_models.MachineAlarmTimeserieDto"]] = None, **kwargs):
        """
        :keyword title: Required.
        :paramtype title: str
        :keyword timeseries:
        :paramtype timeseries: list[~ignos.api.client.models.MachineAlarmTimeserieDto]
        """
        super().__init__(**kwargs)
        self.title = title
        self.timeseries = timeseries


class MachineDto(_serialization.Model):
    """MachineDto.

    :ivar id:
    :vartype id: int
    :ivar external_id:
    :vartype external_id: str
    :ivar name:
    :vartype name: str
    :ivar description:
    :vartype description: str
    """

    _attribute_map = {
        "id": {"key": "id", "type": "int"},
        "external_id": {"key": "externalId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "description": {"key": "description", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: Optional[int] = None,  # pylint: disable=redefined-builtin
        external_id: Optional[str] = None,
        name: Optional[str] = None,
        description: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: int
        :keyword external_id:
        :paramtype external_id: str
        :keyword name:
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.external_id = external_id
        self.name = name
        self.description = description


class MachineStateDatapoint(_serialization.Model):
    """MachineStateDatapoint.

    All required parameters must be populated in order to send to Azure.

    :ivar machine_state_text: Required.
    :vartype machine_state_text: str
    :ivar machine_state: Required. Known values are: "InCycle", "MasterCam", "MdiCycle",
     "CamCycle", "Idle", "OptionalStop", "ProgramStop", "M0", "AtcStopped", "FeedHold", "MdiMode",
     "ManualMode", "EStop", "Alarm", and "PowerOff".
    :vartype machine_state: str or ~ignos.api.client.models.MachineState
    :ivar timestamp: Required.
    :vartype timestamp: int
    """

    _validation = {
        "machine_state_text": {"required": True, "min_length": 1},
        "machine_state": {"required": True},
        "timestamp": {"required": True},
    }

    _attribute_map = {
        "machine_state_text": {"key": "machineStateText", "type": "str"},
        "machine_state": {"key": "machineState", "type": "str"},
        "timestamp": {"key": "timestamp", "type": "int"},
    }

    def __init__(
        self, *, machine_state_text: str, machine_state: Union[str, "_models.MachineState"], timestamp: int, **kwargs
    ):
        """
        :keyword machine_state_text: Required.
        :paramtype machine_state_text: str
        :keyword machine_state: Required. Known values are: "InCycle", "MasterCam", "MdiCycle",
         "CamCycle", "Idle", "OptionalStop", "ProgramStop", "M0", "AtcStopped", "FeedHold", "MdiMode",
         "ManualMode", "EStop", "Alarm", and "PowerOff".
        :paramtype machine_state: str or ~ignos.api.client.models.MachineState
        :keyword timestamp: Required.
        :paramtype timestamp: int
        """
        super().__init__(**kwargs)
        self.machine_state_text = machine_state_text
        self.machine_state = machine_state
        self.timestamp = timestamp


class MachineUtilizationDto(_serialization.Model):
    """MachineUtilizationDto.

    All required parameters must be populated in order to send to Azure.

    :ivar asset_id: Required.
    :vartype asset_id: int
    :ivar name: Required.
    :vartype name: str
    :ivar description:
    :vartype description: str
    :ivar state: Required.
    :vartype state: str
    :ivar machine_state: Required. Known values are: "InCycle", "MasterCam", "MdiCycle",
     "CamCycle", "Idle", "OptionalStop", "ProgramStop", "M0", "AtcStopped", "FeedHold", "MdiMode",
     "ManualMode", "EStop", "Alarm", and "PowerOff".
    :vartype machine_state: str or ~ignos.api.client.models.MachineState
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar workorder:
    :vartype workorder: ~ignos.api.client.models.UtilizationWorkorderDto
    :ivar power_on:
    :vartype power_on: ~ignos.api.client.models.PowerOnUtilizationDto
    """

    _validation = {
        "asset_id": {"required": True},
        "name": {"required": True, "min_length": 1},
        "state": {"required": True, "min_length": 1},
        "machine_state": {"required": True},
    }

    _attribute_map = {
        "asset_id": {"key": "assetId", "type": "int"},
        "name": {"key": "name", "type": "str"},
        "description": {"key": "description", "type": "str"},
        "state": {"key": "state", "type": "str"},
        "machine_state": {"key": "machineState", "type": "str"},
        "start_time": {"key": "startTime", "type": "iso-8601"},
        "workorder": {"key": "workorder", "type": "UtilizationWorkorderDto"},
        "power_on": {"key": "powerOn", "type": "PowerOnUtilizationDto"},
    }

    def __init__(
        self,
        *,
        asset_id: int,
        name: str,
        state: str,
        machine_state: Union[str, "_models.MachineState"],
        description: Optional[str] = None,
        start_time: Optional[datetime.datetime] = None,
        workorder: Optional["_models.UtilizationWorkorderDto"] = None,
        power_on: Optional["_models.PowerOnUtilizationDto"] = None,
        **kwargs
    ):
        """
        :keyword asset_id: Required.
        :paramtype asset_id: int
        :keyword name: Required.
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        :keyword state: Required.
        :paramtype state: str
        :keyword machine_state: Required. Known values are: "InCycle", "MasterCam", "MdiCycle",
         "CamCycle", "Idle", "OptionalStop", "ProgramStop", "M0", "AtcStopped", "FeedHold", "MdiMode",
         "ManualMode", "EStop", "Alarm", and "PowerOff".
        :paramtype machine_state: str or ~ignos.api.client.models.MachineState
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword workorder:
        :paramtype workorder: ~ignos.api.client.models.UtilizationWorkorderDto
        :keyword power_on:
        :paramtype power_on: ~ignos.api.client.models.PowerOnUtilizationDto
        """
        super().__init__(**kwargs)
        self.asset_id = asset_id
        self.name = name
        self.description = description
        self.state = state
        self.machine_state = machine_state
        self.start_time = start_time
        self.workorder = workorder
        self.power_on = power_on


class ManufacturerDto(_serialization.Model):
    """ManufacturerDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name: Required.
    :vartype name: str
    """

    _validation = {
        "id": {"required": True},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
    }

    def __init__(self, *, id: str, name: str, **kwargs):  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name: Required.
        :paramtype name: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name


class MeasurementFormBalloonMappingDto(_serialization.Model):
    """MeasurementFormBalloonMappingDto.

    All required parameters must be populated in order to send to Azure.

    :ivar balloon: Required.
    :vartype balloon: ~ignos.api.client.models.MeasurementFormGroupedElementDto
    :ivar mapped_balloon_id:
    :vartype mapped_balloon_id: str
    :ivar mapping_score_percent:
    :vartype mapping_score_percent: int
    """

    _validation = {
        "balloon": {"required": True},
    }

    _attribute_map = {
        "balloon": {"key": "balloon", "type": "MeasurementFormGroupedElementDto"},
        "mapped_balloon_id": {"key": "mappedBalloonId", "type": "str"},
        "mapping_score_percent": {"key": "mappingScorePercent", "type": "int"},
    }

    def __init__(
        self,
        *,
        balloon: "_models.MeasurementFormGroupedElementDto",
        mapped_balloon_id: Optional[str] = None,
        mapping_score_percent: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword balloon: Required.
        :paramtype balloon: ~ignos.api.client.models.MeasurementFormGroupedElementDto
        :keyword mapped_balloon_id:
        :paramtype mapped_balloon_id: str
        :keyword mapping_score_percent:
        :paramtype mapping_score_percent: int
        """
        super().__init__(**kwargs)
        self.balloon = balloon
        self.mapped_balloon_id = mapped_balloon_id
        self.mapping_score_percent = mapping_score_percent


class MeasurementFormBalloonMappingRequestDto(_serialization.Model):
    """MeasurementFormBalloonMappingRequestDto.

    All required parameters must be populated in order to send to Azure.

    :ivar source_balloon_id: Required.
    :vartype source_balloon_id: str
    :ivar target_balloon_id: Required.
    :vartype target_balloon_id: str
    :ivar mapping_score_percent:
    :vartype mapping_score_percent: int
    """

    _validation = {
        "source_balloon_id": {"required": True, "min_length": 1},
        "target_balloon_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "source_balloon_id": {"key": "sourceBalloonId", "type": "str"},
        "target_balloon_id": {"key": "targetBalloonId", "type": "str"},
        "mapping_score_percent": {"key": "mappingScorePercent", "type": "int"},
    }

    def __init__(
        self, *, source_balloon_id: str, target_balloon_id: str, mapping_score_percent: Optional[int] = None, **kwargs
    ):
        """
        :keyword source_balloon_id: Required.
        :paramtype source_balloon_id: str
        :keyword target_balloon_id: Required.
        :paramtype target_balloon_id: str
        :keyword mapping_score_percent:
        :paramtype mapping_score_percent: int
        """
        super().__init__(**kwargs)
        self.source_balloon_id = source_balloon_id
        self.target_balloon_id = target_balloon_id
        self.mapping_score_percent = mapping_score_percent


class MeasurementFormDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar version_id: Required.
    :vartype version_id: int
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing: Required.
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar created_by: Required.
    :vartype created_by: str
    :ivar created: Required.
    :vartype created: ~datetime.datetime
    :ivar status: Required. Known values are: "Draft", "Released", and "Revoked".
    :vartype status: str or ~ignos.api.client.models.MeasurementFormStatus
    :ivar source: Required. Known values are: "Unknown", "InspectionXpert", "Excel", and "Manual".
    :vartype source: str or ~ignos.api.client.models.MeasurementFormSource
    :ivar extra_schemas: Required.
    :vartype extra_schemas: list[~ignos.api.client.models.MeasurementFormLinkedSchemaDto]
    :ivar validation_rule: Required.
    :vartype validation_rule: ~ignos.api.client.models.ValidationRuleDto
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "schema_id": {"required": True, "min_length": 1},
        "version_id": {"required": True},
        "drawing": {"required": True, "min_length": 1},
        "created_by": {"required": True, "min_length": 1},
        "created": {"required": True},
        "status": {"required": True},
        "source": {"required": True},
        "extra_schemas": {"required": True},
        "validation_rule": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "schema_id": {"key": "schemaId", "type": "str"},
        "version_id": {"key": "versionId", "type": "int"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "created_by": {"key": "createdBy", "type": "str"},
        "created": {"key": "created", "type": "iso-8601"},
        "status": {"key": "status", "type": "str"},
        "source": {"key": "source", "type": "str"},
        "extra_schemas": {"key": "extraSchemas", "type": "[MeasurementFormLinkedSchemaDto]"},
        "validation_rule": {"key": "validationRule", "type": "ValidationRuleDto"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        schema_id: str,
        version_id: int,
        drawing: str,
        created_by: str,
        created: datetime.datetime,
        status: Union[str, "_models.MeasurementFormStatus"],
        source: Union[str, "_models.MeasurementFormSource"],
        extra_schemas: List["_models.MeasurementFormLinkedSchemaDto"],
        validation_rule: "_models.ValidationRuleDto",
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword version_id: Required.
        :paramtype version_id: int
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing: Required.
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword created_by: Required.
        :paramtype created_by: str
        :keyword created: Required.
        :paramtype created: ~datetime.datetime
        :keyword status: Required. Known values are: "Draft", "Released", and "Revoked".
        :paramtype status: str or ~ignos.api.client.models.MeasurementFormStatus
        :keyword source: Required. Known values are: "Unknown", "InspectionXpert", "Excel", and
         "Manual".
        :paramtype source: str or ~ignos.api.client.models.MeasurementFormSource
        :keyword extra_schemas: Required.
        :paramtype extra_schemas: list[~ignos.api.client.models.MeasurementFormLinkedSchemaDto]
        :keyword validation_rule: Required.
        :paramtype validation_rule: ~ignos.api.client.models.ValidationRuleDto
        """
        super().__init__(**kwargs)
        self.id = id
        self.schema_id = schema_id
        self.version_id = version_id
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.created_by = created_by
        self.created = created
        self.status = status
        self.source = source
        self.extra_schemas = extra_schemas
        self.validation_rule = validation_rule


class MeasurementFormElementDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormElementDto.

    :ivar id:
    :vartype id: str
    :ivar image_url:
    :vartype image_url: str
    :ivar thumbnail_url:
    :vartype thumbnail_url: str
    :ivar balloon_id:
    :vartype balloon_id: str
    :ivar section:
    :vartype section: str
    :ivar page_number:
    :vartype page_number: int
    :ivar sheet_zone:
    :vartype sheet_zone: str
    :ivar places:
    :vartype places: int
    :ivar nominal:
    :vartype nominal: float
    :ivar nominal_text:
    :vartype nominal_text: str
    :ivar type:
    :vartype type: str
    :ivar sub_type:
    :vartype sub_type: str
    :ivar unit_of_measure:
    :vartype unit_of_measure: str
    :ivar type_character:
    :vartype type_character: str
    :ivar plus_tolerance:
    :vartype plus_tolerance: float
    :ivar minus_tolerance:
    :vartype minus_tolerance: float
    :ivar upper_limit:
    :vartype upper_limit: float
    :ivar lower_limit:
    :vartype lower_limit: float
    :ivar comments:
    :vartype comments: str
    :ivar updated_by_user:
    :vartype updated_by_user: str
    :ivar updated_date:
    :vartype updated_date: ~datetime.datetime
    :ivar created_by_user:
    :vartype created_by_user: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar frequency: Known values are: "All", "FirstArticle", "NFirst", "NPercent", "ISO2859",
     "Nth", and "None".
    :vartype frequency: str or ~ignos.api.client.models.MeasurementFrequency
    :ivar frequency_parameter:
    :vartype frequency_parameter: int
    :ivar include_in_customer_documentation:
    :vartype include_in_customer_documentation: bool
    :ivar balloon_sequence:
    :vartype balloon_sequence: int
    :ivar balloon_quantity:
    :vartype balloon_quantity: int
    :ivar plus_tolerance_text:
    :vartype plus_tolerance_text: str
    :ivar minus_tolerance_text:
    :vartype minus_tolerance_text: str
    :ivar coating_thickness:
    :vartype coating_thickness: int
    :ivar can_copy:
    :vartype can_copy: bool
    :ivar value_type: Known values are: "None", "Bool", "Decimal", and "String".
    :vartype value_type: str or ~ignos.api.client.models.MeasurementFormValueType
    :ivar bonus_type: Known values are: "None", "Positive", and "PositiveAndNegative".
    :vartype bonus_type: str or ~ignos.api.client.models.BonusType
    :ivar lower_warning_threshold:
    :vartype lower_warning_threshold: float
    :ivar upper_warning_threshold:
    :vartype upper_warning_threshold: float
    :ivar machining_dimension:
    :vartype machining_dimension: float
    :ivar nominal_inch:
    :vartype nominal_inch: float
    """

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "image_url": {"key": "imageUrl", "type": "str"},
        "thumbnail_url": {"key": "thumbnailUrl", "type": "str"},
        "balloon_id": {"key": "balloonId", "type": "str"},
        "section": {"key": "section", "type": "str"},
        "page_number": {"key": "pageNumber", "type": "int"},
        "sheet_zone": {"key": "sheetZone", "type": "str"},
        "places": {"key": "places", "type": "int"},
        "nominal": {"key": "nominal", "type": "float"},
        "nominal_text": {"key": "nominalText", "type": "str"},
        "type": {"key": "type", "type": "str"},
        "sub_type": {"key": "subType", "type": "str"},
        "unit_of_measure": {"key": "unitOfMeasure", "type": "str"},
        "type_character": {"key": "typeCharacter", "type": "str"},
        "plus_tolerance": {"key": "plusTolerance", "type": "float"},
        "minus_tolerance": {"key": "minusTolerance", "type": "float"},
        "upper_limit": {"key": "upperLimit", "type": "float"},
        "lower_limit": {"key": "lowerLimit", "type": "float"},
        "comments": {"key": "comments", "type": "str"},
        "updated_by_user": {"key": "updatedByUser", "type": "str"},
        "updated_date": {"key": "updatedDate", "type": "iso-8601"},
        "created_by_user": {"key": "createdByUser", "type": "str"},
        "created_date": {"key": "createdDate", "type": "iso-8601"},
        "frequency": {"key": "frequency", "type": "str"},
        "frequency_parameter": {"key": "frequencyParameter", "type": "int"},
        "include_in_customer_documentation": {"key": "includeInCustomerDocumentation", "type": "bool"},
        "balloon_sequence": {"key": "balloonSequence", "type": "int"},
        "balloon_quantity": {"key": "balloonQuantity", "type": "int"},
        "plus_tolerance_text": {"key": "plusToleranceText", "type": "str"},
        "minus_tolerance_text": {"key": "minusToleranceText", "type": "str"},
        "coating_thickness": {"key": "coatingThickness", "type": "int"},
        "can_copy": {"key": "canCopy", "type": "bool"},
        "value_type": {"key": "valueType", "type": "str"},
        "bonus_type": {"key": "bonusType", "type": "str"},
        "lower_warning_threshold": {"key": "lowerWarningThreshold", "type": "float"},
        "upper_warning_threshold": {"key": "upperWarningThreshold", "type": "float"},
        "machining_dimension": {"key": "machiningDimension", "type": "float"},
        "nominal_inch": {"key": "nominalInch", "type": "float"},
    }

    def __init__(  # pylint: disable=too-many-locals
        self,
        *,
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        image_url: Optional[str] = None,
        thumbnail_url: Optional[str] = None,
        balloon_id: Optional[str] = None,
        section: Optional[str] = None,
        page_number: Optional[int] = None,
        sheet_zone: Optional[str] = None,
        places: Optional[int] = None,
        nominal: Optional[float] = None,
        nominal_text: Optional[str] = None,
        type: Optional[str] = None,
        sub_type: Optional[str] = None,
        unit_of_measure: Optional[str] = None,
        type_character: Optional[str] = None,
        plus_tolerance: Optional[float] = None,
        minus_tolerance: Optional[float] = None,
        upper_limit: Optional[float] = None,
        lower_limit: Optional[float] = None,
        comments: Optional[str] = None,
        updated_by_user: Optional[str] = None,
        updated_date: Optional[datetime.datetime] = None,
        created_by_user: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        frequency: Optional[Union[str, "_models.MeasurementFrequency"]] = None,
        frequency_parameter: Optional[int] = None,
        include_in_customer_documentation: Optional[bool] = None,
        balloon_sequence: Optional[int] = None,
        balloon_quantity: Optional[int] = None,
        plus_tolerance_text: Optional[str] = None,
        minus_tolerance_text: Optional[str] = None,
        coating_thickness: Optional[int] = None,
        can_copy: Optional[bool] = None,
        value_type: Optional[Union[str, "_models.MeasurementFormValueType"]] = None,
        bonus_type: Optional[Union[str, "_models.BonusType"]] = None,
        lower_warning_threshold: Optional[float] = None,
        upper_warning_threshold: Optional[float] = None,
        machining_dimension: Optional[float] = None,
        nominal_inch: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword image_url:
        :paramtype image_url: str
        :keyword thumbnail_url:
        :paramtype thumbnail_url: str
        :keyword balloon_id:
        :paramtype balloon_id: str
        :keyword section:
        :paramtype section: str
        :keyword page_number:
        :paramtype page_number: int
        :keyword sheet_zone:
        :paramtype sheet_zone: str
        :keyword places:
        :paramtype places: int
        :keyword nominal:
        :paramtype nominal: float
        :keyword nominal_text:
        :paramtype nominal_text: str
        :keyword type:
        :paramtype type: str
        :keyword sub_type:
        :paramtype sub_type: str
        :keyword unit_of_measure:
        :paramtype unit_of_measure: str
        :keyword type_character:
        :paramtype type_character: str
        :keyword plus_tolerance:
        :paramtype plus_tolerance: float
        :keyword minus_tolerance:
        :paramtype minus_tolerance: float
        :keyword upper_limit:
        :paramtype upper_limit: float
        :keyword lower_limit:
        :paramtype lower_limit: float
        :keyword comments:
        :paramtype comments: str
        :keyword updated_by_user:
        :paramtype updated_by_user: str
        :keyword updated_date:
        :paramtype updated_date: ~datetime.datetime
        :keyword created_by_user:
        :paramtype created_by_user: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword frequency: Known values are: "All", "FirstArticle", "NFirst", "NPercent", "ISO2859",
         "Nth", and "None".
        :paramtype frequency: str or ~ignos.api.client.models.MeasurementFrequency
        :keyword frequency_parameter:
        :paramtype frequency_parameter: int
        :keyword include_in_customer_documentation:
        :paramtype include_in_customer_documentation: bool
        :keyword balloon_sequence:
        :paramtype balloon_sequence: int
        :keyword balloon_quantity:
        :paramtype balloon_quantity: int
        :keyword plus_tolerance_text:
        :paramtype plus_tolerance_text: str
        :keyword minus_tolerance_text:
        :paramtype minus_tolerance_text: str
        :keyword coating_thickness:
        :paramtype coating_thickness: int
        :keyword can_copy:
        :paramtype can_copy: bool
        :keyword value_type: Known values are: "None", "Bool", "Decimal", and "String".
        :paramtype value_type: str or ~ignos.api.client.models.MeasurementFormValueType
        :keyword bonus_type: Known values are: "None", "Positive", and "PositiveAndNegative".
        :paramtype bonus_type: str or ~ignos.api.client.models.BonusType
        :keyword lower_warning_threshold:
        :paramtype lower_warning_threshold: float
        :keyword upper_warning_threshold:
        :paramtype upper_warning_threshold: float
        :keyword machining_dimension:
        :paramtype machining_dimension: float
        :keyword nominal_inch:
        :paramtype nominal_inch: float
        """
        super().__init__(**kwargs)
        self.id = id
        self.image_url = image_url
        self.thumbnail_url = thumbnail_url
        self.balloon_id = balloon_id
        self.section = section
        self.page_number = page_number
        self.sheet_zone = sheet_zone
        self.places = places
        self.nominal = nominal
        self.nominal_text = nominal_text
        self.type = type
        self.sub_type = sub_type
        self.unit_of_measure = unit_of_measure
        self.type_character = type_character
        self.plus_tolerance = plus_tolerance
        self.minus_tolerance = minus_tolerance
        self.upper_limit = upper_limit
        self.lower_limit = lower_limit
        self.comments = comments
        self.updated_by_user = updated_by_user
        self.updated_date = updated_date
        self.created_by_user = created_by_user
        self.created_date = created_date
        self.frequency = frequency
        self.frequency_parameter = frequency_parameter
        self.include_in_customer_documentation = include_in_customer_documentation
        self.balloon_sequence = balloon_sequence
        self.balloon_quantity = balloon_quantity
        self.plus_tolerance_text = plus_tolerance_text
        self.minus_tolerance_text = minus_tolerance_text
        self.coating_thickness = coating_thickness
        self.can_copy = can_copy
        self.value_type = value_type
        self.bonus_type = bonus_type
        self.lower_warning_threshold = lower_warning_threshold
        self.upper_warning_threshold = upper_warning_threshold
        self.machining_dimension = machining_dimension
        self.nominal_inch = nominal_inch


class MeasurementFormElementImportDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormElementImportDto.

    :ivar id:
    :vartype id: str
    :ivar image_url:
    :vartype image_url: str
    :ivar thumbnail_url:
    :vartype thumbnail_url: str
    :ivar balloon_id:
    :vartype balloon_id: str
    :ivar section:
    :vartype section: str
    :ivar page_number:
    :vartype page_number: int
    :ivar sheet_zone:
    :vartype sheet_zone: str
    :ivar places:
    :vartype places: int
    :ivar nominal:
    :vartype nominal: float
    :ivar nominal_text:
    :vartype nominal_text: str
    :ivar type:
    :vartype type: str
    :ivar sub_type:
    :vartype sub_type: str
    :ivar unit_of_measure:
    :vartype unit_of_measure: str
    :ivar type_character:
    :vartype type_character: str
    :ivar plus_tolerance:
    :vartype plus_tolerance: float
    :ivar minus_tolerance:
    :vartype minus_tolerance: float
    :ivar upper_limit:
    :vartype upper_limit: float
    :ivar lower_limit:
    :vartype lower_limit: float
    :ivar comments:
    :vartype comments: str
    :ivar updated_by_user:
    :vartype updated_by_user: str
    :ivar updated_date:
    :vartype updated_date: ~datetime.datetime
    :ivar created_by_user:
    :vartype created_by_user: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar frequency: Known values are: "All", "FirstArticle", "NFirst", "NPercent", "ISO2859",
     "Nth", and "None".
    :vartype frequency: str or ~ignos.api.client.models.MeasurementFrequency
    :ivar frequency_parameter:
    :vartype frequency_parameter: int
    :ivar include_in_customer_documentation:
    :vartype include_in_customer_documentation: bool
    :ivar balloon_sequence:
    :vartype balloon_sequence: int
    :ivar balloon_quantity:
    :vartype balloon_quantity: int
    :ivar plus_tolerance_text:
    :vartype plus_tolerance_text: str
    :ivar minus_tolerance_text:
    :vartype minus_tolerance_text: str
    :ivar coating_thickness:
    :vartype coating_thickness: int
    :ivar can_copy:
    :vartype can_copy: bool
    :ivar value_type: Known values are: "None", "Bool", "Decimal", and "String".
    :vartype value_type: str or ~ignos.api.client.models.MeasurementFormValueType
    :ivar inspection_method:
    :vartype inspection_method: str
    :ivar process:
    :vartype process: str
    :ivar classification:
    :vartype classification: str
    :ivar fit_grade:
    :vartype fit_grade: str
    :ivar fit_type:
    :vartype fit_type: int
    :ivar for_reference:
    :vartype for_reference: bool
    """

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "image_url": {"key": "imageUrl", "type": "str"},
        "thumbnail_url": {"key": "thumbnailUrl", "type": "str"},
        "balloon_id": {"key": "balloonId", "type": "str"},
        "section": {"key": "section", "type": "str"},
        "page_number": {"key": "pageNumber", "type": "int"},
        "sheet_zone": {"key": "sheetZone", "type": "str"},
        "places": {"key": "places", "type": "int"},
        "nominal": {"key": "nominal", "type": "float"},
        "nominal_text": {"key": "nominalText", "type": "str"},
        "type": {"key": "type", "type": "str"},
        "sub_type": {"key": "subType", "type": "str"},
        "unit_of_measure": {"key": "unitOfMeasure", "type": "str"},
        "type_character": {"key": "typeCharacter", "type": "str"},
        "plus_tolerance": {"key": "plusTolerance", "type": "float"},
        "minus_tolerance": {"key": "minusTolerance", "type": "float"},
        "upper_limit": {"key": "upperLimit", "type": "float"},
        "lower_limit": {"key": "lowerLimit", "type": "float"},
        "comments": {"key": "comments", "type": "str"},
        "updated_by_user": {"key": "updatedByUser", "type": "str"},
        "updated_date": {"key": "updatedDate", "type": "iso-8601"},
        "created_by_user": {"key": "createdByUser", "type": "str"},
        "created_date": {"key": "createdDate", "type": "iso-8601"},
        "frequency": {"key": "frequency", "type": "str"},
        "frequency_parameter": {"key": "frequencyParameter", "type": "int"},
        "include_in_customer_documentation": {"key": "includeInCustomerDocumentation", "type": "bool"},
        "balloon_sequence": {"key": "balloonSequence", "type": "int"},
        "balloon_quantity": {"key": "balloonQuantity", "type": "int"},
        "plus_tolerance_text": {"key": "plusToleranceText", "type": "str"},
        "minus_tolerance_text": {"key": "minusToleranceText", "type": "str"},
        "coating_thickness": {"key": "coatingThickness", "type": "int"},
        "can_copy": {"key": "canCopy", "type": "bool"},
        "value_type": {"key": "valueType", "type": "str"},
        "inspection_method": {"key": "inspectionMethod", "type": "str"},
        "process": {"key": "process", "type": "str"},
        "classification": {"key": "classification", "type": "str"},
        "fit_grade": {"key": "fitGrade", "type": "str"},
        "fit_type": {"key": "fitType", "type": "int"},
        "for_reference": {"key": "forReference", "type": "bool"},
    }

    def __init__(  # pylint: disable=too-many-locals
        self,
        *,
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        image_url: Optional[str] = None,
        thumbnail_url: Optional[str] = None,
        balloon_id: Optional[str] = None,
        section: Optional[str] = None,
        page_number: Optional[int] = None,
        sheet_zone: Optional[str] = None,
        places: Optional[int] = None,
        nominal: Optional[float] = None,
        nominal_text: Optional[str] = None,
        type: Optional[str] = None,
        sub_type: Optional[str] = None,
        unit_of_measure: Optional[str] = None,
        type_character: Optional[str] = None,
        plus_tolerance: Optional[float] = None,
        minus_tolerance: Optional[float] = None,
        upper_limit: Optional[float] = None,
        lower_limit: Optional[float] = None,
        comments: Optional[str] = None,
        updated_by_user: Optional[str] = None,
        updated_date: Optional[datetime.datetime] = None,
        created_by_user: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        frequency: Optional[Union[str, "_models.MeasurementFrequency"]] = None,
        frequency_parameter: Optional[int] = None,
        include_in_customer_documentation: Optional[bool] = None,
        balloon_sequence: Optional[int] = None,
        balloon_quantity: Optional[int] = None,
        plus_tolerance_text: Optional[str] = None,
        minus_tolerance_text: Optional[str] = None,
        coating_thickness: Optional[int] = None,
        can_copy: Optional[bool] = None,
        value_type: Optional[Union[str, "_models.MeasurementFormValueType"]] = None,
        inspection_method: Optional[str] = None,
        process: Optional[str] = None,
        classification: Optional[str] = None,
        fit_grade: Optional[str] = None,
        fit_type: Optional[int] = None,
        for_reference: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword image_url:
        :paramtype image_url: str
        :keyword thumbnail_url:
        :paramtype thumbnail_url: str
        :keyword balloon_id:
        :paramtype balloon_id: str
        :keyword section:
        :paramtype section: str
        :keyword page_number:
        :paramtype page_number: int
        :keyword sheet_zone:
        :paramtype sheet_zone: str
        :keyword places:
        :paramtype places: int
        :keyword nominal:
        :paramtype nominal: float
        :keyword nominal_text:
        :paramtype nominal_text: str
        :keyword type:
        :paramtype type: str
        :keyword sub_type:
        :paramtype sub_type: str
        :keyword unit_of_measure:
        :paramtype unit_of_measure: str
        :keyword type_character:
        :paramtype type_character: str
        :keyword plus_tolerance:
        :paramtype plus_tolerance: float
        :keyword minus_tolerance:
        :paramtype minus_tolerance: float
        :keyword upper_limit:
        :paramtype upper_limit: float
        :keyword lower_limit:
        :paramtype lower_limit: float
        :keyword comments:
        :paramtype comments: str
        :keyword updated_by_user:
        :paramtype updated_by_user: str
        :keyword updated_date:
        :paramtype updated_date: ~datetime.datetime
        :keyword created_by_user:
        :paramtype created_by_user: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword frequency: Known values are: "All", "FirstArticle", "NFirst", "NPercent", "ISO2859",
         "Nth", and "None".
        :paramtype frequency: str or ~ignos.api.client.models.MeasurementFrequency
        :keyword frequency_parameter:
        :paramtype frequency_parameter: int
        :keyword include_in_customer_documentation:
        :paramtype include_in_customer_documentation: bool
        :keyword balloon_sequence:
        :paramtype balloon_sequence: int
        :keyword balloon_quantity:
        :paramtype balloon_quantity: int
        :keyword plus_tolerance_text:
        :paramtype plus_tolerance_text: str
        :keyword minus_tolerance_text:
        :paramtype minus_tolerance_text: str
        :keyword coating_thickness:
        :paramtype coating_thickness: int
        :keyword can_copy:
        :paramtype can_copy: bool
        :keyword value_type: Known values are: "None", "Bool", "Decimal", and "String".
        :paramtype value_type: str or ~ignos.api.client.models.MeasurementFormValueType
        :keyword inspection_method:
        :paramtype inspection_method: str
        :keyword process:
        :paramtype process: str
        :keyword classification:
        :paramtype classification: str
        :keyword fit_grade:
        :paramtype fit_grade: str
        :keyword fit_type:
        :paramtype fit_type: int
        :keyword for_reference:
        :paramtype for_reference: bool
        """
        super().__init__(**kwargs)
        self.id = id
        self.image_url = image_url
        self.thumbnail_url = thumbnail_url
        self.balloon_id = balloon_id
        self.section = section
        self.page_number = page_number
        self.sheet_zone = sheet_zone
        self.places = places
        self.nominal = nominal
        self.nominal_text = nominal_text
        self.type = type
        self.sub_type = sub_type
        self.unit_of_measure = unit_of_measure
        self.type_character = type_character
        self.plus_tolerance = plus_tolerance
        self.minus_tolerance = minus_tolerance
        self.upper_limit = upper_limit
        self.lower_limit = lower_limit
        self.comments = comments
        self.updated_by_user = updated_by_user
        self.updated_date = updated_date
        self.created_by_user = created_by_user
        self.created_date = created_date
        self.frequency = frequency
        self.frequency_parameter = frequency_parameter
        self.include_in_customer_documentation = include_in_customer_documentation
        self.balloon_sequence = balloon_sequence
        self.balloon_quantity = balloon_quantity
        self.plus_tolerance_text = plus_tolerance_text
        self.minus_tolerance_text = minus_tolerance_text
        self.coating_thickness = coating_thickness
        self.can_copy = can_copy
        self.value_type = value_type
        self.inspection_method = inspection_method
        self.process = process
        self.classification = classification
        self.fit_grade = fit_grade
        self.fit_type = fit_type
        self.for_reference = for_reference


class MeasurementFormElementValueAuditDto(_serialization.Model):
    """MeasurementFormElementValueAuditDto.

    All required parameters must be populated in order to send to Azure.

    :ivar workorder:
    :vartype workorder: str
    :ivar operation:
    :vartype operation: int
    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar value:
    :vartype value: str
    :ivar bonus:
    :vartype bonus: float
    :ivar sequence: Required.
    :vartype sequence: str
    :ivar element_id: Required.
    :vartype element_id: str
    :ivar updated_by_user: Required.
    :vartype updated_by_user: str
    :ivar updated_date: Required.
    :vartype updated_date: ~datetime.datetime
    :ivar tools: Required.
    :vartype tools: list[~ignos.api.client.models.MeasurementFormToolValueDto]
    """

    _validation = {
        "schema_id": {"required": True, "min_length": 1},
        "sequence": {"required": True, "min_length": 1},
        "element_id": {"required": True, "min_length": 1},
        "updated_by_user": {"required": True, "min_length": 1},
        "updated_date": {"required": True},
        "tools": {"required": True},
    }

    _attribute_map = {
        "workorder": {"key": "workorder", "type": "str"},
        "operation": {"key": "operation", "type": "int"},
        "schema_id": {"key": "schemaId", "type": "str"},
        "value": {"key": "value", "type": "str"},
        "bonus": {"key": "bonus", "type": "float"},
        "sequence": {"key": "sequence", "type": "str"},
        "element_id": {"key": "elementId", "type": "str"},
        "updated_by_user": {"key": "updatedByUser", "type": "str"},
        "updated_date": {"key": "updatedDate", "type": "iso-8601"},
        "tools": {"key": "tools", "type": "[MeasurementFormToolValueDto]"},
    }

    def __init__(
        self,
        *,
        schema_id: str,
        sequence: str,
        element_id: str,
        updated_by_user: str,
        updated_date: datetime.datetime,
        tools: List["_models.MeasurementFormToolValueDto"],
        workorder: Optional[str] = None,
        operation: Optional[int] = None,
        value: Optional[str] = None,
        bonus: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword workorder:
        :paramtype workorder: str
        :keyword operation:
        :paramtype operation: int
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword value:
        :paramtype value: str
        :keyword bonus:
        :paramtype bonus: float
        :keyword sequence: Required.
        :paramtype sequence: str
        :keyword element_id: Required.
        :paramtype element_id: str
        :keyword updated_by_user: Required.
        :paramtype updated_by_user: str
        :keyword updated_date: Required.
        :paramtype updated_date: ~datetime.datetime
        :keyword tools: Required.
        :paramtype tools: list[~ignos.api.client.models.MeasurementFormToolValueDto]
        """
        super().__init__(**kwargs)
        self.workorder = workorder
        self.operation = operation
        self.schema_id = schema_id
        self.value = value
        self.bonus = bonus
        self.sequence = sequence
        self.element_id = element_id
        self.updated_by_user = updated_by_user
        self.updated_date = updated_date
        self.tools = tools


class MeasurementFormElementValueDto(_serialization.Model):
    """MeasurementFormElementValueDto.

    All required parameters must be populated in order to send to Azure.

    :ivar bonus:
    :vartype bonus: str
    :ivar completed: Required.
    :vartype completed: bool
    :ivar sequence: Required.
    :vartype sequence: str
    :ivar value:
    :vartype value: str
    :ivar updated_by_user: Required.
    :vartype updated_by_user: str
    :ivar updated_date: Required.
    :vartype updated_date: ~datetime.datetime
    :ivar tools: Required.
    :vartype tools: list[~ignos.api.client.models.MeasurementFormToolValueDto]
    :ivar comment:
    :vartype comment: str
    """

    _validation = {
        "completed": {"required": True},
        "sequence": {"required": True, "min_length": 1},
        "updated_by_user": {"required": True, "min_length": 1},
        "updated_date": {"required": True},
        "tools": {"required": True},
    }

    _attribute_map = {
        "bonus": {"key": "bonus", "type": "str"},
        "completed": {"key": "completed", "type": "bool"},
        "sequence": {"key": "sequence", "type": "str"},
        "value": {"key": "value", "type": "str"},
        "updated_by_user": {"key": "updatedByUser", "type": "str"},
        "updated_date": {"key": "updatedDate", "type": "iso-8601"},
        "tools": {"key": "tools", "type": "[MeasurementFormToolValueDto]"},
        "comment": {"key": "comment", "type": "str"},
    }

    def __init__(
        self,
        *,
        completed: bool,
        sequence: str,
        updated_by_user: str,
        updated_date: datetime.datetime,
        tools: List["_models.MeasurementFormToolValueDto"],
        bonus: Optional[str] = None,
        value: Optional[str] = None,
        comment: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword bonus:
        :paramtype bonus: str
        :keyword completed: Required.
        :paramtype completed: bool
        :keyword sequence: Required.
        :paramtype sequence: str
        :keyword value:
        :paramtype value: str
        :keyword updated_by_user: Required.
        :paramtype updated_by_user: str
        :keyword updated_date: Required.
        :paramtype updated_date: ~datetime.datetime
        :keyword tools: Required.
        :paramtype tools: list[~ignos.api.client.models.MeasurementFormToolValueDto]
        :keyword comment:
        :paramtype comment: str
        """
        super().__init__(**kwargs)
        self.bonus = bonus
        self.completed = completed
        self.sequence = sequence
        self.value = value
        self.updated_by_user = updated_by_user
        self.updated_date = updated_date
        self.tools = tools
        self.comment = comment


class MeasurementFormGroupedElementDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormGroupedElementDto.

    All required parameters must be populated in order to send to Azure.

    :ivar image_url:
    :vartype image_url: str
    :ivar thumbnail_url:
    :vartype thumbnail_url: str
    :ivar balloon_id: Required.
    :vartype balloon_id: str
    :ivar section:
    :vartype section: str
    :ivar page_number:
    :vartype page_number: int
    :ivar sheet_zone:
    :vartype sheet_zone: str
    :ivar places:
    :vartype places: int
    :ivar nominal:
    :vartype nominal: float
    :ivar nominal_text:
    :vartype nominal_text: str
    :ivar type:
    :vartype type: str
    :ivar sub_type:
    :vartype sub_type: str
    :ivar unit_of_measure:
    :vartype unit_of_measure: str
    :ivar type_character:
    :vartype type_character: str
    :ivar plus_tolerance:
    :vartype plus_tolerance: float
    :ivar minus_tolerance:
    :vartype minus_tolerance: float
    :ivar upper_limit:
    :vartype upper_limit: float
    :ivar lower_limit:
    :vartype lower_limit: float
    :ivar comments:
    :vartype comments: str
    :ivar updated_by_user:
    :vartype updated_by_user: str
    :ivar updated_date:
    :vartype updated_date: ~datetime.datetime
    :ivar created_by_user:
    :vartype created_by_user: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar frequency: Known values are: "All", "FirstArticle", "NFirst", "NPercent", "ISO2859",
     "Nth", and "None".
    :vartype frequency: str or ~ignos.api.client.models.MeasurementFrequency
    :ivar frequency_parameter:
    :vartype frequency_parameter: int
    :ivar include_in_customer_documentation:
    :vartype include_in_customer_documentation: bool
    :ivar balloon_quantity:
    :vartype balloon_quantity: int
    :ivar plus_tolerance_text:
    :vartype plus_tolerance_text: str
    :ivar minus_tolerance_text:
    :vartype minus_tolerance_text: str
    :ivar coating_thickness:
    :vartype coating_thickness: int
    :ivar can_copy:
    :vartype can_copy: bool
    :ivar value_type: Known values are: "None", "Bool", "Decimal", and "String".
    :vartype value_type: str or ~ignos.api.client.models.MeasurementFormValueType
    :ivar bonus_type: Known values are: "None", "Positive", and "PositiveAndNegative".
    :vartype bonus_type: str or ~ignos.api.client.models.BonusType
    :ivar lower_warning_threshold:
    :vartype lower_warning_threshold: float
    :ivar upper_warning_threshold:
    :vartype upper_warning_threshold: float
    :ivar machining_dimension:
    :vartype machining_dimension: float
    :ivar nominal_inch:
    :vartype nominal_inch: float
    """

    _validation = {
        "balloon_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "image_url": {"key": "imageUrl", "type": "str"},
        "thumbnail_url": {"key": "thumbnailUrl", "type": "str"},
        "balloon_id": {"key": "balloonId", "type": "str"},
        "section": {"key": "section", "type": "str"},
        "page_number": {"key": "pageNumber", "type": "int"},
        "sheet_zone": {"key": "sheetZone", "type": "str"},
        "places": {"key": "places", "type": "int"},
        "nominal": {"key": "nominal", "type": "float"},
        "nominal_text": {"key": "nominalText", "type": "str"},
        "type": {"key": "type", "type": "str"},
        "sub_type": {"key": "subType", "type": "str"},
        "unit_of_measure": {"key": "unitOfMeasure", "type": "str"},
        "type_character": {"key": "typeCharacter", "type": "str"},
        "plus_tolerance": {"key": "plusTolerance", "type": "float"},
        "minus_tolerance": {"key": "minusTolerance", "type": "float"},
        "upper_limit": {"key": "upperLimit", "type": "float"},
        "lower_limit": {"key": "lowerLimit", "type": "float"},
        "comments": {"key": "comments", "type": "str"},
        "updated_by_user": {"key": "updatedByUser", "type": "str"},
        "updated_date": {"key": "updatedDate", "type": "iso-8601"},
        "created_by_user": {"key": "createdByUser", "type": "str"},
        "created_date": {"key": "createdDate", "type": "iso-8601"},
        "frequency": {"key": "frequency", "type": "str"},
        "frequency_parameter": {"key": "frequencyParameter", "type": "int"},
        "include_in_customer_documentation": {"key": "includeInCustomerDocumentation", "type": "bool"},
        "balloon_quantity": {"key": "balloonQuantity", "type": "int"},
        "plus_tolerance_text": {"key": "plusToleranceText", "type": "str"},
        "minus_tolerance_text": {"key": "minusToleranceText", "type": "str"},
        "coating_thickness": {"key": "coatingThickness", "type": "int"},
        "can_copy": {"key": "canCopy", "type": "bool"},
        "value_type": {"key": "valueType", "type": "str"},
        "bonus_type": {"key": "bonusType", "type": "str"},
        "lower_warning_threshold": {"key": "lowerWarningThreshold", "type": "float"},
        "upper_warning_threshold": {"key": "upperWarningThreshold", "type": "float"},
        "machining_dimension": {"key": "machiningDimension", "type": "float"},
        "nominal_inch": {"key": "nominalInch", "type": "float"},
    }

    def __init__(  # pylint: disable=too-many-locals
        self,
        *,
        balloon_id: str,
        image_url: Optional[str] = None,
        thumbnail_url: Optional[str] = None,
        section: Optional[str] = None,
        page_number: Optional[int] = None,
        sheet_zone: Optional[str] = None,
        places: Optional[int] = None,
        nominal: Optional[float] = None,
        nominal_text: Optional[str] = None,
        type: Optional[str] = None,
        sub_type: Optional[str] = None,
        unit_of_measure: Optional[str] = None,
        type_character: Optional[str] = None,
        plus_tolerance: Optional[float] = None,
        minus_tolerance: Optional[float] = None,
        upper_limit: Optional[float] = None,
        lower_limit: Optional[float] = None,
        comments: Optional[str] = None,
        updated_by_user: Optional[str] = None,
        updated_date: Optional[datetime.datetime] = None,
        created_by_user: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        frequency: Optional[Union[str, "_models.MeasurementFrequency"]] = None,
        frequency_parameter: Optional[int] = None,
        include_in_customer_documentation: Optional[bool] = None,
        balloon_quantity: Optional[int] = None,
        plus_tolerance_text: Optional[str] = None,
        minus_tolerance_text: Optional[str] = None,
        coating_thickness: Optional[int] = None,
        can_copy: Optional[bool] = None,
        value_type: Optional[Union[str, "_models.MeasurementFormValueType"]] = None,
        bonus_type: Optional[Union[str, "_models.BonusType"]] = None,
        lower_warning_threshold: Optional[float] = None,
        upper_warning_threshold: Optional[float] = None,
        machining_dimension: Optional[float] = None,
        nominal_inch: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword image_url:
        :paramtype image_url: str
        :keyword thumbnail_url:
        :paramtype thumbnail_url: str
        :keyword balloon_id: Required.
        :paramtype balloon_id: str
        :keyword section:
        :paramtype section: str
        :keyword page_number:
        :paramtype page_number: int
        :keyword sheet_zone:
        :paramtype sheet_zone: str
        :keyword places:
        :paramtype places: int
        :keyword nominal:
        :paramtype nominal: float
        :keyword nominal_text:
        :paramtype nominal_text: str
        :keyword type:
        :paramtype type: str
        :keyword sub_type:
        :paramtype sub_type: str
        :keyword unit_of_measure:
        :paramtype unit_of_measure: str
        :keyword type_character:
        :paramtype type_character: str
        :keyword plus_tolerance:
        :paramtype plus_tolerance: float
        :keyword minus_tolerance:
        :paramtype minus_tolerance: float
        :keyword upper_limit:
        :paramtype upper_limit: float
        :keyword lower_limit:
        :paramtype lower_limit: float
        :keyword comments:
        :paramtype comments: str
        :keyword updated_by_user:
        :paramtype updated_by_user: str
        :keyword updated_date:
        :paramtype updated_date: ~datetime.datetime
        :keyword created_by_user:
        :paramtype created_by_user: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword frequency: Known values are: "All", "FirstArticle", "NFirst", "NPercent", "ISO2859",
         "Nth", and "None".
        :paramtype frequency: str or ~ignos.api.client.models.MeasurementFrequency
        :keyword frequency_parameter:
        :paramtype frequency_parameter: int
        :keyword include_in_customer_documentation:
        :paramtype include_in_customer_documentation: bool
        :keyword balloon_quantity:
        :paramtype balloon_quantity: int
        :keyword plus_tolerance_text:
        :paramtype plus_tolerance_text: str
        :keyword minus_tolerance_text:
        :paramtype minus_tolerance_text: str
        :keyword coating_thickness:
        :paramtype coating_thickness: int
        :keyword can_copy:
        :paramtype can_copy: bool
        :keyword value_type: Known values are: "None", "Bool", "Decimal", and "String".
        :paramtype value_type: str or ~ignos.api.client.models.MeasurementFormValueType
        :keyword bonus_type: Known values are: "None", "Positive", and "PositiveAndNegative".
        :paramtype bonus_type: str or ~ignos.api.client.models.BonusType
        :keyword lower_warning_threshold:
        :paramtype lower_warning_threshold: float
        :keyword upper_warning_threshold:
        :paramtype upper_warning_threshold: float
        :keyword machining_dimension:
        :paramtype machining_dimension: float
        :keyword nominal_inch:
        :paramtype nominal_inch: float
        """
        super().__init__(**kwargs)
        self.image_url = image_url
        self.thumbnail_url = thumbnail_url
        self.balloon_id = balloon_id
        self.section = section
        self.page_number = page_number
        self.sheet_zone = sheet_zone
        self.places = places
        self.nominal = nominal
        self.nominal_text = nominal_text
        self.type = type
        self.sub_type = sub_type
        self.unit_of_measure = unit_of_measure
        self.type_character = type_character
        self.plus_tolerance = plus_tolerance
        self.minus_tolerance = minus_tolerance
        self.upper_limit = upper_limit
        self.lower_limit = lower_limit
        self.comments = comments
        self.updated_by_user = updated_by_user
        self.updated_date = updated_date
        self.created_by_user = created_by_user
        self.created_date = created_date
        self.frequency = frequency
        self.frequency_parameter = frequency_parameter
        self.include_in_customer_documentation = include_in_customer_documentation
        self.balloon_quantity = balloon_quantity
        self.plus_tolerance_text = plus_tolerance_text
        self.minus_tolerance_text = minus_tolerance_text
        self.coating_thickness = coating_thickness
        self.can_copy = can_copy
        self.value_type = value_type
        self.bonus_type = bonus_type
        self.lower_warning_threshold = lower_warning_threshold
        self.upper_warning_threshold = upper_warning_threshold
        self.machining_dimension = machining_dimension
        self.nominal_inch = nominal_inch


class MeasurementFormImportLinkedSchemaDto(_serialization.Model):
    """MeasurementFormImportLinkedSchemaDto.

    All required parameters must be populated in order to send to Azure.

    :ivar customer_id:
    :vartype customer_id: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing: Required.
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar schema_id:
    :vartype schema_id: str
    """

    _validation = {
        "drawing": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "customer_id": {"key": "customerId", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "schema_id": {"key": "schemaId", "type": "str"},
    }

    def __init__(
        self,
        *,
        drawing: str,
        customer_id: Optional[str] = None,
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        schema_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing: Required.
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword schema_id:
        :paramtype schema_id: str
        """
        super().__init__(**kwargs)
        self.customer_id = customer_id
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.schema_id = schema_id


class MeasurementFormImportStatusDto(_serialization.Model):
    """MeasurementFormImportStatusDto.

    Variables are only populated by the server, and will be ignored when sending a request.

    All required parameters must be populated in order to send to Azure.

    :ivar progress: Required.
    :vartype progress: int
    :ivar total_elements: Required.
    :vartype total_elements: int
    :ivar error_message: Required.
    :vartype error_message: str
    :ivar timestamp: Required.
    :vartype timestamp: ~datetime.datetime
    """

    _validation = {
        "progress": {"required": True, "readonly": True},
        "total_elements": {"required": True, "readonly": True},
        "error_message": {"required": True, "readonly": True, "min_length": 1},
        "timestamp": {"required": True, "readonly": True},
    }

    _attribute_map = {
        "progress": {"key": "progress", "type": "int"},
        "total_elements": {"key": "totalElements", "type": "int"},
        "error_message": {"key": "errorMessage", "type": "str"},
        "timestamp": {"key": "timestamp", "type": "iso-8601"},
    }

    def __init__(self, **kwargs):
        """ """
        super().__init__(**kwargs)
        self.progress = None
        self.total_elements = None
        self.error_message = None
        self.timestamp = None


class MeasurementFormInstanceDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormInstanceDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar readonly: Required.
    :vartype readonly: bool
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar customer_id:
    :vartype customer_id: str
    :ivar quantity: Required.
    :vartype quantity: int
    :ivar validation_rule_id:
    :vartype validation_rule_id: str
    :ivar status: Required. Known values are: "Active", "Cancelled", "Completed", and "Approved".
    :vartype status: str or ~ignos.api.client.models.MeasurementFormInstanceStatus
    :ivar schemas: Required.
    :vartype schemas: list[~ignos.api.client.models.MeasurementFormWorkorderSchemaDto]
    :ivar sequences: Required.
    :vartype sequences: list[~ignos.api.client.models.MeasurementFormWorkorderSequenceDto]
    :ivar suppliers: Required.
    :vartype suppliers: list[~ignos.api.client.models.MeasurementFormWorkorderSupplierDto]
    :ivar progress: Required.
    :vartype progress: ~ignos.api.client.models.MeasurementFormProgressDto
    :ivar approved_report_url:
    :vartype approved_report_url: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "readonly": {"required": True},
        "quantity": {"required": True},
        "status": {"required": True},
        "schemas": {"required": True},
        "sequences": {"required": True},
        "suppliers": {"required": True},
        "progress": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "readonly": {"key": "readonly", "type": "bool"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "customer_id": {"key": "customerId", "type": "str"},
        "quantity": {"key": "quantity", "type": "int"},
        "validation_rule_id": {"key": "validationRuleId", "type": "str"},
        "status": {"key": "status", "type": "str"},
        "schemas": {"key": "schemas", "type": "[MeasurementFormWorkorderSchemaDto]"},
        "sequences": {"key": "sequences", "type": "[MeasurementFormWorkorderSequenceDto]"},
        "suppliers": {"key": "suppliers", "type": "[MeasurementFormWorkorderSupplierDto]"},
        "progress": {"key": "progress", "type": "MeasurementFormProgressDto"},
        "approved_report_url": {"key": "approvedReportUrl", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        readonly: bool,
        quantity: int,
        status: Union[str, "_models.MeasurementFormInstanceStatus"],
        schemas: List["_models.MeasurementFormWorkorderSchemaDto"],
        sequences: List["_models.MeasurementFormWorkorderSequenceDto"],
        suppliers: List["_models.MeasurementFormWorkorderSupplierDto"],
        progress: "_models.MeasurementFormProgressDto",
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        customer_id: Optional[str] = None,
        validation_rule_id: Optional[str] = None,
        approved_report_url: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword readonly: Required.
        :paramtype readonly: bool
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword quantity: Required.
        :paramtype quantity: int
        :keyword validation_rule_id:
        :paramtype validation_rule_id: str
        :keyword status: Required. Known values are: "Active", "Cancelled", "Completed", and
         "Approved".
        :paramtype status: str or ~ignos.api.client.models.MeasurementFormInstanceStatus
        :keyword schemas: Required.
        :paramtype schemas: list[~ignos.api.client.models.MeasurementFormWorkorderSchemaDto]
        :keyword sequences: Required.
        :paramtype sequences: list[~ignos.api.client.models.MeasurementFormWorkorderSequenceDto]
        :keyword suppliers: Required.
        :paramtype suppliers: list[~ignos.api.client.models.MeasurementFormWorkorderSupplierDto]
        :keyword progress: Required.
        :paramtype progress: ~ignos.api.client.models.MeasurementFormProgressDto
        :keyword approved_report_url:
        :paramtype approved_report_url: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.readonly = readonly
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.customer_id = customer_id
        self.quantity = quantity
        self.validation_rule_id = validation_rule_id
        self.status = status
        self.schemas = schemas
        self.sequences = sequences
        self.suppliers = suppliers
        self.progress = progress
        self.approved_report_url = approved_report_url


class MeasurementFormInstanceDtoPagedResult(_serialization.Model):
    """MeasurementFormInstanceDtoPagedResult.

    All required parameters must be populated in order to send to Azure.

    :ivar results: Required.
    :vartype results: list[~ignos.api.client.models.MeasurementFormInstanceDto]
    :ivar continuation_token:
    :vartype continuation_token: str
    """

    _validation = {
        "results": {"required": True},
    }

    _attribute_map = {
        "results": {"key": "results", "type": "[MeasurementFormInstanceDto]"},
        "continuation_token": {"key": "continuationToken", "type": "str"},
    }

    def __init__(
        self, *, results: List["_models.MeasurementFormInstanceDto"], continuation_token: Optional[str] = None, **kwargs
    ):
        """
        :keyword results: Required.
        :paramtype results: list[~ignos.api.client.models.MeasurementFormInstanceDto]
        :keyword continuation_token:
        :paramtype continuation_token: str
        """
        super().__init__(**kwargs)
        self.results = results
        self.continuation_token = continuation_token


class MeasurementFormInstanceElementDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormInstanceElementDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar image_url:
    :vartype image_url: str
    :ivar thumbnail_url:
    :vartype thumbnail_url: str
    :ivar balloon_id:
    :vartype balloon_id: str
    :ivar section:
    :vartype section: str
    :ivar page_number:
    :vartype page_number: int
    :ivar sheet_zone:
    :vartype sheet_zone: str
    :ivar completed: Required.
    :vartype completed: bool
    :ivar places:
    :vartype places: int
    :ivar nominal:
    :vartype nominal: str
    :ivar type:
    :vartype type: str
    :ivar sub_type:
    :vartype sub_type: str
    :ivar unit_of_measure:
    :vartype unit_of_measure: str
    :ivar type_character:
    :vartype type_character: str
    :ivar upper_limit:
    :vartype upper_limit: float
    :ivar lower_limit:
    :vartype lower_limit: float
    :ivar comments:
    :vartype comments: str
    :ivar updated_by_user:
    :vartype updated_by_user: str
    :ivar updated_date:
    :vartype updated_date: ~datetime.datetime
    :ivar created_by_user:
    :vartype created_by_user: str
    :ivar created_date:
    :vartype created_date: ~datetime.datetime
    :ivar frequency: Required. Known values are: "All", "FirstArticle", "NFirst", "NPercent",
     "ISO2859", "Nth", and "None".
    :vartype frequency: str or ~ignos.api.client.models.MeasurementFrequency
    :ivar frequency_parameter:
    :vartype frequency_parameter: int
    :ivar include_in_customer_documentation: Required.
    :vartype include_in_customer_documentation: bool
    :ivar balloon_sequence:
    :vartype balloon_sequence: int
    :ivar balloon_quantity:
    :vartype balloon_quantity: int
    :ivar plus_tolerance:
    :vartype plus_tolerance: str
    :ivar minus_tolerance:
    :vartype minus_tolerance: str
    :ivar coating_thickness:
    :vartype coating_thickness: int
    :ivar can_copy: Required.
    :vartype can_copy: bool
    :ivar value_type: Required. Known values are: "None", "Bool", "Decimal", and "String".
    :vartype value_type: str or ~ignos.api.client.models.MeasurementFormValueType
    :ivar bonus_type: Required. Known values are: "None", "Positive", and "PositiveAndNegative".
    :vartype bonus_type: str or ~ignos.api.client.models.BonusType
    :ivar lower_warning_threshold:
    :vartype lower_warning_threshold: float
    :ivar upper_warning_threshold:
    :vartype upper_warning_threshold: float
    :ivar machining_dimension:
    :vartype machining_dimension: float
    :ivar minimum_decimals:
    :vartype minimum_decimals: int
    :ivar maximum_decimals: Required.
    :vartype maximum_decimals: int
    :ivar machining_dimensions:
    :vartype machining_dimensions: float
    :ivar values: Required.
    :vartype values: list[~ignos.api.client.models.MeasurementFormElementValueDto]
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "completed": {"required": True},
        "frequency": {"required": True},
        "include_in_customer_documentation": {"required": True},
        "can_copy": {"required": True},
        "value_type": {"required": True},
        "bonus_type": {"required": True},
        "maximum_decimals": {"required": True},
        "values": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "image_url": {"key": "imageUrl", "type": "str"},
        "thumbnail_url": {"key": "thumbnailUrl", "type": "str"},
        "balloon_id": {"key": "balloonId", "type": "str"},
        "section": {"key": "section", "type": "str"},
        "page_number": {"key": "pageNumber", "type": "int"},
        "sheet_zone": {"key": "sheetZone", "type": "str"},
        "completed": {"key": "completed", "type": "bool"},
        "places": {"key": "places", "type": "int"},
        "nominal": {"key": "nominal", "type": "str"},
        "type": {"key": "type", "type": "str"},
        "sub_type": {"key": "subType", "type": "str"},
        "unit_of_measure": {"key": "unitOfMeasure", "type": "str"},
        "type_character": {"key": "typeCharacter", "type": "str"},
        "upper_limit": {"key": "upperLimit", "type": "float"},
        "lower_limit": {"key": "lowerLimit", "type": "float"},
        "comments": {"key": "comments", "type": "str"},
        "updated_by_user": {"key": "updatedByUser", "type": "str"},
        "updated_date": {"key": "updatedDate", "type": "iso-8601"},
        "created_by_user": {"key": "createdByUser", "type": "str"},
        "created_date": {"key": "createdDate", "type": "iso-8601"},
        "frequency": {"key": "frequency", "type": "str"},
        "frequency_parameter": {"key": "frequencyParameter", "type": "int"},
        "include_in_customer_documentation": {"key": "includeInCustomerDocumentation", "type": "bool"},
        "balloon_sequence": {"key": "balloonSequence", "type": "int"},
        "balloon_quantity": {"key": "balloonQuantity", "type": "int"},
        "plus_tolerance": {"key": "plusTolerance", "type": "str"},
        "minus_tolerance": {"key": "minusTolerance", "type": "str"},
        "coating_thickness": {"key": "coatingThickness", "type": "int"},
        "can_copy": {"key": "canCopy", "type": "bool"},
        "value_type": {"key": "valueType", "type": "str"},
        "bonus_type": {"key": "bonusType", "type": "str"},
        "lower_warning_threshold": {"key": "lowerWarningThreshold", "type": "float"},
        "upper_warning_threshold": {"key": "upperWarningThreshold", "type": "float"},
        "machining_dimension": {"key": "machiningDimension", "type": "float"},
        "minimum_decimals": {"key": "minimumDecimals", "type": "int"},
        "maximum_decimals": {"key": "maximumDecimals", "type": "int"},
        "machining_dimensions": {"key": "machiningDimensions", "type": "float"},
        "values": {"key": "values", "type": "[MeasurementFormElementValueDto]"},
    }

    def __init__(  # pylint: disable=too-many-locals
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        completed: bool,
        frequency: Union[str, "_models.MeasurementFrequency"],
        include_in_customer_documentation: bool,
        can_copy: bool,
        value_type: Union[str, "_models.MeasurementFormValueType"],
        bonus_type: Union[str, "_models.BonusType"],
        maximum_decimals: int,
        values: List["_models.MeasurementFormElementValueDto"],
        image_url: Optional[str] = None,
        thumbnail_url: Optional[str] = None,
        balloon_id: Optional[str] = None,
        section: Optional[str] = None,
        page_number: Optional[int] = None,
        sheet_zone: Optional[str] = None,
        places: Optional[int] = None,
        nominal: Optional[str] = None,
        type: Optional[str] = None,
        sub_type: Optional[str] = None,
        unit_of_measure: Optional[str] = None,
        type_character: Optional[str] = None,
        upper_limit: Optional[float] = None,
        lower_limit: Optional[float] = None,
        comments: Optional[str] = None,
        updated_by_user: Optional[str] = None,
        updated_date: Optional[datetime.datetime] = None,
        created_by_user: Optional[str] = None,
        created_date: Optional[datetime.datetime] = None,
        frequency_parameter: Optional[int] = None,
        balloon_sequence: Optional[int] = None,
        balloon_quantity: Optional[int] = None,
        plus_tolerance: Optional[str] = None,
        minus_tolerance: Optional[str] = None,
        coating_thickness: Optional[int] = None,
        lower_warning_threshold: Optional[float] = None,
        upper_warning_threshold: Optional[float] = None,
        machining_dimension: Optional[float] = None,
        minimum_decimals: Optional[int] = None,
        machining_dimensions: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword image_url:
        :paramtype image_url: str
        :keyword thumbnail_url:
        :paramtype thumbnail_url: str
        :keyword balloon_id:
        :paramtype balloon_id: str
        :keyword section:
        :paramtype section: str
        :keyword page_number:
        :paramtype page_number: int
        :keyword sheet_zone:
        :paramtype sheet_zone: str
        :keyword completed: Required.
        :paramtype completed: bool
        :keyword places:
        :paramtype places: int
        :keyword nominal:
        :paramtype nominal: str
        :keyword type:
        :paramtype type: str
        :keyword sub_type:
        :paramtype sub_type: str
        :keyword unit_of_measure:
        :paramtype unit_of_measure: str
        :keyword type_character:
        :paramtype type_character: str
        :keyword upper_limit:
        :paramtype upper_limit: float
        :keyword lower_limit:
        :paramtype lower_limit: float
        :keyword comments:
        :paramtype comments: str
        :keyword updated_by_user:
        :paramtype updated_by_user: str
        :keyword updated_date:
        :paramtype updated_date: ~datetime.datetime
        :keyword created_by_user:
        :paramtype created_by_user: str
        :keyword created_date:
        :paramtype created_date: ~datetime.datetime
        :keyword frequency: Required. Known values are: "All", "FirstArticle", "NFirst", "NPercent",
         "ISO2859", "Nth", and "None".
        :paramtype frequency: str or ~ignos.api.client.models.MeasurementFrequency
        :keyword frequency_parameter:
        :paramtype frequency_parameter: int
        :keyword include_in_customer_documentation: Required.
        :paramtype include_in_customer_documentation: bool
        :keyword balloon_sequence:
        :paramtype balloon_sequence: int
        :keyword balloon_quantity:
        :paramtype balloon_quantity: int
        :keyword plus_tolerance:
        :paramtype plus_tolerance: str
        :keyword minus_tolerance:
        :paramtype minus_tolerance: str
        :keyword coating_thickness:
        :paramtype coating_thickness: int
        :keyword can_copy: Required.
        :paramtype can_copy: bool
        :keyword value_type: Required. Known values are: "None", "Bool", "Decimal", and "String".
        :paramtype value_type: str or ~ignos.api.client.models.MeasurementFormValueType
        :keyword bonus_type: Required. Known values are: "None", "Positive", and "PositiveAndNegative".
        :paramtype bonus_type: str or ~ignos.api.client.models.BonusType
        :keyword lower_warning_threshold:
        :paramtype lower_warning_threshold: float
        :keyword upper_warning_threshold:
        :paramtype upper_warning_threshold: float
        :keyword machining_dimension:
        :paramtype machining_dimension: float
        :keyword minimum_decimals:
        :paramtype minimum_decimals: int
        :keyword maximum_decimals: Required.
        :paramtype maximum_decimals: int
        :keyword machining_dimensions:
        :paramtype machining_dimensions: float
        :keyword values: Required.
        :paramtype values: list[~ignos.api.client.models.MeasurementFormElementValueDto]
        """
        super().__init__(**kwargs)
        self.id = id
        self.image_url = image_url
        self.thumbnail_url = thumbnail_url
        self.balloon_id = balloon_id
        self.section = section
        self.page_number = page_number
        self.sheet_zone = sheet_zone
        self.completed = completed
        self.places = places
        self.nominal = nominal
        self.type = type
        self.sub_type = sub_type
        self.unit_of_measure = unit_of_measure
        self.type_character = type_character
        self.upper_limit = upper_limit
        self.lower_limit = lower_limit
        self.comments = comments
        self.updated_by_user = updated_by_user
        self.updated_date = updated_date
        self.created_by_user = created_by_user
        self.created_date = created_date
        self.frequency = frequency
        self.frequency_parameter = frequency_parameter
        self.include_in_customer_documentation = include_in_customer_documentation
        self.balloon_sequence = balloon_sequence
        self.balloon_quantity = balloon_quantity
        self.plus_tolerance = plus_tolerance
        self.minus_tolerance = minus_tolerance
        self.coating_thickness = coating_thickness
        self.can_copy = can_copy
        self.value_type = value_type
        self.bonus_type = bonus_type
        self.lower_warning_threshold = lower_warning_threshold
        self.upper_warning_threshold = upper_warning_threshold
        self.machining_dimension = machining_dimension
        self.minimum_decimals = minimum_decimals
        self.maximum_decimals = maximum_decimals
        self.machining_dimensions = machining_dimensions
        self.values = values


class MeasurementFormInstanceOverviewDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormInstanceOverviewDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar readonly: Required.
    :vartype readonly: bool
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar drawing_url:
    :vartype drawing_url: str
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar quantity: Required.
    :vartype quantity: int
    :ivar validation_rule_id:
    :vartype validation_rule_id: str
    :ivar status: Required. Known values are: "Active", "Cancelled", "Completed", and "Approved".
    :vartype status: str or ~ignos.api.client.models.MeasurementFormInstanceStatus
    :ivar schemas: Required.
    :vartype schemas: list[~ignos.api.client.models.MeasurementFormInstanceSchemaOverviewDto]
    :ivar supplier_data:
    :vartype supplier_data: ~ignos.api.client.models.MeasurementFormInstanceSupplierDto
    :ivar progress: Required.
    :vartype progress: ~ignos.api.client.models.MeasurementFormProgressDto
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "readonly": {"required": True},
        "quantity": {"required": True},
        "status": {"required": True},
        "schemas": {"required": True},
        "progress": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "readonly": {"key": "readonly", "type": "bool"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "drawing_url": {"key": "drawingUrl", "type": "str"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "quantity": {"key": "quantity", "type": "int"},
        "validation_rule_id": {"key": "validationRuleId", "type": "str"},
        "status": {"key": "status", "type": "str"},
        "schemas": {"key": "schemas", "type": "[MeasurementFormInstanceSchemaOverviewDto]"},
        "supplier_data": {"key": "supplierData", "type": "MeasurementFormInstanceSupplierDto"},
        "progress": {"key": "progress", "type": "MeasurementFormProgressDto"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        readonly: bool,
        quantity: int,
        status: Union[str, "_models.MeasurementFormInstanceStatus"],
        schemas: List["_models.MeasurementFormInstanceSchemaOverviewDto"],
        progress: "_models.MeasurementFormProgressDto",
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        drawing_url: Optional[str] = None,
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        validation_rule_id: Optional[str] = None,
        supplier_data: Optional["_models.MeasurementFormInstanceSupplierDto"] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword readonly: Required.
        :paramtype readonly: bool
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword drawing_url:
        :paramtype drawing_url: str
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword quantity: Required.
        :paramtype quantity: int
        :keyword validation_rule_id:
        :paramtype validation_rule_id: str
        :keyword status: Required. Known values are: "Active", "Cancelled", "Completed", and
         "Approved".
        :paramtype status: str or ~ignos.api.client.models.MeasurementFormInstanceStatus
        :keyword schemas: Required.
        :paramtype schemas: list[~ignos.api.client.models.MeasurementFormInstanceSchemaOverviewDto]
        :keyword supplier_data:
        :paramtype supplier_data: ~ignos.api.client.models.MeasurementFormInstanceSupplierDto
        :keyword progress: Required.
        :paramtype progress: ~ignos.api.client.models.MeasurementFormProgressDto
        """
        super().__init__(**kwargs)
        self.id = id
        self.readonly = readonly
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.drawing_url = drawing_url
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.quantity = quantity
        self.validation_rule_id = validation_rule_id
        self.status = status
        self.schemas = schemas
        self.supplier_data = supplier_data
        self.progress = progress


class MeasurementFormInstanceOverviewDtoPagedResult(_serialization.Model):
    """MeasurementFormInstanceOverviewDtoPagedResult.

    All required parameters must be populated in order to send to Azure.

    :ivar results: Required.
    :vartype results: list[~ignos.api.client.models.MeasurementFormInstanceOverviewDto]
    :ivar continuation_token:
    :vartype continuation_token: str
    """

    _validation = {
        "results": {"required": True},
    }

    _attribute_map = {
        "results": {"key": "results", "type": "[MeasurementFormInstanceOverviewDto]"},
        "continuation_token": {"key": "continuationToken", "type": "str"},
    }

    def __init__(
        self,
        *,
        results: List["_models.MeasurementFormInstanceOverviewDto"],
        continuation_token: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword results: Required.
        :paramtype results: list[~ignos.api.client.models.MeasurementFormInstanceOverviewDto]
        :keyword continuation_token:
        :paramtype continuation_token: str
        """
        super().__init__(**kwargs)
        self.results = results
        self.continuation_token = continuation_token


class MeasurementFormInstanceProgressDto(_serialization.Model):
    """MeasurementFormInstanceProgressDto.

    :ivar progress:
    :vartype progress: ~ignos.api.client.models.MeasurementFormProgressDto
    :ivar schemas:
    :vartype schemas: list[~ignos.api.client.models.MeasurementFormProgressDto]
    """

    _attribute_map = {
        "progress": {"key": "progress", "type": "MeasurementFormProgressDto"},
        "schemas": {"key": "schemas", "type": "[MeasurementFormProgressDto]"},
    }

    def __init__(
        self,
        *,
        progress: Optional["_models.MeasurementFormProgressDto"] = None,
        schemas: Optional[List["_models.MeasurementFormProgressDto"]] = None,
        **kwargs
    ):
        """
        :keyword progress:
        :paramtype progress: ~ignos.api.client.models.MeasurementFormProgressDto
        :keyword schemas:
        :paramtype schemas: list[~ignos.api.client.models.MeasurementFormProgressDto]
        """
        super().__init__(**kwargs)
        self.progress = progress
        self.schemas = schemas


class MeasurementFormInstanceSchemaDto(_serialization.Model):
    """MeasurementFormInstanceSchemaDto.

    All required parameters must be populated in order to send to Azure.

    :ivar elements: Required.
    :vartype elements: list[~ignos.api.client.models.MeasurementFormInstanceElementDto]
    :ivar is_completed: Required.
    :vartype is_completed: bool
    :ivar comment:
    :vartype comment: str
    """

    _validation = {
        "elements": {"required": True},
        "is_completed": {"required": True},
    }

    _attribute_map = {
        "elements": {"key": "elements", "type": "[MeasurementFormInstanceElementDto]"},
        "is_completed": {"key": "isCompleted", "type": "bool"},
        "comment": {"key": "comment", "type": "str"},
    }

    def __init__(
        self,
        *,
        elements: List["_models.MeasurementFormInstanceElementDto"],
        is_completed: bool,
        comment: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword elements: Required.
        :paramtype elements: list[~ignos.api.client.models.MeasurementFormInstanceElementDto]
        :keyword is_completed: Required.
        :paramtype is_completed: bool
        :keyword comment:
        :paramtype comment: str
        """
        super().__init__(**kwargs)
        self.elements = elements
        self.is_completed = is_completed
        self.comment = comment


class MeasurementFormInstanceSchemaOverviewDto(_serialization.Model):
    """MeasurementFormInstanceSchemaOverviewDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
    }

    def __init__(self, *, id: str, **kwargs):  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: str
        """
        super().__init__(**kwargs)
        self.id = id


class MeasurementFormInstanceSupplierDto(_serialization.Model):
    """MeasurementFormInstanceSupplierDto.

    All required parameters must be populated in order to send to Azure.

    :ivar supplier_id: Required.
    :vartype supplier_id: str
    :ivar supplier_name:
    :vartype supplier_name: str
    :ivar available:
    :vartype available: bool
    :ivar procurement_order:
    :vartype procurement_order: str
    :ivar procurement_line:
    :vartype procurement_line: int
    :ivar external_order_number:
    :vartype external_order_number: str
    """

    _validation = {
        "supplier_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "supplier_id": {"key": "supplierId", "type": "str"},
        "supplier_name": {"key": "supplierName", "type": "str"},
        "available": {"key": "available", "type": "bool"},
        "procurement_order": {"key": "procurementOrder", "type": "str"},
        "procurement_line": {"key": "procurementLine", "type": "int"},
        "external_order_number": {"key": "externalOrderNumber", "type": "str"},
    }

    def __init__(
        self,
        *,
        supplier_id: str,
        supplier_name: Optional[str] = None,
        available: Optional[bool] = None,
        procurement_order: Optional[str] = None,
        procurement_line: Optional[int] = None,
        external_order_number: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword supplier_id: Required.
        :paramtype supplier_id: str
        :keyword supplier_name:
        :paramtype supplier_name: str
        :keyword available:
        :paramtype available: bool
        :keyword procurement_order:
        :paramtype procurement_order: str
        :keyword procurement_line:
        :paramtype procurement_line: int
        :keyword external_order_number:
        :paramtype external_order_number: str
        """
        super().__init__(**kwargs)
        self.supplier_id = supplier_id
        self.supplier_name = supplier_name
        self.available = available
        self.procurement_order = procurement_order
        self.procurement_line = procurement_line
        self.external_order_number = external_order_number


class MeasurementFormLinkedSchemaDto(_serialization.Model):
    """MeasurementFormLinkedSchemaDto.

    All required parameters must be populated in order to send to Azure.

    :ivar customer_id:
    :vartype customer_id: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing: Required.
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar latest_released_schema_id: Required.
    :vartype latest_released_schema_id: str
    """

    _validation = {
        "drawing": {"required": True, "min_length": 1},
        "schema_id": {"required": True, "min_length": 1},
        "latest_released_schema_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "customer_id": {"key": "customerId", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "schema_id": {"key": "schemaId", "type": "str"},
        "latest_released_schema_id": {"key": "latestReleasedSchemaId", "type": "str"},
    }

    def __init__(
        self,
        *,
        drawing: str,
        schema_id: str,
        latest_released_schema_id: str,
        customer_id: Optional[str] = None,
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing: Required.
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword latest_released_schema_id: Required.
        :paramtype latest_released_schema_id: str
        """
        super().__init__(**kwargs)
        self.customer_id = customer_id
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.schema_id = schema_id
        self.latest_released_schema_id = latest_released_schema_id


class MeasurementFormListDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormListDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar version_id: Required.
    :vartype version_id: int
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing: Required.
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar created_by: Required.
    :vartype created_by: str
    :ivar created: Required.
    :vartype created: ~datetime.datetime
    :ivar status: Required. Known values are: "Draft", "Released", and "Revoked".
    :vartype status: str or ~ignos.api.client.models.MeasurementFormStatus
    :ivar source: Required. Known values are: "Unknown", "InspectionXpert", "Excel", and "Manual".
    :vartype source: str or ~ignos.api.client.models.MeasurementFormSource
    :ivar validation_rule: Required.
    :vartype validation_rule: ~ignos.api.client.models.ValidationRuleDto
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "schema_id": {"required": True, "min_length": 1},
        "version_id": {"required": True},
        "drawing": {"required": True, "min_length": 1},
        "created_by": {"required": True, "min_length": 1},
        "created": {"required": True},
        "status": {"required": True},
        "source": {"required": True},
        "validation_rule": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "schema_id": {"key": "schemaId", "type": "str"},
        "version_id": {"key": "versionId", "type": "int"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "created_by": {"key": "createdBy", "type": "str"},
        "created": {"key": "created", "type": "iso-8601"},
        "status": {"key": "status", "type": "str"},
        "source": {"key": "source", "type": "str"},
        "validation_rule": {"key": "validationRule", "type": "ValidationRuleDto"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        schema_id: str,
        version_id: int,
        drawing: str,
        created_by: str,
        created: datetime.datetime,
        status: Union[str, "_models.MeasurementFormStatus"],
        source: Union[str, "_models.MeasurementFormSource"],
        validation_rule: "_models.ValidationRuleDto",
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword version_id: Required.
        :paramtype version_id: int
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing: Required.
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword created_by: Required.
        :paramtype created_by: str
        :keyword created: Required.
        :paramtype created: ~datetime.datetime
        :keyword status: Required. Known values are: "Draft", "Released", and "Revoked".
        :paramtype status: str or ~ignos.api.client.models.MeasurementFormStatus
        :keyword source: Required. Known values are: "Unknown", "InspectionXpert", "Excel", and
         "Manual".
        :paramtype source: str or ~ignos.api.client.models.MeasurementFormSource
        :keyword validation_rule: Required.
        :paramtype validation_rule: ~ignos.api.client.models.ValidationRuleDto
        """
        super().__init__(**kwargs)
        self.id = id
        self.schema_id = schema_id
        self.version_id = version_id
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.created_by = created_by
        self.created = created
        self.status = status
        self.source = source
        self.validation_rule = validation_rule


class MeasurementFormListDtoPagedResult(_serialization.Model):
    """MeasurementFormListDtoPagedResult.

    All required parameters must be populated in order to send to Azure.

    :ivar results: Required.
    :vartype results: list[~ignos.api.client.models.MeasurementFormListDto]
    :ivar continuation_token:
    :vartype continuation_token: str
    """

    _validation = {
        "results": {"required": True},
    }

    _attribute_map = {
        "results": {"key": "results", "type": "[MeasurementFormListDto]"},
        "continuation_token": {"key": "continuationToken", "type": "str"},
    }

    def __init__(
        self, *, results: List["_models.MeasurementFormListDto"], continuation_token: Optional[str] = None, **kwargs
    ):
        """
        :keyword results: Required.
        :paramtype results: list[~ignos.api.client.models.MeasurementFormListDto]
        :keyword continuation_token:
        :paramtype continuation_token: str
        """
        super().__init__(**kwargs)
        self.results = results
        self.continuation_token = continuation_token


class MeasurementFormMappingDto(_serialization.Model):
    """MeasurementFormMappingDto.

    Variables are only populated by the server, and will be ignored when sending a request.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar measurement_schema_source_id: Required.
    :vartype measurement_schema_source_id: str
    :ivar measurement_schema_target_id: Required.
    :vartype measurement_schema_target_id: str
    :ivar source_balloons: Required.
    :vartype source_balloons: list[~ignos.api.client.models.MeasurementFormBalloonMappingDto]
    :ivar target_balloons: Required.
    :vartype target_balloons: list[~ignos.api.client.models.MeasurementFormBalloonMappingDto]
    """

    _validation = {
        "id": {"required": True, "readonly": True, "min_length": 1},
        "measurement_schema_source_id": {"required": True, "readonly": True, "min_length": 1},
        "measurement_schema_target_id": {"required": True, "readonly": True, "min_length": 1},
        "source_balloons": {"required": True, "readonly": True},
        "target_balloons": {"required": True, "readonly": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "measurement_schema_source_id": {"key": "measurementSchemaSourceId", "type": "str"},
        "measurement_schema_target_id": {"key": "measurementSchemaTargetId", "type": "str"},
        "source_balloons": {"key": "sourceBalloons", "type": "[MeasurementFormBalloonMappingDto]"},
        "target_balloons": {"key": "targetBalloons", "type": "[MeasurementFormBalloonMappingDto]"},
    }

    def __init__(self, **kwargs):
        """ """
        super().__init__(**kwargs)
        self.id = None
        self.measurement_schema_source_id = None
        self.measurement_schema_target_id = None
        self.source_balloons = None
        self.target_balloons = None


class MeasurementFormMappingSuggestionDto(_serialization.Model):
    """MeasurementFormMappingSuggestionDto.

    Variables are only populated by the server, and will be ignored when sending a request.

    All required parameters must be populated in order to send to Azure.

    :ivar measurement_schema_source_id: Required.
    :vartype measurement_schema_source_id: str
    :ivar measurement_schema_target_id: Required.
    :vartype measurement_schema_target_id: str
    :ivar source_balloons: Required.
    :vartype source_balloons: list[~ignos.api.client.models.MeasurementFormBalloonMappingDto]
    :ivar target_balloons: Required.
    :vartype target_balloons: list[~ignos.api.client.models.MeasurementFormBalloonMappingDto]
    """

    _validation = {
        "measurement_schema_source_id": {"required": True, "min_length": 1},
        "measurement_schema_target_id": {"required": True, "min_length": 1},
        "source_balloons": {"required": True, "readonly": True},
        "target_balloons": {"required": True, "readonly": True},
    }

    _attribute_map = {
        "measurement_schema_source_id": {"key": "measurementSchemaSourceId", "type": "str"},
        "measurement_schema_target_id": {"key": "measurementSchemaTargetId", "type": "str"},
        "source_balloons": {"key": "sourceBalloons", "type": "[MeasurementFormBalloonMappingDto]"},
        "target_balloons": {"key": "targetBalloons", "type": "[MeasurementFormBalloonMappingDto]"},
    }

    def __init__(self, *, measurement_schema_source_id: str, measurement_schema_target_id: str, **kwargs):
        """
        :keyword measurement_schema_source_id: Required.
        :paramtype measurement_schema_source_id: str
        :keyword measurement_schema_target_id: Required.
        :paramtype measurement_schema_target_id: str
        """
        super().__init__(**kwargs)
        self.measurement_schema_source_id = measurement_schema_source_id
        self.measurement_schema_target_id = measurement_schema_target_id
        self.source_balloons = None
        self.target_balloons = None


class MeasurementFormNeedDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormNeedDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar requirement_date: Required.
    :vartype requirement_date: ~datetime.datetime
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar workorder:
    :vartype workorder: str
    :ivar operation:
    :vartype operation: int
    :ivar resource:
    :vartype resource: str
    :ivar assigned_to:
    :vartype assigned_to: ~ignos.api.client.models.UserDto
    :ivar is_generated_requirement: Required.
    :vartype is_generated_requirement: bool
    :ivar measurement_schema_id:
    :vartype measurement_schema_id: str
    :ivar drawing_url:
    :vartype drawing_url: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "requirement_date": {"required": True},
        "is_generated_requirement": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "requirement_date": {"key": "requirementDate", "type": "iso-8601"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "workorder": {"key": "workorder", "type": "str"},
        "operation": {"key": "operation", "type": "int"},
        "resource": {"key": "resource", "type": "str"},
        "assigned_to": {"key": "assignedTo", "type": "UserDto"},
        "is_generated_requirement": {"key": "isGeneratedRequirement", "type": "bool"},
        "measurement_schema_id": {"key": "measurementSchemaId", "type": "str"},
        "drawing_url": {"key": "drawingUrl", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        requirement_date: datetime.datetime,
        is_generated_requirement: bool,
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        workorder: Optional[str] = None,
        operation: Optional[int] = None,
        resource: Optional[str] = None,
        assigned_to: Optional["_models.UserDto"] = None,
        measurement_schema_id: Optional[str] = None,
        drawing_url: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword requirement_date: Required.
        :paramtype requirement_date: ~datetime.datetime
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword workorder:
        :paramtype workorder: str
        :keyword operation:
        :paramtype operation: int
        :keyword resource:
        :paramtype resource: str
        :keyword assigned_to:
        :paramtype assigned_to: ~ignos.api.client.models.UserDto
        :keyword is_generated_requirement: Required.
        :paramtype is_generated_requirement: bool
        :keyword measurement_schema_id:
        :paramtype measurement_schema_id: str
        :keyword drawing_url:
        :paramtype drawing_url: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.requirement_date = requirement_date
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.workorder = workorder
        self.operation = operation
        self.resource = resource
        self.assigned_to = assigned_to
        self.is_generated_requirement = is_generated_requirement
        self.measurement_schema_id = measurement_schema_id
        self.drawing_url = drawing_url


class MeasurementFormNeedDtoPagedResult(_serialization.Model):
    """MeasurementFormNeedDtoPagedResult.

    All required parameters must be populated in order to send to Azure.

    :ivar results: Required.
    :vartype results: list[~ignos.api.client.models.MeasurementFormNeedDto]
    :ivar continuation_token:
    :vartype continuation_token: str
    """

    _validation = {
        "results": {"required": True},
    }

    _attribute_map = {
        "results": {"key": "results", "type": "[MeasurementFormNeedDto]"},
        "continuation_token": {"key": "continuationToken", "type": "str"},
    }

    def __init__(
        self, *, results: List["_models.MeasurementFormNeedDto"], continuation_token: Optional[str] = None, **kwargs
    ):
        """
        :keyword results: Required.
        :paramtype results: list[~ignos.api.client.models.MeasurementFormNeedDto]
        :keyword continuation_token:
        :paramtype continuation_token: str
        """
        super().__init__(**kwargs)
        self.results = results
        self.continuation_token = continuation_token


class MeasurementFormProgressDto(_serialization.Model):
    """MeasurementFormProgressDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar required_values: Required.
    :vartype required_values: int
    :ivar values: Required.
    :vartype values: int
    :ivar progress: Required.
    :vartype progress: float
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "required_values": {"required": True},
        "values": {"required": True},
        "progress": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "required_values": {"key": "requiredValues", "type": "int"},
        "values": {"key": "values", "type": "int"},
        "progress": {"key": "progress", "type": "float"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        required_values: int,
        values: int,
        progress: float,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword required_values: Required.
        :paramtype required_values: int
        :keyword values: Required.
        :paramtype values: int
        :keyword progress: Required.
        :paramtype progress: float
        """
        super().__init__(**kwargs)
        self.id = id
        self.required_values = required_values
        self.values = values
        self.progress = progress


class MeasurementFormResourceTypeGeneratorDto(_serialization.Model):
    """MeasurementFormResourceTypeGeneratorDto.

    All required parameters must be populated in order to send to Azure.

    :ivar resource_type: Required.
    :vartype resource_type: str
    """

    _validation = {
        "resource_type": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "resource_type": {"key": "resourceType", "type": "str"},
    }

    def __init__(self, *, resource_type: str, **kwargs):
        """
        :keyword resource_type: Required.
        :paramtype resource_type: str
        """
        super().__init__(**kwargs)
        self.resource_type = resource_type


class MeasurementFormSchemaAttachmentDto(_serialization.Model):
    """MeasurementFormSchemaAttachmentDto.

    All required parameters must be populated in order to send to Azure.

    :ivar url: Required.
    :vartype url: str
    :ivar title: Required.
    :vartype title: str
    """

    _validation = {
        "url": {"required": True, "min_length": 1},
        "title": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "url": {"key": "url", "type": "str"},
        "title": {"key": "title", "type": "str"},
    }

    def __init__(self, *, url: str, title: str, **kwargs):
        """
        :keyword url: Required.
        :paramtype url: str
        :keyword title: Required.
        :paramtype title: str
        """
        super().__init__(**kwargs)
        self.url = url
        self.title = title


class MeasurementFormSchemaDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormSchemaDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar version_id: Required.
    :vartype version_id: int
    :ivar part_number: Required.
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar drawing_url:
    :vartype drawing_url: str
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar exclude_from_customer_documentation: Required.
    :vartype exclude_from_customer_documentation: bool
    :ivar specification:
    :vartype specification: str
    :ivar is_used: Required.
    :vartype is_used: bool
    :ivar status: Required. Known values are: "Draft", "Released", and "Revoked".
    :vartype status: str or ~ignos.api.client.models.MeasurementFormStatus
    :ivar source: Required. Known values are: "Unknown", "InspectionXpert", "Excel", and "Manual".
    :vartype source: str or ~ignos.api.client.models.MeasurementFormSource
    :ivar marked_drawing_url:
    :vartype marked_drawing_url: str
    :ivar project_file_url:
    :vartype project_file_url: str
    :ivar attachments: Required.
    :vartype attachments: list[~ignos.api.client.models.MeasurementFormSchemaAttachmentDto]
    :ivar grouped_elements: Required.
    :vartype grouped_elements: list[~ignos.api.client.models.MeasurementFormGroupedElementDto]
    :ivar extra_schemas: Required.
    :vartype extra_schemas: list[~ignos.api.client.models.MeasurementFormLinkedSchemaDto]
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "version_id": {"required": True},
        "part_number": {"required": True, "min_length": 1},
        "exclude_from_customer_documentation": {"required": True},
        "is_used": {"required": True},
        "status": {"required": True},
        "source": {"required": True},
        "attachments": {"required": True},
        "grouped_elements": {"required": True},
        "extra_schemas": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "version_id": {"key": "versionId", "type": "int"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "drawing_url": {"key": "drawingUrl", "type": "str"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "exclude_from_customer_documentation": {"key": "excludeFromCustomerDocumentation", "type": "bool"},
        "specification": {"key": "specification", "type": "str"},
        "is_used": {"key": "isUsed", "type": "bool"},
        "status": {"key": "status", "type": "str"},
        "source": {"key": "source", "type": "str"},
        "marked_drawing_url": {"key": "markedDrawingUrl", "type": "str"},
        "project_file_url": {"key": "projectFileUrl", "type": "str"},
        "attachments": {"key": "attachments", "type": "[MeasurementFormSchemaAttachmentDto]"},
        "grouped_elements": {"key": "groupedElements", "type": "[MeasurementFormGroupedElementDto]"},
        "extra_schemas": {"key": "extraSchemas", "type": "[MeasurementFormLinkedSchemaDto]"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        version_id: int,
        part_number: str,
        exclude_from_customer_documentation: bool,
        is_used: bool,
        status: Union[str, "_models.MeasurementFormStatus"],
        source: Union[str, "_models.MeasurementFormSource"],
        attachments: List["_models.MeasurementFormSchemaAttachmentDto"],
        grouped_elements: List["_models.MeasurementFormGroupedElementDto"],
        extra_schemas: List["_models.MeasurementFormLinkedSchemaDto"],
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        drawing_url: Optional[str] = None,
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        specification: Optional[str] = None,
        marked_drawing_url: Optional[str] = None,
        project_file_url: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword version_id: Required.
        :paramtype version_id: int
        :keyword part_number: Required.
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword drawing_url:
        :paramtype drawing_url: str
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword exclude_from_customer_documentation: Required.
        :paramtype exclude_from_customer_documentation: bool
        :keyword specification:
        :paramtype specification: str
        :keyword is_used: Required.
        :paramtype is_used: bool
        :keyword status: Required. Known values are: "Draft", "Released", and "Revoked".
        :paramtype status: str or ~ignos.api.client.models.MeasurementFormStatus
        :keyword source: Required. Known values are: "Unknown", "InspectionXpert", "Excel", and
         "Manual".
        :paramtype source: str or ~ignos.api.client.models.MeasurementFormSource
        :keyword marked_drawing_url:
        :paramtype marked_drawing_url: str
        :keyword project_file_url:
        :paramtype project_file_url: str
        :keyword attachments: Required.
        :paramtype attachments: list[~ignos.api.client.models.MeasurementFormSchemaAttachmentDto]
        :keyword grouped_elements: Required.
        :paramtype grouped_elements: list[~ignos.api.client.models.MeasurementFormGroupedElementDto]
        :keyword extra_schemas: Required.
        :paramtype extra_schemas: list[~ignos.api.client.models.MeasurementFormLinkedSchemaDto]
        """
        super().__init__(**kwargs)
        self.id = id
        self.version_id = version_id
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.drawing_url = drawing_url
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.exclude_from_customer_documentation = exclude_from_customer_documentation
        self.specification = specification
        self.is_used = is_used
        self.status = status
        self.source = source
        self.marked_drawing_url = marked_drawing_url
        self.project_file_url = project_file_url
        self.attachments = attachments
        self.grouped_elements = grouped_elements
        self.extra_schemas = extra_schemas


class MeasurementFormSchemaNotNeededDto(_serialization.Model):
    """MeasurementFormSchemaNotNeededDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar comment:
    :vartype comment: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "comment": {"key": "comment", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        comment: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword comment:
        :paramtype comment: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.comment = comment


class MeasurementFormSchemaNotNeededDtoPagedResult(_serialization.Model):
    """MeasurementFormSchemaNotNeededDtoPagedResult.

    All required parameters must be populated in order to send to Azure.

    :ivar results: Required.
    :vartype results: list[~ignos.api.client.models.MeasurementFormSchemaNotNeededDto]
    :ivar continuation_token:
    :vartype continuation_token: str
    """

    _validation = {
        "results": {"required": True},
    }

    _attribute_map = {
        "results": {"key": "results", "type": "[MeasurementFormSchemaNotNeededDto]"},
        "continuation_token": {"key": "continuationToken", "type": "str"},
    }

    def __init__(
        self,
        *,
        results: List["_models.MeasurementFormSchemaNotNeededDto"],
        continuation_token: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword results: Required.
        :paramtype results: list[~ignos.api.client.models.MeasurementFormSchemaNotNeededDto]
        :keyword continuation_token:
        :paramtype continuation_token: str
        """
        super().__init__(**kwargs)
        self.results = results
        self.continuation_token = continuation_token


class MeasurementFormSettingsDto(_serialization.Model):
    """MeasurementFormSettingsDto.

    All required parameters must be populated in order to send to Azure.

    :ivar convert_inch_to_mm: Required.
    :vartype convert_inch_to_mm: bool
    :ivar validate_measuring_tools: Required.
    :vartype validate_measuring_tools: bool
    :ivar validate_measuring_tools_for_suppliers: Required.
    :vartype validate_measuring_tools_for_suppliers: bool
    :ivar generate_schema_requirements: Required.
    :vartype generate_schema_requirements: bool
    :ivar generate_schema_instances: Required.
    :vartype generate_schema_instances: bool
    :ivar auto_complete_schema_instances: Required.
    :vartype auto_complete_schema_instances: bool
    :ivar generate_report_for_approved_instances: Required.
    :vartype generate_report_for_approved_instances: bool
    :ivar resource_types_blocking_auto_workflow:
    :vartype resource_types_blocking_auto_workflow: list[str]
    """

    _validation = {
        "convert_inch_to_mm": {"required": True},
        "validate_measuring_tools": {"required": True},
        "validate_measuring_tools_for_suppliers": {"required": True},
        "generate_schema_requirements": {"required": True},
        "generate_schema_instances": {"required": True},
        "auto_complete_schema_instances": {"required": True},
        "generate_report_for_approved_instances": {"required": True},
    }

    _attribute_map = {
        "convert_inch_to_mm": {"key": "convertInchToMm", "type": "bool"},
        "validate_measuring_tools": {"key": "validateMeasuringTools", "type": "bool"},
        "validate_measuring_tools_for_suppliers": {"key": "validateMeasuringToolsForSuppliers", "type": "bool"},
        "generate_schema_requirements": {"key": "generateSchemaRequirements", "type": "bool"},
        "generate_schema_instances": {"key": "generateSchemaInstances", "type": "bool"},
        "auto_complete_schema_instances": {"key": "autoCompleteSchemaInstances", "type": "bool"},
        "generate_report_for_approved_instances": {"key": "generateReportForApprovedInstances", "type": "bool"},
        "resource_types_blocking_auto_workflow": {"key": "resourceTypesBlockingAutoWorkflow", "type": "[str]"},
    }

    def __init__(
        self,
        *,
        convert_inch_to_mm: bool,
        validate_measuring_tools: bool,
        validate_measuring_tools_for_suppliers: bool,
        generate_schema_requirements: bool,
        generate_schema_instances: bool,
        auto_complete_schema_instances: bool,
        generate_report_for_approved_instances: bool,
        resource_types_blocking_auto_workflow: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword convert_inch_to_mm: Required.
        :paramtype convert_inch_to_mm: bool
        :keyword validate_measuring_tools: Required.
        :paramtype validate_measuring_tools: bool
        :keyword validate_measuring_tools_for_suppliers: Required.
        :paramtype validate_measuring_tools_for_suppliers: bool
        :keyword generate_schema_requirements: Required.
        :paramtype generate_schema_requirements: bool
        :keyword generate_schema_instances: Required.
        :paramtype generate_schema_instances: bool
        :keyword auto_complete_schema_instances: Required.
        :paramtype auto_complete_schema_instances: bool
        :keyword generate_report_for_approved_instances: Required.
        :paramtype generate_report_for_approved_instances: bool
        :keyword resource_types_blocking_auto_workflow:
        :paramtype resource_types_blocking_auto_workflow: list[str]
        """
        super().__init__(**kwargs)
        self.convert_inch_to_mm = convert_inch_to_mm
        self.validate_measuring_tools = validate_measuring_tools
        self.validate_measuring_tools_for_suppliers = validate_measuring_tools_for_suppliers
        self.generate_schema_requirements = generate_schema_requirements
        self.generate_schema_instances = generate_schema_instances
        self.auto_complete_schema_instances = auto_complete_schema_instances
        self.generate_report_for_approved_instances = generate_report_for_approved_instances
        self.resource_types_blocking_auto_workflow = resource_types_blocking_auto_workflow


class MeasurementFormSupplierAccessInstanceDto(_serialization.Model):
    """MeasurementFormSupplierAccessInstanceDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar readonly: Required.
    :vartype readonly: bool
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar customer_id:
    :vartype customer_id: str
    :ivar quantity: Required.
    :vartype quantity: int
    :ivar status: Required. Known values are: "Active", "Cancelled", "Completed", and "Approved".
    :vartype status: str or ~ignos.api.client.models.MeasurementFormInstanceStatus
    :ivar suppliers: Required.
    :vartype suppliers: list[~ignos.api.client.models.MeasurementFormWorkorderSupplierDto]
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "readonly": {"required": True},
        "quantity": {"required": True},
        "status": {"required": True},
        "suppliers": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "readonly": {"key": "readonly", "type": "bool"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "customer_id": {"key": "customerId", "type": "str"},
        "quantity": {"key": "quantity", "type": "int"},
        "status": {"key": "status", "type": "str"},
        "suppliers": {"key": "suppliers", "type": "[MeasurementFormWorkorderSupplierDto]"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        readonly: bool,
        quantity: int,
        status: Union[str, "_models.MeasurementFormInstanceStatus"],
        suppliers: List["_models.MeasurementFormWorkorderSupplierDto"],
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        customer_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword readonly: Required.
        :paramtype readonly: bool
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword quantity: Required.
        :paramtype quantity: int
        :keyword status: Required. Known values are: "Active", "Cancelled", "Completed", and
         "Approved".
        :paramtype status: str or ~ignos.api.client.models.MeasurementFormInstanceStatus
        :keyword suppliers: Required.
        :paramtype suppliers: list[~ignos.api.client.models.MeasurementFormWorkorderSupplierDto]
        """
        super().__init__(**kwargs)
        self.id = id
        self.readonly = readonly
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.customer_id = customer_id
        self.quantity = quantity
        self.status = status
        self.suppliers = suppliers


class MeasurementFormToolValueDto(_serialization.Model):
    """MeasurementFormToolValueDto.

    All required parameters must be populated in order to send to Azure.

    :ivar tool: Required.
    :vartype tool: str
    :ivar type:
    :vartype type: str
    :ivar sub_type:
    :vartype sub_type: str
    """

    _validation = {
        "tool": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "tool": {"key": "tool", "type": "str"},
        "type": {"key": "type", "type": "str"},
        "sub_type": {"key": "subType", "type": "str"},
    }

    def __init__(self, *, tool: str, type: Optional[str] = None, sub_type: Optional[str] = None, **kwargs):
        """
        :keyword tool: Required.
        :paramtype tool: str
        :keyword type:
        :paramtype type: str
        :keyword sub_type:
        :paramtype sub_type: str
        """
        super().__init__(**kwargs)
        self.tool = tool
        self.type = type
        self.sub_type = sub_type


class MeasurementFormVersionImportDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormVersionImportDto.

    All required parameters must be populated in order to send to Azure.

    :ivar version: Required.
    :vartype version: int
    :ivar specification:
    :vartype specification: str
    :ivar drawing_url:
    :vartype drawing_url: str
    :ivar marked_drawing_url:
    :vartype marked_drawing_url: str
    :ivar xml_url:
    :vartype xml_url: str
    :ivar inspection_xpert_project_url:
    :vartype inspection_xpert_project_url: str
    :ivar created: Required.
    :vartype created: ~datetime.datetime
    :ivar created_by: Required.
    :vartype created_by: str
    :ivar updated:
    :vartype updated: ~datetime.datetime
    :ivar updated_by:
    :vartype updated_by: str
    :ivar elements: Required.
    :vartype elements: list[~ignos.api.client.models.MeasurementFormElementImportDto]
    :ivar is_used: Required.
    :vartype is_used: bool
    """

    _validation = {
        "version": {"required": True},
        "created": {"required": True},
        "created_by": {"required": True, "min_length": 1},
        "elements": {"required": True},
        "is_used": {"required": True},
    }

    _attribute_map = {
        "version": {"key": "version", "type": "int"},
        "specification": {"key": "specification", "type": "str"},
        "drawing_url": {"key": "drawingUrl", "type": "str"},
        "marked_drawing_url": {"key": "markedDrawingUrl", "type": "str"},
        "xml_url": {"key": "xmlUrl", "type": "str"},
        "inspection_xpert_project_url": {"key": "inspectionXpertProjectUrl", "type": "str"},
        "created": {"key": "created", "type": "iso-8601"},
        "created_by": {"key": "createdBy", "type": "str"},
        "updated": {"key": "updated", "type": "iso-8601"},
        "updated_by": {"key": "updatedBy", "type": "str"},
        "elements": {"key": "elements", "type": "[MeasurementFormElementImportDto]"},
        "is_used": {"key": "isUsed", "type": "bool"},
    }

    def __init__(
        self,
        *,
        version: int,
        created: datetime.datetime,
        created_by: str,
        elements: List["_models.MeasurementFormElementImportDto"],
        is_used: bool,
        specification: Optional[str] = None,
        drawing_url: Optional[str] = None,
        marked_drawing_url: Optional[str] = None,
        xml_url: Optional[str] = None,
        inspection_xpert_project_url: Optional[str] = None,
        updated: Optional[datetime.datetime] = None,
        updated_by: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword version: Required.
        :paramtype version: int
        :keyword specification:
        :paramtype specification: str
        :keyword drawing_url:
        :paramtype drawing_url: str
        :keyword marked_drawing_url:
        :paramtype marked_drawing_url: str
        :keyword xml_url:
        :paramtype xml_url: str
        :keyword inspection_xpert_project_url:
        :paramtype inspection_xpert_project_url: str
        :keyword created: Required.
        :paramtype created: ~datetime.datetime
        :keyword created_by: Required.
        :paramtype created_by: str
        :keyword updated:
        :paramtype updated: ~datetime.datetime
        :keyword updated_by:
        :paramtype updated_by: str
        :keyword elements: Required.
        :paramtype elements: list[~ignos.api.client.models.MeasurementFormElementImportDto]
        :keyword is_used: Required.
        :paramtype is_used: bool
        """
        super().__init__(**kwargs)
        self.version = version
        self.specification = specification
        self.drawing_url = drawing_url
        self.marked_drawing_url = marked_drawing_url
        self.xml_url = xml_url
        self.inspection_xpert_project_url = inspection_xpert_project_url
        self.created = created
        self.created_by = created_by
        self.updated = updated
        self.updated_by = updated_by
        self.elements = elements
        self.is_used = is_used


class MeasurementFormWorkorderSchemaDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasurementFormWorkorderSchemaDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar customer_id:
    :vartype customer_id: str
    :ivar drawing_url:
    :vartype drawing_url: str
    :ivar marked_drawing_url:
    :vartype marked_drawing_url: str
    :ivar exclude_from_customer_documentation: Required.
    :vartype exclude_from_customer_documentation: bool
    :ivar version_id: Required.
    :vartype version_id: int
    :ivar specification:
    :vartype specification: str
    :ivar progress: Required.
    :vartype progress: ~ignos.api.client.models.MeasurementFormProgressDto
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "exclude_from_customer_documentation": {"required": True},
        "version_id": {"required": True},
        "progress": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "customer_id": {"key": "customerId", "type": "str"},
        "drawing_url": {"key": "drawingUrl", "type": "str"},
        "marked_drawing_url": {"key": "markedDrawingUrl", "type": "str"},
        "exclude_from_customer_documentation": {"key": "excludeFromCustomerDocumentation", "type": "bool"},
        "version_id": {"key": "versionId", "type": "int"},
        "specification": {"key": "specification", "type": "str"},
        "progress": {"key": "progress", "type": "MeasurementFormProgressDto"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        exclude_from_customer_documentation: bool,
        version_id: int,
        progress: "_models.MeasurementFormProgressDto",
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        customer_id: Optional[str] = None,
        drawing_url: Optional[str] = None,
        marked_drawing_url: Optional[str] = None,
        specification: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword drawing_url:
        :paramtype drawing_url: str
        :keyword marked_drawing_url:
        :paramtype marked_drawing_url: str
        :keyword exclude_from_customer_documentation: Required.
        :paramtype exclude_from_customer_documentation: bool
        :keyword version_id: Required.
        :paramtype version_id: int
        :keyword specification:
        :paramtype specification: str
        :keyword progress: Required.
        :paramtype progress: ~ignos.api.client.models.MeasurementFormProgressDto
        """
        super().__init__(**kwargs)
        self.id = id
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.customer_id = customer_id
        self.drawing_url = drawing_url
        self.marked_drawing_url = marked_drawing_url
        self.exclude_from_customer_documentation = exclude_from_customer_documentation
        self.version_id = version_id
        self.specification = specification
        self.progress = progress


class MeasurementFormWorkorderSequenceDto(_serialization.Model):
    """MeasurementFormWorkorderSequenceDto.

    All required parameters must be populated in order to send to Azure.

    :ivar lot:
    :vartype lot: str
    :ivar sequence: Required.
    :vartype sequence: str
    :ivar serial_number:
    :vartype serial_number: str
    """

    _validation = {
        "sequence": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "lot": {"key": "lot", "type": "str"},
        "sequence": {"key": "sequence", "type": "str"},
        "serial_number": {"key": "serialNumber", "type": "str"},
    }

    def __init__(self, *, sequence: str, lot: Optional[str] = None, serial_number: Optional[str] = None, **kwargs):
        """
        :keyword lot:
        :paramtype lot: str
        :keyword sequence: Required.
        :paramtype sequence: str
        :keyword serial_number:
        :paramtype serial_number: str
        """
        super().__init__(**kwargs)
        self.lot = lot
        self.sequence = sequence
        self.serial_number = serial_number


class MeasurementFormWorkorderSupplierDto(_serialization.Model):
    """MeasurementFormWorkorderSupplierDto.

    All required parameters must be populated in order to send to Azure.

    :ivar supplier_id: Required.
    :vartype supplier_id: str
    :ivar supplier_name:
    :vartype supplier_name: str
    :ivar available:
    :vartype available: bool
    :ivar procurement_order:
    :vartype procurement_order: str
    :ivar procurement_line:
    :vartype procurement_line: int
    :ivar external_order_number:
    :vartype external_order_number: str
    """

    _validation = {
        "supplier_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "supplier_id": {"key": "supplierId", "type": "str"},
        "supplier_name": {"key": "supplierName", "type": "str"},
        "available": {"key": "available", "type": "bool"},
        "procurement_order": {"key": "procurementOrder", "type": "str"},
        "procurement_line": {"key": "procurementLine", "type": "int"},
        "external_order_number": {"key": "externalOrderNumber", "type": "str"},
    }

    def __init__(
        self,
        *,
        supplier_id: str,
        supplier_name: Optional[str] = None,
        available: Optional[bool] = None,
        procurement_order: Optional[str] = None,
        procurement_line: Optional[int] = None,
        external_order_number: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword supplier_id: Required.
        :paramtype supplier_id: str
        :keyword supplier_name:
        :paramtype supplier_name: str
        :keyword available:
        :paramtype available: bool
        :keyword procurement_order:
        :paramtype procurement_order: str
        :keyword procurement_line:
        :paramtype procurement_line: int
        :keyword external_order_number:
        :paramtype external_order_number: str
        """
        super().__init__(**kwargs)
        self.supplier_id = supplier_id
        self.supplier_name = supplier_name
        self.available = available
        self.procurement_order = procurement_order
        self.procurement_line = procurement_line
        self.external_order_number = external_order_number


class MeasurementFrequencyDto(_serialization.Model):
    """MeasurementFrequencyDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: int
    :ivar name: Required.
    :vartype name: str
    """

    _validation = {
        "id": {"required": True},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "int"},
        "name": {"key": "name", "type": "str"},
    }

    def __init__(self, *, id: int, name: str, **kwargs):  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: int
        :keyword name: Required.
        :paramtype name: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name


class MeasuringToolCalibrationDto(_serialization.Model):
    """MeasuringToolCalibrationDto.

    All required parameters must be populated in order to send to Azure.

    :ivar calibration_date: Required.
    :vartype calibration_date: ~datetime.datetime
    :ivar next_calibration_date: Required.
    :vartype next_calibration_date: ~datetime.datetime
    :ivar report_type:
    :vartype report_type: str
    :ivar calibration_location:
    :vartype calibration_location: str
    :ivar calibration_certificate_number:
    :vartype calibration_certificate_number: str
    :ivar adjusted: Required.
    :vartype adjusted: bool
    :ivar calibration_certificate_url:
    :vartype calibration_certificate_url: str
    """

    _validation = {
        "calibration_date": {"required": True},
        "next_calibration_date": {"required": True},
        "adjusted": {"required": True},
    }

    _attribute_map = {
        "calibration_date": {"key": "calibrationDate", "type": "iso-8601"},
        "next_calibration_date": {"key": "nextCalibrationDate", "type": "iso-8601"},
        "report_type": {"key": "reportType", "type": "str"},
        "calibration_location": {"key": "calibrationLocation", "type": "str"},
        "calibration_certificate_number": {"key": "calibrationCertificateNumber", "type": "str"},
        "adjusted": {"key": "adjusted", "type": "bool"},
        "calibration_certificate_url": {"key": "calibrationCertificateUrl", "type": "str"},
    }

    def __init__(
        self,
        *,
        calibration_date: datetime.datetime,
        next_calibration_date: datetime.datetime,
        adjusted: bool,
        report_type: Optional[str] = None,
        calibration_location: Optional[str] = None,
        calibration_certificate_number: Optional[str] = None,
        calibration_certificate_url: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword calibration_date: Required.
        :paramtype calibration_date: ~datetime.datetime
        :keyword next_calibration_date: Required.
        :paramtype next_calibration_date: ~datetime.datetime
        :keyword report_type:
        :paramtype report_type: str
        :keyword calibration_location:
        :paramtype calibration_location: str
        :keyword calibration_certificate_number:
        :paramtype calibration_certificate_number: str
        :keyword adjusted: Required.
        :paramtype adjusted: bool
        :keyword calibration_certificate_url:
        :paramtype calibration_certificate_url: str
        """
        super().__init__(**kwargs)
        self.calibration_date = calibration_date
        self.next_calibration_date = next_calibration_date
        self.report_type = report_type
        self.calibration_location = calibration_location
        self.calibration_certificate_number = calibration_certificate_number
        self.adjusted = adjusted
        self.calibration_certificate_url = calibration_certificate_url


class MeasuringToolCalibrationImportDto(_serialization.Model):
    """MeasuringToolCalibrationImportDto.

    All required parameters must be populated in order to send to Azure.

    :ivar created: Required.
    :vartype created: ~datetime.datetime
    :ivar created_by: Required.
    :vartype created_by: str
    :ivar calibration_date: Required.
    :vartype calibration_date: ~datetime.datetime
    :ivar next_calibration_date: Required.
    :vartype next_calibration_date: ~datetime.datetime
    :ivar report_type:
    :vartype report_type: str
    :ivar calibration_location:
    :vartype calibration_location: str
    :ivar calibration_certificate_number:
    :vartype calibration_certificate_number: str
    :ivar adjusted: Required.
    :vartype adjusted: bool
    :ivar calibration_certificate_url:
    :vartype calibration_certificate_url: str
    """

    _validation = {
        "created": {"required": True},
        "created_by": {"required": True, "min_length": 1},
        "calibration_date": {"required": True},
        "next_calibration_date": {"required": True},
        "adjusted": {"required": True},
    }

    _attribute_map = {
        "created": {"key": "created", "type": "iso-8601"},
        "created_by": {"key": "createdBy", "type": "str"},
        "calibration_date": {"key": "calibrationDate", "type": "iso-8601"},
        "next_calibration_date": {"key": "nextCalibrationDate", "type": "iso-8601"},
        "report_type": {"key": "reportType", "type": "str"},
        "calibration_location": {"key": "calibrationLocation", "type": "str"},
        "calibration_certificate_number": {"key": "calibrationCertificateNumber", "type": "str"},
        "adjusted": {"key": "adjusted", "type": "bool"},
        "calibration_certificate_url": {"key": "calibrationCertificateUrl", "type": "str"},
    }

    def __init__(
        self,
        *,
        created: datetime.datetime,
        created_by: str,
        calibration_date: datetime.datetime,
        next_calibration_date: datetime.datetime,
        adjusted: bool,
        report_type: Optional[str] = None,
        calibration_location: Optional[str] = None,
        calibration_certificate_number: Optional[str] = None,
        calibration_certificate_url: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword created: Required.
        :paramtype created: ~datetime.datetime
        :keyword created_by: Required.
        :paramtype created_by: str
        :keyword calibration_date: Required.
        :paramtype calibration_date: ~datetime.datetime
        :keyword next_calibration_date: Required.
        :paramtype next_calibration_date: ~datetime.datetime
        :keyword report_type:
        :paramtype report_type: str
        :keyword calibration_location:
        :paramtype calibration_location: str
        :keyword calibration_certificate_number:
        :paramtype calibration_certificate_number: str
        :keyword adjusted: Required.
        :paramtype adjusted: bool
        :keyword calibration_certificate_url:
        :paramtype calibration_certificate_url: str
        """
        super().__init__(**kwargs)
        self.created = created
        self.created_by = created_by
        self.calibration_date = calibration_date
        self.next_calibration_date = next_calibration_date
        self.report_type = report_type
        self.calibration_location = calibration_location
        self.calibration_certificate_number = calibration_certificate_number
        self.adjusted = adjusted
        self.calibration_certificate_url = calibration_certificate_url


class MeasuringToolDetailDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasuringToolDetailDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar tool_id: Required.
    :vartype tool_id: str
    :ivar name: Required.
    :vartype name: str
    :ivar manufacturer: Required.
    :vartype manufacturer: ~ignos.api.client.models.ManufacturerDto
    :ivar type: Required.
    :vartype type: ~ignos.api.client.models.MeasuringToolTypeDto
    :ivar sub_type:
    :vartype sub_type: ~ignos.api.client.models.MeasuringToolSubTypeDto
    :ivar unit:
    :vartype unit: ~ignos.api.client.models.MeasuringUnitDto
    :ivar default_location:
    :vartype default_location: str
    :ivar min:
    :vartype min: float
    :ivar max:
    :vartype max: float
    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar serial_number:
    :vartype serial_number: str
    :ivar precision:
    :vartype precision: str
    :ivar last_calibration_date:
    :vartype last_calibration_date: ~datetime.datetime
    :ivar next_calibration_date:
    :vartype next_calibration_date: ~datetime.datetime
    :ivar deprecated_date:
    :vartype deprecated_date: ~datetime.datetime
    :ivar last_location:
    :vartype last_location: str
    :ivar last_location_date:
    :vartype last_location_date: ~datetime.datetime
    :ivar calibration_status: Required. Known values are: "Uncalibrated", "Deprecated", "Expired",
     "SoonDue", and "Valid".
    :vartype calibration_status: str or ~ignos.api.client.models.CalibrationStatusDto
    """

    _validation = {
        "id": {"required": True},
        "tool_id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "manufacturer": {"required": True},
        "type": {"required": True},
        "calibration_status": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "tool_id": {"key": "toolId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "manufacturer": {"key": "manufacturer", "type": "ManufacturerDto"},
        "type": {"key": "type", "type": "MeasuringToolTypeDto"},
        "sub_type": {"key": "subType", "type": "MeasuringToolSubTypeDto"},
        "unit": {"key": "unit", "type": "MeasuringUnitDto"},
        "default_location": {"key": "defaultLocation", "type": "str"},
        "min": {"key": "min", "type": "float"},
        "max": {"key": "max", "type": "float"},
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "serial_number": {"key": "serialNumber", "type": "str"},
        "precision": {"key": "precision", "type": "str"},
        "last_calibration_date": {"key": "lastCalibrationDate", "type": "iso-8601"},
        "next_calibration_date": {"key": "nextCalibrationDate", "type": "iso-8601"},
        "deprecated_date": {"key": "deprecatedDate", "type": "iso-8601"},
        "last_location": {"key": "lastLocation", "type": "str"},
        "last_location_date": {"key": "lastLocationDate", "type": "iso-8601"},
        "calibration_status": {"key": "calibrationStatus", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        tool_id: str,
        name: str,
        manufacturer: "_models.ManufacturerDto",
        type: "_models.MeasuringToolTypeDto",
        calibration_status: Union[str, "_models.CalibrationStatusDto"],
        sub_type: Optional["_models.MeasuringToolSubTypeDto"] = None,
        unit: Optional["_models.MeasuringUnitDto"] = None,
        default_location: Optional[str] = None,
        min: Optional[float] = None,  # pylint: disable=redefined-builtin
        max: Optional[float] = None,  # pylint: disable=redefined-builtin
        calibration_interval: Optional[int] = None,
        serial_number: Optional[str] = None,
        precision: Optional[str] = None,
        last_calibration_date: Optional[datetime.datetime] = None,
        next_calibration_date: Optional[datetime.datetime] = None,
        deprecated_date: Optional[datetime.datetime] = None,
        last_location: Optional[str] = None,
        last_location_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword tool_id: Required.
        :paramtype tool_id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword manufacturer: Required.
        :paramtype manufacturer: ~ignos.api.client.models.ManufacturerDto
        :keyword type: Required.
        :paramtype type: ~ignos.api.client.models.MeasuringToolTypeDto
        :keyword sub_type:
        :paramtype sub_type: ~ignos.api.client.models.MeasuringToolSubTypeDto
        :keyword unit:
        :paramtype unit: ~ignos.api.client.models.MeasuringUnitDto
        :keyword default_location:
        :paramtype default_location: str
        :keyword min:
        :paramtype min: float
        :keyword max:
        :paramtype max: float
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword serial_number:
        :paramtype serial_number: str
        :keyword precision:
        :paramtype precision: str
        :keyword last_calibration_date:
        :paramtype last_calibration_date: ~datetime.datetime
        :keyword next_calibration_date:
        :paramtype next_calibration_date: ~datetime.datetime
        :keyword deprecated_date:
        :paramtype deprecated_date: ~datetime.datetime
        :keyword last_location:
        :paramtype last_location: str
        :keyword last_location_date:
        :paramtype last_location_date: ~datetime.datetime
        :keyword calibration_status: Required. Known values are: "Uncalibrated", "Deprecated",
         "Expired", "SoonDue", and "Valid".
        :paramtype calibration_status: str or ~ignos.api.client.models.CalibrationStatusDto
        """
        super().__init__(**kwargs)
        self.id = id
        self.tool_id = tool_id
        self.name = name
        self.manufacturer = manufacturer
        self.type = type
        self.sub_type = sub_type
        self.unit = unit
        self.default_location = default_location
        self.min = min
        self.max = max
        self.calibration_interval = calibration_interval
        self.serial_number = serial_number
        self.precision = precision
        self.last_calibration_date = last_calibration_date
        self.next_calibration_date = next_calibration_date
        self.deprecated_date = deprecated_date
        self.last_location = last_location
        self.last_location_date = last_location_date
        self.calibration_status = calibration_status


class MeasuringToolDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MeasuringToolDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar tool_id: Required.
    :vartype tool_id: str
    :ivar name: Required.
    :vartype name: str
    :ivar manufacturer: Required.
    :vartype manufacturer: str
    :ivar type: Required.
    :vartype type: str
    :ivar type_id: Required.
    :vartype type_id: str
    :ivar sub_type:
    :vartype sub_type: str
    :ivar sub_type_id:
    :vartype sub_type_id: str
    :ivar unit:
    :vartype unit: str
    :ivar min:
    :vartype min: float
    :ivar max:
    :vartype max: float
    :ivar last_calibration_date:
    :vartype last_calibration_date: ~datetime.datetime
    :ivar next_calibration_date:
    :vartype next_calibration_date: ~datetime.datetime
    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar deprecated_date:
    :vartype deprecated_date: ~datetime.datetime
    :ivar last_location:
    :vartype last_location: str
    :ivar last_location_date:
    :vartype last_location_date: ~datetime.datetime
    :ivar calibration_status: Required. Known values are: "Uncalibrated", "Deprecated", "Expired",
     "SoonDue", and "Valid".
    :vartype calibration_status: str or ~ignos.api.client.models.CalibrationStatusDto
    """

    _validation = {
        "id": {"required": True},
        "tool_id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "manufacturer": {"required": True, "min_length": 1},
        "type": {"required": True, "min_length": 1},
        "type_id": {"required": True},
        "calibration_status": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "tool_id": {"key": "toolId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "manufacturer": {"key": "manufacturer", "type": "str"},
        "type": {"key": "type", "type": "str"},
        "type_id": {"key": "typeId", "type": "str"},
        "sub_type": {"key": "subType", "type": "str"},
        "sub_type_id": {"key": "subTypeId", "type": "str"},
        "unit": {"key": "unit", "type": "str"},
        "min": {"key": "min", "type": "float"},
        "max": {"key": "max", "type": "float"},
        "last_calibration_date": {"key": "lastCalibrationDate", "type": "iso-8601"},
        "next_calibration_date": {"key": "nextCalibrationDate", "type": "iso-8601"},
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "deprecated_date": {"key": "deprecatedDate", "type": "iso-8601"},
        "last_location": {"key": "lastLocation", "type": "str"},
        "last_location_date": {"key": "lastLocationDate", "type": "iso-8601"},
        "calibration_status": {"key": "calibrationStatus", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        tool_id: str,
        name: str,
        manufacturer: str,
        type: str,
        type_id: str,
        calibration_status: Union[str, "_models.CalibrationStatusDto"],
        sub_type: Optional[str] = None,
        sub_type_id: Optional[str] = None,
        unit: Optional[str] = None,
        min: Optional[float] = None,  # pylint: disable=redefined-builtin
        max: Optional[float] = None,  # pylint: disable=redefined-builtin
        last_calibration_date: Optional[datetime.datetime] = None,
        next_calibration_date: Optional[datetime.datetime] = None,
        calibration_interval: Optional[int] = None,
        deprecated_date: Optional[datetime.datetime] = None,
        last_location: Optional[str] = None,
        last_location_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword tool_id: Required.
        :paramtype tool_id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword manufacturer: Required.
        :paramtype manufacturer: str
        :keyword type: Required.
        :paramtype type: str
        :keyword type_id: Required.
        :paramtype type_id: str
        :keyword sub_type:
        :paramtype sub_type: str
        :keyword sub_type_id:
        :paramtype sub_type_id: str
        :keyword unit:
        :paramtype unit: str
        :keyword min:
        :paramtype min: float
        :keyword max:
        :paramtype max: float
        :keyword last_calibration_date:
        :paramtype last_calibration_date: ~datetime.datetime
        :keyword next_calibration_date:
        :paramtype next_calibration_date: ~datetime.datetime
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword deprecated_date:
        :paramtype deprecated_date: ~datetime.datetime
        :keyword last_location:
        :paramtype last_location: str
        :keyword last_location_date:
        :paramtype last_location_date: ~datetime.datetime
        :keyword calibration_status: Required. Known values are: "Uncalibrated", "Deprecated",
         "Expired", "SoonDue", and "Valid".
        :paramtype calibration_status: str or ~ignos.api.client.models.CalibrationStatusDto
        """
        super().__init__(**kwargs)
        self.id = id
        self.tool_id = tool_id
        self.name = name
        self.manufacturer = manufacturer
        self.type = type
        self.type_id = type_id
        self.sub_type = sub_type
        self.sub_type_id = sub_type_id
        self.unit = unit
        self.min = min
        self.max = max
        self.last_calibration_date = last_calibration_date
        self.next_calibration_date = next_calibration_date
        self.calibration_interval = calibration_interval
        self.deprecated_date = deprecated_date
        self.last_location = last_location
        self.last_location_date = last_location_date
        self.calibration_status = calibration_status


class MeasuringToolDtoPagedData(_serialization.Model):
    """MeasuringToolDtoPagedData.

    All required parameters must be populated in order to send to Azure.

    :ivar page_number: Required.
    :vartype page_number: int
    :ivar page_size: Required.
    :vartype page_size: int
    :ivar total_number_of_pages: Required.
    :vartype total_number_of_pages: int
    :ivar total_number_of_records: Required.
    :vartype total_number_of_records: int
    :ivar next_page_url:
    :vartype next_page_url: str
    :ivar value: Required.
    :vartype value: list[~ignos.api.client.models.MeasuringToolDto]
    """

    _validation = {
        "page_number": {"required": True},
        "page_size": {"required": True},
        "total_number_of_pages": {"required": True},
        "total_number_of_records": {"required": True},
        "value": {"required": True},
    }

    _attribute_map = {
        "page_number": {"key": "pageNumber", "type": "int"},
        "page_size": {"key": "pageSize", "type": "int"},
        "total_number_of_pages": {"key": "totalNumberOfPages", "type": "int"},
        "total_number_of_records": {"key": "totalNumberOfRecords", "type": "int"},
        "next_page_url": {"key": "nextPageUrl", "type": "str"},
        "value": {"key": "value", "type": "[MeasuringToolDto]"},
    }

    def __init__(
        self,
        *,
        page_number: int,
        page_size: int,
        total_number_of_pages: int,
        total_number_of_records: int,
        value: List["_models.MeasuringToolDto"],
        next_page_url: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword page_number: Required.
        :paramtype page_number: int
        :keyword page_size: Required.
        :paramtype page_size: int
        :keyword total_number_of_pages: Required.
        :paramtype total_number_of_pages: int
        :keyword total_number_of_records: Required.
        :paramtype total_number_of_records: int
        :keyword next_page_url:
        :paramtype next_page_url: str
        :keyword value: Required.
        :paramtype value: list[~ignos.api.client.models.MeasuringToolDto]
        """
        super().__init__(**kwargs)
        self.page_number = page_number
        self.page_size = page_size
        self.total_number_of_pages = total_number_of_pages
        self.total_number_of_records = total_number_of_records
        self.next_page_url = next_page_url
        self.value = value


class MeasuringToolSubTypeDto(_serialization.Model):
    """MeasuringToolSubTypeDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name: Required.
    :vartype name: str
    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar max_number_of_usages_between_calibration:
    :vartype max_number_of_usages_between_calibration: int
    """

    _validation = {
        "id": {"required": True},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "max_number_of_usages_between_calibration": {"key": "maxNumberOfUsagesBetweenCalibration", "type": "int"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        name: str,
        calibration_interval: Optional[int] = None,
        max_number_of_usages_between_calibration: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword max_number_of_usages_between_calibration:
        :paramtype max_number_of_usages_between_calibration: int
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name
        self.calibration_interval = calibration_interval
        self.max_number_of_usages_between_calibration = max_number_of_usages_between_calibration


class MeasuringToolTypeDto(_serialization.Model):
    """MeasuringToolTypeDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name: Required.
    :vartype name: str
    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar max_number_of_usages_between_calibration:
    :vartype max_number_of_usages_between_calibration: int
    """

    _validation = {
        "id": {"required": True},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "max_number_of_usages_between_calibration": {"key": "maxNumberOfUsagesBetweenCalibration", "type": "int"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        name: str,
        calibration_interval: Optional[int] = None,
        max_number_of_usages_between_calibration: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword max_number_of_usages_between_calibration:
        :paramtype max_number_of_usages_between_calibration: int
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name
        self.calibration_interval = calibration_interval
        self.max_number_of_usages_between_calibration = max_number_of_usages_between_calibration


class MeasuringToolWhitelistDto(_serialization.Model):
    """MeasuringToolWhitelistDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar value: Required.
    :vartype value: str
    :ivar description: Required.
    :vartype description: str
    """

    _validation = {
        "id": {"required": True},
        "value": {"required": True, "min_length": 1},
        "description": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "value": {"key": "value", "type": "str"},
        "description": {"key": "description", "type": "str"},
    }

    def __init__(self, *, id: str, value: str, description: str, **kwargs):  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword value: Required.
        :paramtype value: str
        :keyword description: Required.
        :paramtype description: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.value = value
        self.description = description


class MeasuringToolWhitelistDtoPagedData(_serialization.Model):
    """MeasuringToolWhitelistDtoPagedData.

    All required parameters must be populated in order to send to Azure.

    :ivar page_number: Required.
    :vartype page_number: int
    :ivar page_size: Required.
    :vartype page_size: int
    :ivar total_number_of_pages: Required.
    :vartype total_number_of_pages: int
    :ivar total_number_of_records: Required.
    :vartype total_number_of_records: int
    :ivar next_page_url:
    :vartype next_page_url: str
    :ivar value: Required.
    :vartype value: list[~ignos.api.client.models.MeasuringToolWhitelistDto]
    """

    _validation = {
        "page_number": {"required": True},
        "page_size": {"required": True},
        "total_number_of_pages": {"required": True},
        "total_number_of_records": {"required": True},
        "value": {"required": True},
    }

    _attribute_map = {
        "page_number": {"key": "pageNumber", "type": "int"},
        "page_size": {"key": "pageSize", "type": "int"},
        "total_number_of_pages": {"key": "totalNumberOfPages", "type": "int"},
        "total_number_of_records": {"key": "totalNumberOfRecords", "type": "int"},
        "next_page_url": {"key": "nextPageUrl", "type": "str"},
        "value": {"key": "value", "type": "[MeasuringToolWhitelistDto]"},
    }

    def __init__(
        self,
        *,
        page_number: int,
        page_size: int,
        total_number_of_pages: int,
        total_number_of_records: int,
        value: List["_models.MeasuringToolWhitelistDto"],
        next_page_url: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword page_number: Required.
        :paramtype page_number: int
        :keyword page_size: Required.
        :paramtype page_size: int
        :keyword total_number_of_pages: Required.
        :paramtype total_number_of_pages: int
        :keyword total_number_of_records: Required.
        :paramtype total_number_of_records: int
        :keyword next_page_url:
        :paramtype next_page_url: str
        :keyword value: Required.
        :paramtype value: list[~ignos.api.client.models.MeasuringToolWhitelistDto]
        """
        super().__init__(**kwargs)
        self.page_number = page_number
        self.page_size = page_size
        self.total_number_of_pages = total_number_of_pages
        self.total_number_of_records = total_number_of_records
        self.next_page_url = next_page_url
        self.value = value


class MeasuringUnitDto(_serialization.Model):
    """MeasuringUnitDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar unit: Required.
    :vartype unit: str
    """

    _validation = {
        "id": {"required": True},
        "unit": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "unit": {"key": "unit", "type": "str"},
    }

    def __init__(self, *, id: str, unit: str, **kwargs):  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword unit: Required.
        :paramtype unit: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.unit = unit


class NumericDataPointDto(_serialization.Model):
    """NumericDataPointDto.

    :ivar timestamp:
    :vartype timestamp: int
    :ivar value:
    :vartype value: float
    :ivar average:
    :vartype average: float
    :ivar min:
    :vartype min: float
    :ivar max:
    :vartype max: float
    """

    _attribute_map = {
        "timestamp": {"key": "timestamp", "type": "int"},
        "value": {"key": "value", "type": "float"},
        "average": {"key": "average", "type": "float"},
        "min": {"key": "min", "type": "float"},
        "max": {"key": "max", "type": "float"},
    }

    def __init__(
        self,
        *,
        timestamp: Optional[int] = None,
        value: Optional[float] = None,
        average: Optional[float] = None,
        min: Optional[float] = None,  # pylint: disable=redefined-builtin
        max: Optional[float] = None,  # pylint: disable=redefined-builtin
        **kwargs
    ):
        """
        :keyword timestamp:
        :paramtype timestamp: int
        :keyword value:
        :paramtype value: float
        :keyword average:
        :paramtype average: float
        :keyword min:
        :paramtype min: float
        :keyword max:
        :paramtype max: float
        """
        super().__init__(**kwargs)
        self.timestamp = timestamp
        self.value = value
        self.average = average
        self.min = min
        self.max = max


class NumericNullableValueWithTimestamp(_serialization.Model):
    """NumericNullableValueWithTimestamp.

    :ivar timestamp:
    :vartype timestamp: int
    :ivar value:
    :vartype value: float
    """

    _attribute_map = {
        "timestamp": {"key": "timestamp", "type": "int"},
        "value": {"key": "value", "type": "float"},
    }

    def __init__(self, *, timestamp: Optional[int] = None, value: Optional[float] = None, **kwargs):
        """
        :keyword timestamp:
        :paramtype timestamp: int
        :keyword value:
        :paramtype value: float
        """
        super().__init__(**kwargs)
        self.timestamp = timestamp
        self.value = value


class PartDto(_serialization.Model):
    """PartDto.

    All required parameters must be populated in order to send to Azure.

    :ivar part_number: Required.
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar part_name:
    :vartype part_name: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    """

    _validation = {
        "part_number": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "part_name": {"key": "partName", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
    }

    def __init__(
        self,
        *,
        part_number: str,
        part_revision: Optional[str] = None,
        part_name: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword part_number: Required.
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword part_name:
        :paramtype part_name: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        """
        super().__init__(**kwargs)
        self.part_number = part_number
        self.part_revision = part_revision
        self.part_name = part_name
        self.drawing = drawing
        self.drawing_revision = drawing_revision


class PowerDto(_serialization.Model):
    """PowerDto.

    :ivar asset_name:
    :vartype asset_name: str
    :ivar assets:
    :vartype assets: list[~ignos.api.client.models.AssetPowerDto]
    """

    _attribute_map = {
        "asset_name": {"key": "assetName", "type": "str"},
        "assets": {"key": "assets", "type": "[AssetPowerDto]"},
    }

    def __init__(
        self, *, asset_name: Optional[str] = None, assets: Optional[List["_models.AssetPowerDto"]] = None, **kwargs
    ):
        """
        :keyword asset_name:
        :paramtype asset_name: str
        :keyword assets:
        :paramtype assets: list[~ignos.api.client.models.AssetPowerDto]
        """
        super().__init__(**kwargs)
        self.asset_name = asset_name
        self.assets = assets


class PowerOnUtilizationDto(_serialization.Model):
    """PowerOnUtilizationDto.

    :ivar average_utilization90_days:
    :vartype average_utilization90_days: float
    :ivar average_utilization30_days:
    :vartype average_utilization30_days: float
    :ivar average_utilization7_days:
    :vartype average_utilization7_days: float
    :ivar average_utilization_year_to_date:
    :vartype average_utilization_year_to_date: float
    :ivar power_on_utilization:
    :vartype power_on_utilization: float
    :ivar compared_to_average:
    :vartype compared_to_average: float
    """

    _attribute_map = {
        "average_utilization90_days": {"key": "averageUtilization90Days", "type": "float"},
        "average_utilization30_days": {"key": "averageUtilization30Days", "type": "float"},
        "average_utilization7_days": {"key": "averageUtilization7Days", "type": "float"},
        "average_utilization_year_to_date": {"key": "averageUtilizationYearToDate", "type": "float"},
        "power_on_utilization": {"key": "powerOnUtilization", "type": "float"},
        "compared_to_average": {"key": "comparedToAverage", "type": "float"},
    }

    def __init__(
        self,
        *,
        average_utilization90_days: Optional[float] = None,
        average_utilization30_days: Optional[float] = None,
        average_utilization7_days: Optional[float] = None,
        average_utilization_year_to_date: Optional[float] = None,
        power_on_utilization: Optional[float] = None,
        compared_to_average: Optional[float] = None,
        **kwargs
    ):
        """
        :keyword average_utilization90_days:
        :paramtype average_utilization90_days: float
        :keyword average_utilization30_days:
        :paramtype average_utilization30_days: float
        :keyword average_utilization7_days:
        :paramtype average_utilization7_days: float
        :keyword average_utilization_year_to_date:
        :paramtype average_utilization_year_to_date: float
        :keyword power_on_utilization:
        :paramtype power_on_utilization: float
        :keyword compared_to_average:
        :paramtype compared_to_average: float
        """
        super().__init__(**kwargs)
        self.average_utilization90_days = average_utilization90_days
        self.average_utilization30_days = average_utilization30_days
        self.average_utilization7_days = average_utilization7_days
        self.average_utilization_year_to_date = average_utilization_year_to_date
        self.power_on_utilization = power_on_utilization
        self.compared_to_average = compared_to_average


class PowerOnUtilizationList(_serialization.Model):
    """PowerOnUtilizationList.

    :ivar machines:
    :vartype machines: list[~ignos.api.client.models.Machine]
    """

    _attribute_map = {
        "machines": {"key": "machines", "type": "[Machine]"},
    }

    def __init__(self, *, machines: Optional[List["_models.Machine"]] = None, **kwargs):
        """
        :keyword machines:
        :paramtype machines: list[~ignos.api.client.models.Machine]
        """
        super().__init__(**kwargs)
        self.machines = machines


class PowerRegionDto(_serialization.Model):
    """PowerRegionDto.

    :ivar id:
    :vartype id: str
    :ivar country:
    :vartype country: str
    :ivar region:
    :vartype region: str
    :ivar description:
    :vartype description: str
    """

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "country": {"key": "country", "type": "str"},
        "region": {"key": "region", "type": "str"},
        "description": {"key": "description", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        country: Optional[str] = None,
        region: Optional[str] = None,
        description: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword country:
        :paramtype country: str
        :keyword region:
        :paramtype region: str
        :keyword description:
        :paramtype description: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.country = country
        self.region = region
        self.description = description


class ProblemDetails(_serialization.Model):
    """ProblemDetails.

    :ivar additional_properties: Unmatched properties from the message are deserialized to this
     collection.
    :vartype additional_properties: dict[str, any]
    :ivar type:
    :vartype type: str
    :ivar title:
    :vartype title: str
    :ivar status:
    :vartype status: int
    :ivar detail:
    :vartype detail: str
    :ivar instance:
    :vartype instance: str
    """

    _attribute_map = {
        "additional_properties": {"key": "", "type": "{object}"},
        "type": {"key": "type", "type": "str"},
        "title": {"key": "title", "type": "str"},
        "status": {"key": "status", "type": "int"},
        "detail": {"key": "detail", "type": "str"},
        "instance": {"key": "instance", "type": "str"},
    }

    def __init__(
        self,
        *,
        additional_properties: Optional[Dict[str, Any]] = None,
        type: Optional[str] = None,
        title: Optional[str] = None,
        status: Optional[int] = None,
        detail: Optional[str] = None,
        instance: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword additional_properties: Unmatched properties from the message are deserialized to this
         collection.
        :paramtype additional_properties: dict[str, any]
        :keyword type:
        :paramtype type: str
        :keyword title:
        :paramtype title: str
        :keyword status:
        :paramtype status: int
        :keyword detail:
        :paramtype detail: str
        :keyword instance:
        :paramtype instance: str
        """
        super().__init__(**kwargs)
        self.additional_properties = additional_properties
        self.type = type
        self.title = title
        self.status = status
        self.detail = detail
        self.instance = instance


class RegisterMeasuringToolCalibrationRequest(_serialization.Model):
    """RegisterMeasuringToolCalibrationRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar calibration_certificate_number:
    :vartype calibration_certificate_number: str
    :ivar adjusted: Required.
    :vartype adjusted: bool
    :ivar calibration_date: Required.
    :vartype calibration_date: ~datetime.datetime
    :ivar calibration_location:
    :vartype calibration_location: str
    :ivar report_type:
    :vartype report_type: str
    :ivar upload_key:
    :vartype upload_key: str
    :ivar filename:
    :vartype filename: str
    """

    _validation = {
        "adjusted": {"required": True},
        "calibration_date": {"required": True},
    }

    _attribute_map = {
        "calibration_certificate_number": {"key": "calibrationCertificateNumber", "type": "str"},
        "adjusted": {"key": "adjusted", "type": "bool"},
        "calibration_date": {"key": "calibrationDate", "type": "iso-8601"},
        "calibration_location": {"key": "calibrationLocation", "type": "str"},
        "report_type": {"key": "reportType", "type": "str"},
        "upload_key": {"key": "uploadKey", "type": "str"},
        "filename": {"key": "filename", "type": "str"},
    }

    def __init__(
        self,
        *,
        adjusted: bool,
        calibration_date: datetime.datetime,
        calibration_certificate_number: Optional[str] = None,
        calibration_location: Optional[str] = None,
        report_type: Optional[str] = None,
        upload_key: Optional[str] = None,
        filename: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword calibration_certificate_number:
        :paramtype calibration_certificate_number: str
        :keyword adjusted: Required.
        :paramtype adjusted: bool
        :keyword calibration_date: Required.
        :paramtype calibration_date: ~datetime.datetime
        :keyword calibration_location:
        :paramtype calibration_location: str
        :keyword report_type:
        :paramtype report_type: str
        :keyword upload_key:
        :paramtype upload_key: str
        :keyword filename:
        :paramtype filename: str
        """
        super().__init__(**kwargs)
        self.calibration_certificate_number = calibration_certificate_number
        self.adjusted = adjusted
        self.calibration_date = calibration_date
        self.calibration_location = calibration_location
        self.report_type = report_type
        self.upload_key = upload_key
        self.filename = filename


class RegisterWorkorderOperationEventRequest(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """RegisterWorkorderOperationEventRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar workorder_description:
    :vartype workorder_description: str
    :ivar operation_description:
    :vartype operation_description: str
    :ivar is_setup: Required.
    :vartype is_setup: bool
    :ivar employee:
    :vartype employee: ~ignos.api.client.models.EmployeeDto
    :ivar resource_id: Required.
    :vartype resource_id: str
    :ivar customer_order:
    :vartype customer_order: ~ignos.api.client.models.CustomerOrderInfoDto
    :ivar part:
    :vartype part: ~ignos.api.client.models.PartDto
    :ivar workorder_quantity:
    :vartype workorder_quantity: float
    :ivar start_time: Required.
    :vartype start_time: ~datetime.datetime
    :ivar end_time: Required.
    :vartype end_time: ~datetime.datetime
    :ivar material_part_number:
    :vartype material_part_number: str
    :ivar material_part_name:
    :vartype material_part_name: str
    :ivar material_item_group:
    :vartype material_item_group: str
    :ivar external_id:
    :vartype external_id: str
    """

    _validation = {
        "is_setup": {"required": True},
        "resource_id": {"required": True, "min_length": 1},
        "start_time": {"required": True},
        "end_time": {"required": True},
    }

    _attribute_map = {
        "workorder_description": {"key": "workorderDescription", "type": "str"},
        "operation_description": {"key": "operationDescription", "type": "str"},
        "is_setup": {"key": "isSetup", "type": "bool"},
        "employee": {"key": "employee", "type": "EmployeeDto"},
        "resource_id": {"key": "resourceId", "type": "str"},
        "customer_order": {"key": "customerOrder", "type": "CustomerOrderInfoDto"},
        "part": {"key": "part", "type": "PartDto"},
        "workorder_quantity": {"key": "workorderQuantity", "type": "float"},
        "start_time": {"key": "startTime", "type": "iso-8601"},
        "end_time": {"key": "endTime", "type": "iso-8601"},
        "material_part_number": {"key": "materialPartNumber", "type": "str"},
        "material_part_name": {"key": "materialPartName", "type": "str"},
        "material_item_group": {"key": "materialItemGroup", "type": "str"},
        "external_id": {"key": "externalId", "type": "str"},
    }

    def __init__(
        self,
        *,
        is_setup: bool,
        resource_id: str,
        start_time: datetime.datetime,
        end_time: datetime.datetime,
        workorder_description: Optional[str] = None,
        operation_description: Optional[str] = None,
        employee: Optional["_models.EmployeeDto"] = None,
        customer_order: Optional["_models.CustomerOrderInfoDto"] = None,
        part: Optional["_models.PartDto"] = None,
        workorder_quantity: Optional[float] = None,
        material_part_number: Optional[str] = None,
        material_part_name: Optional[str] = None,
        material_item_group: Optional[str] = None,
        external_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword workorder_description:
        :paramtype workorder_description: str
        :keyword operation_description:
        :paramtype operation_description: str
        :keyword is_setup: Required.
        :paramtype is_setup: bool
        :keyword employee:
        :paramtype employee: ~ignos.api.client.models.EmployeeDto
        :keyword resource_id: Required.
        :paramtype resource_id: str
        :keyword customer_order:
        :paramtype customer_order: ~ignos.api.client.models.CustomerOrderInfoDto
        :keyword part:
        :paramtype part: ~ignos.api.client.models.PartDto
        :keyword workorder_quantity:
        :paramtype workorder_quantity: float
        :keyword start_time: Required.
        :paramtype start_time: ~datetime.datetime
        :keyword end_time: Required.
        :paramtype end_time: ~datetime.datetime
        :keyword material_part_number:
        :paramtype material_part_number: str
        :keyword material_part_name:
        :paramtype material_part_name: str
        :keyword material_item_group:
        :paramtype material_item_group: str
        :keyword external_id:
        :paramtype external_id: str
        """
        super().__init__(**kwargs)
        self.workorder_description = workorder_description
        self.operation_description = operation_description
        self.is_setup = is_setup
        self.employee = employee
        self.resource_id = resource_id
        self.customer_order = customer_order
        self.part = part
        self.workorder_quantity = workorder_quantity
        self.start_time = start_time
        self.end_time = end_time
        self.material_part_number = material_part_number
        self.material_part_name = material_part_name
        self.material_item_group = material_item_group
        self.external_id = external_id


class ResourceDto(_serialization.Model):
    """ResourceDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name:
    :vartype name: str
    :ivar external: Required.
    :vartype external: bool
    :ivar description:
    :vartype description: str
    :ivar resource_type:
    :vartype resource_type: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "external": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "external": {"key": "external", "type": "bool"},
        "description": {"key": "description", "type": "str"},
        "resource_type": {"key": "resourceType", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        external: bool,
        name: Optional[str] = None,
        description: Optional[str] = None,
        resource_type: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name:
        :paramtype name: str
        :keyword external: Required.
        :paramtype external: bool
        :keyword description:
        :paramtype description: str
        :keyword resource_type:
        :paramtype resource_type: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name
        self.external = external
        self.description = description
        self.resource_type = resource_type


class ResourceExistDto(_serialization.Model):
    """ResourceExistDto.

    All required parameters must be populated in order to send to Azure.

    :ivar exists: Required.
    :vartype exists: bool
    :ivar id:
    :vartype id: str
    :ivar external_id:
    :vartype external_id: str
    """

    _validation = {
        "exists": {"required": True},
    }

    _attribute_map = {
        "exists": {"key": "exists", "type": "bool"},
        "id": {"key": "id", "type": "str"},
        "external_id": {"key": "externalId", "type": "str"},
    }

    def __init__(
        self,
        *,
        exists: bool,
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        external_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword exists: Required.
        :paramtype exists: bool
        :keyword id:
        :paramtype id: str
        :keyword external_id:
        :paramtype external_id: str
        """
        super().__init__(**kwargs)
        self.exists = exists
        self.id = id
        self.external_id = external_id


class SaveCommentRequest(_serialization.Model):
    """SaveCommentRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar element_id: Required.
    :vartype element_id: str
    :ivar sequence: Required.
    :vartype sequence: str
    :ivar comment:
    :vartype comment: str
    """

    _validation = {
        "schema_id": {"required": True, "min_length": 1},
        "element_id": {"required": True, "min_length": 1},
        "sequence": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "schema_id": {"key": "schemaId", "type": "str"},
        "element_id": {"key": "elementId", "type": "str"},
        "sequence": {"key": "sequence", "type": "str"},
        "comment": {"key": "comment", "type": "str"},
    }

    def __init__(self, *, schema_id: str, element_id: str, sequence: str, comment: Optional[str] = None, **kwargs):
        """
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword element_id: Required.
        :paramtype element_id: str
        :keyword sequence: Required.
        :paramtype sequence: str
        :keyword comment:
        :paramtype comment: str
        """
        super().__init__(**kwargs)
        self.schema_id = schema_id
        self.element_id = element_id
        self.sequence = sequence
        self.comment = comment


class SaveMeasurementFormInstanceSchemaCommentRequest(_serialization.Model):
    """SaveMeasurementFormInstanceSchemaCommentRequest.

    :ivar comment:
    :vartype comment: str
    """

    _attribute_map = {
        "comment": {"key": "comment", "type": "str"},
    }

    def __init__(self, *, comment: Optional[str] = None, **kwargs):
        """
        :keyword comment:
        :paramtype comment: str
        """
        super().__init__(**kwargs)
        self.comment = comment


class SaveToolRequest(_serialization.Model):
    """SaveToolRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar element_id: Required.
    :vartype element_id: str
    :ivar sequence: Required.
    :vartype sequence: str
    :ivar tools:
    :vartype tools: list[str]
    """

    _validation = {
        "schema_id": {"required": True, "min_length": 1},
        "element_id": {"required": True, "min_length": 1},
        "sequence": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "schema_id": {"key": "schemaId", "type": "str"},
        "element_id": {"key": "elementId", "type": "str"},
        "sequence": {"key": "sequence", "type": "str"},
        "tools": {"key": "tools", "type": "[str]"},
    }

    def __init__(self, *, schema_id: str, element_id: str, sequence: str, tools: Optional[List[str]] = None, **kwargs):
        """
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword element_id: Required.
        :paramtype element_id: str
        :keyword sequence: Required.
        :paramtype sequence: str
        :keyword tools:
        :paramtype tools: list[str]
        """
        super().__init__(**kwargs)
        self.schema_id = schema_id
        self.element_id = element_id
        self.sequence = sequence
        self.tools = tools


class SaveValueRequest(_serialization.Model):
    """SaveValueRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar operation:
    :vartype operation: int
    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar element_id: Required.
    :vartype element_id: str
    :ivar sequence: Required.
    :vartype sequence: str
    :ivar value:
    :vartype value: str
    :ivar bonus:
    :vartype bonus: str
    """

    _validation = {
        "schema_id": {"required": True, "min_length": 1},
        "element_id": {"required": True, "min_length": 1},
        "sequence": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "operation": {"key": "operation", "type": "int"},
        "schema_id": {"key": "schemaId", "type": "str"},
        "element_id": {"key": "elementId", "type": "str"},
        "sequence": {"key": "sequence", "type": "str"},
        "value": {"key": "value", "type": "str"},
        "bonus": {"key": "bonus", "type": "str"},
    }

    def __init__(
        self,
        *,
        schema_id: str,
        element_id: str,
        sequence: str,
        operation: Optional[int] = None,
        value: Optional[str] = None,
        bonus: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword operation:
        :paramtype operation: int
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword element_id: Required.
        :paramtype element_id: str
        :keyword sequence: Required.
        :paramtype sequence: str
        :keyword value:
        :paramtype value: str
        :keyword bonus:
        :paramtype bonus: str
        """
        super().__init__(**kwargs)
        self.operation = operation
        self.schema_id = schema_id
        self.element_id = element_id
        self.sequence = sequence
        self.value = value
        self.bonus = bonus


class SaveValueResponseDto(_serialization.Model):
    """SaveValueResponseDto.

    All required parameters must be populated in order to send to Azure.

    :ivar element_completed: Required.
    :vartype element_completed: bool
    :ivar warning:
    :vartype warning: str
    :ivar tools: Required.
    :vartype tools: list[~ignos.api.client.models.MeasurementFormToolValueDto]
    """

    _validation = {
        "element_completed": {"required": True},
        "tools": {"required": True},
    }

    _attribute_map = {
        "element_completed": {"key": "elementCompleted", "type": "bool"},
        "warning": {"key": "warning", "type": "str"},
        "tools": {"key": "tools", "type": "[MeasurementFormToolValueDto]"},
    }

    def __init__(
        self,
        *,
        element_completed: bool,
        tools: List["_models.MeasurementFormToolValueDto"],
        warning: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword element_completed: Required.
        :paramtype element_completed: bool
        :keyword warning:
        :paramtype warning: str
        :keyword tools: Required.
        :paramtype tools: list[~ignos.api.client.models.MeasurementFormToolValueDto]
        """
        super().__init__(**kwargs)
        self.element_completed = element_completed
        self.warning = warning
        self.tools = tools


class SchemaFeedbackCreatedDto(_serialization.Model):
    """SchemaFeedbackCreatedDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar work_order: Required.
    :vartype work_order: str
    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar version_id: Required.
    :vartype version_id: int
    :ivar schema_instance_id: Required.
    :vartype schema_instance_id: str
    :ivar balloon_id:
    :vartype balloon_id: str
    :ivar feedback: Required.
    :vartype feedback: str
    :ivar from_property: Required.
    :vartype from_property: str
    :ivar created: Required.
    :vartype created: ~datetime.datetime
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "work_order": {"required": True, "min_length": 1},
        "schema_id": {"required": True, "min_length": 1},
        "version_id": {"required": True},
        "schema_instance_id": {"required": True, "min_length": 1},
        "feedback": {"required": True, "min_length": 1},
        "from_property": {"required": True, "min_length": 1},
        "created": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "work_order": {"key": "workOrder", "type": "str"},
        "schema_id": {"key": "schemaId", "type": "str"},
        "version_id": {"key": "versionId", "type": "int"},
        "schema_instance_id": {"key": "schemaInstanceId", "type": "str"},
        "balloon_id": {"key": "balloonId", "type": "str"},
        "feedback": {"key": "feedback", "type": "str"},
        "from_property": {"key": "from", "type": "str"},
        "created": {"key": "created", "type": "iso-8601"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        work_order: str,
        schema_id: str,
        version_id: int,
        schema_instance_id: str,
        feedback: str,
        from_property: str,
        created: datetime.datetime,
        balloon_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword work_order: Required.
        :paramtype work_order: str
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword version_id: Required.
        :paramtype version_id: int
        :keyword schema_instance_id: Required.
        :paramtype schema_instance_id: str
        :keyword balloon_id:
        :paramtype balloon_id: str
        :keyword feedback: Required.
        :paramtype feedback: str
        :keyword from_property: Required.
        :paramtype from_property: str
        :keyword created: Required.
        :paramtype created: ~datetime.datetime
        """
        super().__init__(**kwargs)
        self.id = id
        self.work_order = work_order
        self.schema_id = schema_id
        self.version_id = version_id
        self.schema_instance_id = schema_instance_id
        self.balloon_id = balloon_id
        self.feedback = feedback
        self.from_property = from_property
        self.created = created


class SchemaFeedbackDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """SchemaFeedbackDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar work_order: Required.
    :vartype work_order: str
    :ivar schema_id: Required.
    :vartype schema_id: str
    :ivar version_id:
    :vartype version_id: int
    :ivar schema_instance_id: Required.
    :vartype schema_instance_id: str
    :ivar balloon_id:
    :vartype balloon_id: str
    :ivar feedback: Required.
    :vartype feedback: str
    :ivar from_property: Required.
    :vartype from_property: str
    :ivar created: Required.
    :vartype created: ~datetime.datetime
    :ivar assigned_to:
    :vartype assigned_to: ~ignos.api.client.models.UserDto
    :ivar status: Known values are: "New" and "InProgress".
    :vartype status: str or ~ignos.api.client.models.SchemaFeedbackStatus
    :ivar latest_schema_definition_id:
    :vartype latest_schema_definition_id: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "work_order": {"required": True, "min_length": 1},
        "schema_id": {"required": True, "min_length": 1},
        "schema_instance_id": {"required": True, "min_length": 1},
        "feedback": {"required": True, "min_length": 1},
        "from_property": {"required": True, "min_length": 1},
        "created": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "work_order": {"key": "workOrder", "type": "str"},
        "schema_id": {"key": "schemaId", "type": "str"},
        "version_id": {"key": "versionId", "type": "int"},
        "schema_instance_id": {"key": "schemaInstanceId", "type": "str"},
        "balloon_id": {"key": "balloonId", "type": "str"},
        "feedback": {"key": "feedback", "type": "str"},
        "from_property": {"key": "from", "type": "str"},
        "created": {"key": "created", "type": "iso-8601"},
        "assigned_to": {"key": "assignedTo", "type": "UserDto"},
        "status": {"key": "status", "type": "str"},
        "latest_schema_definition_id": {"key": "latestSchemaDefinitionId", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        work_order: str,
        schema_id: str,
        schema_instance_id: str,
        feedback: str,
        from_property: str,
        created: datetime.datetime,
        version_id: Optional[int] = None,
        balloon_id: Optional[str] = None,
        assigned_to: Optional["_models.UserDto"] = None,
        status: Optional[Union[str, "_models.SchemaFeedbackStatus"]] = None,
        latest_schema_definition_id: Optional[str] = None,
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword work_order: Required.
        :paramtype work_order: str
        :keyword schema_id: Required.
        :paramtype schema_id: str
        :keyword version_id:
        :paramtype version_id: int
        :keyword schema_instance_id: Required.
        :paramtype schema_instance_id: str
        :keyword balloon_id:
        :paramtype balloon_id: str
        :keyword feedback: Required.
        :paramtype feedback: str
        :keyword from_property: Required.
        :paramtype from_property: str
        :keyword created: Required.
        :paramtype created: ~datetime.datetime
        :keyword assigned_to:
        :paramtype assigned_to: ~ignos.api.client.models.UserDto
        :keyword status: Known values are: "New" and "InProgress".
        :paramtype status: str or ~ignos.api.client.models.SchemaFeedbackStatus
        :keyword latest_schema_definition_id:
        :paramtype latest_schema_definition_id: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.work_order = work_order
        self.schema_id = schema_id
        self.version_id = version_id
        self.schema_instance_id = schema_instance_id
        self.balloon_id = balloon_id
        self.feedback = feedback
        self.from_property = from_property
        self.created = created
        self.assigned_to = assigned_to
        self.status = status
        self.latest_schema_definition_id = latest_schema_definition_id
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision


class SchemaFeedbackDtoPagedResult(_serialization.Model):
    """SchemaFeedbackDtoPagedResult.

    All required parameters must be populated in order to send to Azure.

    :ivar results: Required.
    :vartype results: list[~ignos.api.client.models.SchemaFeedbackDto]
    :ivar continuation_token:
    :vartype continuation_token: str
    """

    _validation = {
        "results": {"required": True},
    }

    _attribute_map = {
        "results": {"key": "results", "type": "[SchemaFeedbackDto]"},
        "continuation_token": {"key": "continuationToken", "type": "str"},
    }

    def __init__(
        self, *, results: List["_models.SchemaFeedbackDto"], continuation_token: Optional[str] = None, **kwargs
    ):
        """
        :keyword results: Required.
        :paramtype results: list[~ignos.api.client.models.SchemaFeedbackDto]
        :keyword continuation_token:
        :paramtype continuation_token: str
        """
        super().__init__(**kwargs)
        self.results = results
        self.continuation_token = continuation_token


class SetMeasurementFormNeedAsNotNeededRequest(_serialization.Model):
    """SetMeasurementFormNeedAsNotNeededRequest.

    :ivar comment:
    :vartype comment: str
    """

    _attribute_map = {
        "comment": {"key": "comment", "type": "str"},
    }

    def __init__(self, *, comment: Optional[str] = None, **kwargs):
        """
        :keyword comment:
        :paramtype comment: str
        """
        super().__init__(**kwargs)
        self.comment = comment


class SetMeasurementFormNeedUserRequest(_serialization.Model):
    """SetMeasurementFormNeedUserRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar user_id: Required.
    :vartype user_id: str
    """

    _validation = {
        "user_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "user_id": {"key": "userId", "type": "str"},
    }

    def __init__(self, *, user_id: str, **kwargs):
        """
        :keyword user_id: Required.
        :paramtype user_id: str
        """
        super().__init__(**kwargs)
        self.user_id = user_id


class SetMeasurementFormSchemaFeedbackUserRequest(_serialization.Model):
    """SetMeasurementFormSchemaFeedbackUserRequest.

    :ivar user_id:
    :vartype user_id: str
    """

    _attribute_map = {
        "user_id": {"key": "userId", "type": "str"},
    }

    def __init__(self, *, user_id: Optional[str] = None, **kwargs):
        """
        :keyword user_id:
        :paramtype user_id: str
        """
        super().__init__(**kwargs)
        self.user_id = user_id


class SetMeasurementFormSchemasNotNeeded(_serialization.Model):
    """SetMeasurementFormSchemasNotNeeded.

    :ivar customer_id:
    :vartype customer_id: str
    :ivar part_number:
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar drawing:
    :vartype drawing: str
    :ivar drawing_revision:
    :vartype drawing_revision: str
    :ivar comment:
    :vartype comment: str
    """

    _attribute_map = {
        "customer_id": {"key": "customerId", "type": "str"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "drawing": {"key": "drawing", "type": "str"},
        "drawing_revision": {"key": "drawingRevision", "type": "str"},
        "comment": {"key": "comment", "type": "str"},
    }

    def __init__(
        self,
        *,
        customer_id: Optional[str] = None,
        part_number: Optional[str] = None,
        part_revision: Optional[str] = None,
        drawing: Optional[str] = None,
        drawing_revision: Optional[str] = None,
        comment: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword drawing:
        :paramtype drawing: str
        :keyword drawing_revision:
        :paramtype drawing_revision: str
        :keyword comment:
        :paramtype comment: str
        """
        super().__init__(**kwargs)
        self.customer_id = customer_id
        self.part_number = part_number
        self.part_revision = part_revision
        self.drawing = drawing
        self.drawing_revision = drawing_revision
        self.comment = comment


class StartWorkOperationRequest(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """StartWorkOperationRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar is_setup:
    :vartype is_setup: bool
    :ivar employee:
    :vartype employee: ~ignos.api.client.models.EmployeeDto
    :ivar resource_id: Required.
    :vartype resource_id: str
    :ivar customer_order:
    :vartype customer_order: ~ignos.api.client.models.CustomerOrderInfoDto
    :ivar part:
    :vartype part: ~ignos.api.client.models.PartDto
    :ivar workorder_quantity:
    :vartype workorder_quantity: float
    :ivar time:
    :vartype time: ~datetime.datetime
    :ivar material_part_number:
    :vartype material_part_number: str
    :ivar material_part_name:
    :vartype material_part_name: str
    :ivar material_item_group:
    :vartype material_item_group: str
    :ivar workorder_description:
    :vartype workorder_description: str
    :ivar operation_description:
    :vartype operation_description: str
    :ivar external_id:
    :vartype external_id: str
    """

    _validation = {
        "resource_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "is_setup": {"key": "isSetup", "type": "bool"},
        "employee": {"key": "employee", "type": "EmployeeDto"},
        "resource_id": {"key": "resourceId", "type": "str"},
        "customer_order": {"key": "customerOrder", "type": "CustomerOrderInfoDto"},
        "part": {"key": "part", "type": "PartDto"},
        "workorder_quantity": {"key": "workorderQuantity", "type": "float"},
        "time": {"key": "time", "type": "iso-8601"},
        "material_part_number": {"key": "materialPartNumber", "type": "str"},
        "material_part_name": {"key": "materialPartName", "type": "str"},
        "material_item_group": {"key": "materialItemGroup", "type": "str"},
        "workorder_description": {"key": "workorderDescription", "type": "str"},
        "operation_description": {"key": "operationDescription", "type": "str"},
        "external_id": {"key": "externalId", "type": "str"},
    }

    def __init__(
        self,
        *,
        resource_id: str,
        is_setup: Optional[bool] = None,
        employee: Optional["_models.EmployeeDto"] = None,
        customer_order: Optional["_models.CustomerOrderInfoDto"] = None,
        part: Optional["_models.PartDto"] = None,
        workorder_quantity: Optional[float] = None,
        time: Optional[datetime.datetime] = None,
        material_part_number: Optional[str] = None,
        material_part_name: Optional[str] = None,
        material_item_group: Optional[str] = None,
        workorder_description: Optional[str] = None,
        operation_description: Optional[str] = None,
        external_id: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword is_setup:
        :paramtype is_setup: bool
        :keyword employee:
        :paramtype employee: ~ignos.api.client.models.EmployeeDto
        :keyword resource_id: Required.
        :paramtype resource_id: str
        :keyword customer_order:
        :paramtype customer_order: ~ignos.api.client.models.CustomerOrderInfoDto
        :keyword part:
        :paramtype part: ~ignos.api.client.models.PartDto
        :keyword workorder_quantity:
        :paramtype workorder_quantity: float
        :keyword time:
        :paramtype time: ~datetime.datetime
        :keyword material_part_number:
        :paramtype material_part_number: str
        :keyword material_part_name:
        :paramtype material_part_name: str
        :keyword material_item_group:
        :paramtype material_item_group: str
        :keyword workorder_description:
        :paramtype workorder_description: str
        :keyword operation_description:
        :paramtype operation_description: str
        :keyword external_id:
        :paramtype external_id: str
        """
        super().__init__(**kwargs)
        self.is_setup = is_setup
        self.employee = employee
        self.resource_id = resource_id
        self.customer_order = customer_order
        self.part = part
        self.workorder_quantity = workorder_quantity
        self.time = time
        self.material_part_number = material_part_number
        self.material_part_name = material_part_name
        self.material_item_group = material_item_group
        self.workorder_description = workorder_description
        self.operation_description = operation_description
        self.external_id = external_id


class StateDto(_serialization.Model):
    """StateDto.

    All required parameters must be populated in order to send to Azure.

    :ivar state: Required.
    :vartype state: str
    :ivar machine_state: Required. Known values are: "InCycle", "MasterCam", "MdiCycle",
     "CamCycle", "Idle", "OptionalStop", "ProgramStop", "M0", "AtcStopped", "FeedHold", "MdiMode",
     "ManualMode", "EStop", "Alarm", and "PowerOff".
    :vartype machine_state: str or ~ignos.api.client.models.MachineState
    :ivar seconds: Required.
    :vartype seconds: int
    """

    _validation = {
        "state": {"required": True, "min_length": 1},
        "machine_state": {"required": True},
        "seconds": {"required": True},
    }

    _attribute_map = {
        "state": {"key": "state", "type": "str"},
        "machine_state": {"key": "machineState", "type": "str"},
        "seconds": {"key": "seconds", "type": "int"},
    }

    def __init__(self, *, state: str, machine_state: Union[str, "_models.MachineState"], seconds: int, **kwargs):
        """
        :keyword state: Required.
        :paramtype state: str
        :keyword machine_state: Required. Known values are: "InCycle", "MasterCam", "MdiCycle",
         "CamCycle", "Idle", "OptionalStop", "ProgramStop", "M0", "AtcStopped", "FeedHold", "MdiMode",
         "ManualMode", "EStop", "Alarm", and "PowerOff".
        :paramtype machine_state: str or ~ignos.api.client.models.MachineState
        :keyword seconds: Required.
        :paramtype seconds: int
        """
        super().__init__(**kwargs)
        self.state = state
        self.machine_state = machine_state
        self.seconds = seconds


class StopWorkOperationRequest(_serialization.Model):
    """StopWorkOperationRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar is_setup:
    :vartype is_setup: bool
    :ivar employee:
    :vartype employee: ~ignos.api.client.models.EmployeeDto
    :ivar time:
    :vartype time: ~datetime.datetime
    :ivar resource_id: Required.
    :vartype resource_id: str
    """

    _validation = {
        "resource_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "is_setup": {"key": "isSetup", "type": "bool"},
        "employee": {"key": "employee", "type": "EmployeeDto"},
        "time": {"key": "time", "type": "iso-8601"},
        "resource_id": {"key": "resourceId", "type": "str"},
    }

    def __init__(
        self,
        *,
        resource_id: str,
        is_setup: Optional[bool] = None,
        employee: Optional["_models.EmployeeDto"] = None,
        time: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword is_setup:
        :paramtype is_setup: bool
        :keyword employee:
        :paramtype employee: ~ignos.api.client.models.EmployeeDto
        :keyword time:
        :paramtype time: ~datetime.datetime
        :keyword resource_id: Required.
        :paramtype resource_id: str
        """
        super().__init__(**kwargs)
        self.is_setup = is_setup
        self.employee = employee
        self.time = time
        self.resource_id = resource_id


class SubComsumptionResultDto(_serialization.Model):
    """SubComsumptionResultDto.

    :ivar kwh:
    :vartype kwh: float
    :ivar co2_equivalent:
    :vartype co2_equivalent: float
    :ivar timestamp:
    :vartype timestamp: int
    """

    _attribute_map = {
        "kwh": {"key": "kwh", "type": "float"},
        "co2_equivalent": {"key": "co2Equivalent", "type": "float"},
        "timestamp": {"key": "timestamp", "type": "int"},
    }

    def __init__(
        self,
        *,
        kwh: Optional[float] = None,
        co2_equivalent: Optional[float] = None,
        timestamp: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword kwh:
        :paramtype kwh: float
        :keyword co2_equivalent:
        :paramtype co2_equivalent: float
        :keyword timestamp:
        :paramtype timestamp: int
        """
        super().__init__(**kwargs)
        self.kwh = kwh
        self.co2_equivalent = co2_equivalent
        self.timestamp = timestamp


class SubConsumptionDto(_serialization.Model):
    """SubConsumptionDto.

    :ivar asset_id:
    :vartype asset_id: int
    :ivar asset_name:
    :vartype asset_name: str
    :ivar timeseries_id:
    :vartype timeseries_id: int
    :ivar timeseries_name:
    :vartype timeseries_name: str
    :ivar kwh:
    :vartype kwh: float
    :ivar co2_equivalent:
    :vartype co2_equivalent: float
    :ivar first_timestamp:
    :vartype first_timestamp: int
    :ivar last_timestamp:
    :vartype last_timestamp: int
    :ivar items:
    :vartype items: list[~ignos.api.client.models.SubComsumptionResultDto]
    """

    _attribute_map = {
        "asset_id": {"key": "assetId", "type": "int"},
        "asset_name": {"key": "assetName", "type": "str"},
        "timeseries_id": {"key": "timeseriesId", "type": "int"},
        "timeseries_name": {"key": "timeseriesName", "type": "str"},
        "kwh": {"key": "kwh", "type": "float"},
        "co2_equivalent": {"key": "co2Equivalent", "type": "float"},
        "first_timestamp": {"key": "firstTimestamp", "type": "int"},
        "last_timestamp": {"key": "lastTimestamp", "type": "int"},
        "items": {"key": "items", "type": "[SubComsumptionResultDto]"},
    }

    def __init__(
        self,
        *,
        asset_id: Optional[int] = None,
        asset_name: Optional[str] = None,
        timeseries_id: Optional[int] = None,
        timeseries_name: Optional[str] = None,
        kwh: Optional[float] = None,
        co2_equivalent: Optional[float] = None,
        first_timestamp: Optional[int] = None,
        last_timestamp: Optional[int] = None,
        items: Optional[List["_models.SubComsumptionResultDto"]] = None,
        **kwargs
    ):
        """
        :keyword asset_id:
        :paramtype asset_id: int
        :keyword asset_name:
        :paramtype asset_name: str
        :keyword timeseries_id:
        :paramtype timeseries_id: int
        :keyword timeseries_name:
        :paramtype timeseries_name: str
        :keyword kwh:
        :paramtype kwh: float
        :keyword co2_equivalent:
        :paramtype co2_equivalent: float
        :keyword first_timestamp:
        :paramtype first_timestamp: int
        :keyword last_timestamp:
        :paramtype last_timestamp: int
        :keyword items:
        :paramtype items: list[~ignos.api.client.models.SubComsumptionResultDto]
        """
        super().__init__(**kwargs)
        self.asset_id = asset_id
        self.asset_name = asset_name
        self.timeseries_id = timeseries_id
        self.timeseries_name = timeseries_name
        self.kwh = kwh
        self.co2_equivalent = co2_equivalent
        self.first_timestamp = first_timestamp
        self.last_timestamp = last_timestamp
        self.items = items


class SupplierInviteDto(_serialization.Model):
    """SupplierInviteDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar supplier_id: Required.
    :vartype supplier_id: str
    :ivar name: Required.
    :vartype name: str
    :ivar username: Required.
    :vartype username: str
    :ivar deadline: Required.
    :vartype deadline: ~datetime.datetime
    :ivar created_time: Required.
    :vartype created_time: ~datetime.datetime
    :ivar created_by: Required.
    :vartype created_by: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "supplier_id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
        "username": {"required": True, "min_length": 1},
        "deadline": {"required": True},
        "created_time": {"required": True},
        "created_by": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "supplier_id": {"key": "supplierId", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "username": {"key": "username", "type": "str"},
        "deadline": {"key": "deadline", "type": "iso-8601"},
        "created_time": {"key": "createdTime", "type": "iso-8601"},
        "created_by": {"key": "createdBy", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        supplier_id: str,
        name: str,
        username: str,
        deadline: datetime.datetime,
        created_time: datetime.datetime,
        created_by: str,
        **kwargs
    ):
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword supplier_id: Required.
        :paramtype supplier_id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword username: Required.
        :paramtype username: str
        :keyword deadline: Required.
        :paramtype deadline: ~datetime.datetime
        :keyword created_time: Required.
        :paramtype created_time: ~datetime.datetime
        :keyword created_by: Required.
        :paramtype created_by: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.supplier_id = supplier_id
        self.name = name
        self.username = username
        self.deadline = deadline
        self.created_time = created_time
        self.created_by = created_by


class SustainabilityCustomerOrderDto(_serialization.Model):
    """SustainabilityCustomerOrderDto.

    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar customer_order:
    :vartype customer_order: str
    :ivar customer_order_line:
    :vartype customer_order_line: int
    :ivar external_order_number:
    :vartype external_order_number: str
    """

    _attribute_map = {
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "customer_order": {"key": "customerOrder", "type": "str"},
        "customer_order_line": {"key": "customerOrderLine", "type": "int"},
        "external_order_number": {"key": "externalOrderNumber", "type": "str"},
    }

    def __init__(
        self,
        *,
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        customer_order: Optional[str] = None,
        customer_order_line: Optional[int] = None,
        external_order_number: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword customer_order:
        :paramtype customer_order: str
        :keyword customer_order_line:
        :paramtype customer_order_line: int
        :keyword external_order_number:
        :paramtype external_order_number: str
        """
        super().__init__(**kwargs)
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.customer_order = customer_order
        self.customer_order_line = customer_order_line
        self.external_order_number = external_order_number


class SustainabilityNodeDto(_serialization.Model):
    """SustainabilityNodeDto.

    All required parameters must be populated in order to send to Azure.

    :ivar part_info: Required.
    :vartype part_info: ~ignos.api.client.models.SustainabilityPartInfoDto
    :ivar serial_number:
    :vartype serial_number: str
    :ivar workorder:
    :vartype workorder: str
    :ivar procurement_info:
    :vartype procurement_info: ~ignos.api.client.models.SustainabilityNodeProcurementInfoDto
    :ivar quantity: Required.
    :vartype quantity: float
    :ivar sub_nodes:
    :vartype sub_nodes: list[~ignos.api.client.models.SustainabilityNodeDto]
    """

    _validation = {
        "part_info": {"required": True},
        "quantity": {"required": True},
    }

    _attribute_map = {
        "part_info": {"key": "partInfo", "type": "SustainabilityPartInfoDto"},
        "serial_number": {"key": "serialNumber", "type": "str"},
        "workorder": {"key": "workorder", "type": "str"},
        "procurement_info": {"key": "procurementInfo", "type": "SustainabilityNodeProcurementInfoDto"},
        "quantity": {"key": "quantity", "type": "float"},
        "sub_nodes": {"key": "subNodes", "type": "[SustainabilityNodeDto]"},
    }

    def __init__(
        self,
        *,
        part_info: "_models.SustainabilityPartInfoDto",
        quantity: float,
        serial_number: Optional[str] = None,
        workorder: Optional[str] = None,
        procurement_info: Optional["_models.SustainabilityNodeProcurementInfoDto"] = None,
        sub_nodes: Optional[List["_models.SustainabilityNodeDto"]] = None,
        **kwargs
    ):
        """
        :keyword part_info: Required.
        :paramtype part_info: ~ignos.api.client.models.SustainabilityPartInfoDto
        :keyword serial_number:
        :paramtype serial_number: str
        :keyword workorder:
        :paramtype workorder: str
        :keyword procurement_info:
        :paramtype procurement_info: ~ignos.api.client.models.SustainabilityNodeProcurementInfoDto
        :keyword quantity: Required.
        :paramtype quantity: float
        :keyword sub_nodes:
        :paramtype sub_nodes: list[~ignos.api.client.models.SustainabilityNodeDto]
        """
        super().__init__(**kwargs)
        self.part_info = part_info
        self.serial_number = serial_number
        self.workorder = workorder
        self.procurement_info = procurement_info
        self.quantity = quantity
        self.sub_nodes = sub_nodes


class SustainabilityNodeProcurementInfoDto(_serialization.Model):
    """SustainabilityNodeProcurementInfoDto.

    :ivar procurement_order:
    :vartype procurement_order: str
    :ivar procurement_order_line:
    :vartype procurement_order_line: int
    :ivar lot_number:
    :vartype lot_number: str
    :ivar heat_number:
    :vartype heat_number: str
    """

    _attribute_map = {
        "procurement_order": {"key": "procurementOrder", "type": "str"},
        "procurement_order_line": {"key": "procurementOrderLine", "type": "int"},
        "lot_number": {"key": "lotNumber", "type": "str"},
        "heat_number": {"key": "heatNumber", "type": "str"},
    }

    def __init__(
        self,
        *,
        procurement_order: Optional[str] = None,
        procurement_order_line: Optional[int] = None,
        lot_number: Optional[str] = None,
        heat_number: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword procurement_order:
        :paramtype procurement_order: str
        :keyword procurement_order_line:
        :paramtype procurement_order_line: int
        :keyword lot_number:
        :paramtype lot_number: str
        :keyword heat_number:
        :paramtype heat_number: str
        """
        super().__init__(**kwargs)
        self.procurement_order = procurement_order
        self.procurement_order_line = procurement_order_line
        self.lot_number = lot_number
        self.heat_number = heat_number


class SustainabilityPartInfoDto(_serialization.Model):
    """SustainabilityPartInfoDto.

    All required parameters must be populated in order to send to Azure.

    :ivar part_number: Required.
    :vartype part_number: str
    :ivar part_revision:
    :vartype part_revision: str
    :ivar part_name:
    :vartype part_name: str
    """

    _validation = {
        "part_number": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "part_number": {"key": "partNumber", "type": "str"},
        "part_revision": {"key": "partRevision", "type": "str"},
        "part_name": {"key": "partName", "type": "str"},
    }

    def __init__(
        self, *, part_number: str, part_revision: Optional[str] = None, part_name: Optional[str] = None, **kwargs
    ):
        """
        :keyword part_number: Required.
        :paramtype part_number: str
        :keyword part_revision:
        :paramtype part_revision: str
        :keyword part_name:
        :paramtype part_name: str
        """
        super().__init__(**kwargs)
        self.part_number = part_number
        self.part_revision = part_revision
        self.part_name = part_name


class UnregisteredToolValueDto(_serialization.Model):
    """UnregisteredToolValueDto.

    All required parameters must be populated in order to send to Azure.

    :ivar unregistered_tool: Required.
    :vartype unregistered_tool: str
    :ivar count: Required.
    :vartype count: int
    """

    _validation = {
        "unregistered_tool": {"required": True, "min_length": 1},
        "count": {"required": True},
    }

    _attribute_map = {
        "unregistered_tool": {"key": "unregisteredTool", "type": "str"},
        "count": {"key": "count", "type": "int"},
    }

    def __init__(self, *, unregistered_tool: str, count: int, **kwargs):
        """
        :keyword unregistered_tool: Required.
        :paramtype unregistered_tool: str
        :keyword count: Required.
        :paramtype count: int
        """
        super().__init__(**kwargs)
        self.unregistered_tool = unregistered_tool
        self.count = count


class UpdateCdfConfig(_serialization.Model):
    """UpdateCdfConfig.

    All required parameters must be populated in order to send to Azure.

    :ivar client_id: Required.
    :vartype client_id: str
    :ivar client_secret:
    :vartype client_secret: str
    """

    _validation = {
        "client_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "client_id": {"key": "clientId", "type": "str"},
        "client_secret": {"key": "clientSecret", "type": "str"},
    }

    def __init__(self, *, client_id: str, client_secret: Optional[str] = None, **kwargs):
        """
        :keyword client_id: Required.
        :paramtype client_id: str
        :keyword client_secret:
        :paramtype client_secret: str
        """
        super().__init__(**kwargs)
        self.client_id = client_id
        self.client_secret = client_secret


class UpdateCompanyUserRequest(_serialization.Model):
    """UpdateCompanyUserRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar name: Required.
    :vartype name: str
    :ivar roles: Required.
    :vartype roles: list[str]
    """

    _validation = {
        "name": {"required": True, "min_length": 1},
        "roles": {"required": True},
    }

    _attribute_map = {
        "name": {"key": "name", "type": "str"},
        "roles": {"key": "roles", "type": "[str]"},
    }

    def __init__(self, *, name: str, roles: List[str], **kwargs):
        """
        :keyword name: Required.
        :paramtype name: str
        :keyword roles: Required.
        :paramtype roles: list[str]
        """
        super().__init__(**kwargs)
        self.name = name
        self.roles = roles


class UpdateMeasurementFormInstanceRequest(_serialization.Model):
    """UpdateMeasurementFormInstanceRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar quantity: Required.
    :vartype quantity: int
    :ivar sequences: Required.
    :vartype sequences: list[~ignos.api.client.models.MeasurementFormWorkorderSequenceDto]
    :ivar suppliers: Required.
    :vartype suppliers: list[~ignos.api.client.models.MeasurementFormWorkorderSupplierDto]
    """

    _validation = {
        "quantity": {"required": True},
        "sequences": {"required": True},
        "suppliers": {"required": True},
    }

    _attribute_map = {
        "quantity": {"key": "quantity", "type": "int"},
        "sequences": {"key": "sequences", "type": "[MeasurementFormWorkorderSequenceDto]"},
        "suppliers": {"key": "suppliers", "type": "[MeasurementFormWorkorderSupplierDto]"},
    }

    def __init__(
        self,
        *,
        quantity: int,
        sequences: List["_models.MeasurementFormWorkorderSequenceDto"],
        suppliers: List["_models.MeasurementFormWorkorderSupplierDto"],
        **kwargs
    ):
        """
        :keyword quantity: Required.
        :paramtype quantity: int
        :keyword sequences: Required.
        :paramtype sequences: list[~ignos.api.client.models.MeasurementFormWorkorderSequenceDto]
        :keyword suppliers: Required.
        :paramtype suppliers: list[~ignos.api.client.models.MeasurementFormWorkorderSupplierDto]
        """
        super().__init__(**kwargs)
        self.quantity = quantity
        self.sequences = sequences
        self.suppliers = suppliers


class UpdateMeasurementFormSchemaRequest(_serialization.Model):
    """UpdateMeasurementFormSchemaRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar exclude_from_customer_documentation: Required.
    :vartype exclude_from_customer_documentation: bool
    :ivar specification:
    :vartype specification: str
    """

    _validation = {
        "exclude_from_customer_documentation": {"required": True},
    }

    _attribute_map = {
        "exclude_from_customer_documentation": {"key": "excludeFromCustomerDocumentation", "type": "bool"},
        "specification": {"key": "specification", "type": "str"},
    }

    def __init__(self, *, exclude_from_customer_documentation: bool, specification: Optional[str] = None, **kwargs):
        """
        :keyword exclude_from_customer_documentation: Required.
        :paramtype exclude_from_customer_documentation: bool
        :keyword specification:
        :paramtype specification: str
        """
        super().__init__(**kwargs)
        self.exclude_from_customer_documentation = exclude_from_customer_documentation
        self.specification = specification


class UpdateMeasurementFormSettings(_serialization.Model):
    """UpdateMeasurementFormSettings.

    All required parameters must be populated in order to send to Azure.

    :ivar convert_inch_to_mm: Required.
    :vartype convert_inch_to_mm: bool
    :ivar validate_measuring_tools: Required.
    :vartype validate_measuring_tools: bool
    :ivar validate_measuring_tools_for_suppliers: Required.
    :vartype validate_measuring_tools_for_suppliers: bool
    :ivar generate_schema_requirements: Required.
    :vartype generate_schema_requirements: bool
    :ivar generate_schema_instances: Required.
    :vartype generate_schema_instances: bool
    :ivar auto_complete_schema_instances: Required.
    :vartype auto_complete_schema_instances: bool
    :ivar generate_report_for_approved_instances: Required.
    :vartype generate_report_for_approved_instances: bool
    :ivar resource_types_blocking_auto_workflow:
    :vartype resource_types_blocking_auto_workflow: list[str]
    """

    _validation = {
        "convert_inch_to_mm": {"required": True},
        "validate_measuring_tools": {"required": True},
        "validate_measuring_tools_for_suppliers": {"required": True},
        "generate_schema_requirements": {"required": True},
        "generate_schema_instances": {"required": True},
        "auto_complete_schema_instances": {"required": True},
        "generate_report_for_approved_instances": {"required": True},
    }

    _attribute_map = {
        "convert_inch_to_mm": {"key": "convertInchToMm", "type": "bool"},
        "validate_measuring_tools": {"key": "validateMeasuringTools", "type": "bool"},
        "validate_measuring_tools_for_suppliers": {"key": "validateMeasuringToolsForSuppliers", "type": "bool"},
        "generate_schema_requirements": {"key": "generateSchemaRequirements", "type": "bool"},
        "generate_schema_instances": {"key": "generateSchemaInstances", "type": "bool"},
        "auto_complete_schema_instances": {"key": "autoCompleteSchemaInstances", "type": "bool"},
        "generate_report_for_approved_instances": {"key": "generateReportForApprovedInstances", "type": "bool"},
        "resource_types_blocking_auto_workflow": {"key": "resourceTypesBlockingAutoWorkflow", "type": "[str]"},
    }

    def __init__(
        self,
        *,
        convert_inch_to_mm: bool,
        validate_measuring_tools: bool,
        validate_measuring_tools_for_suppliers: bool,
        generate_schema_requirements: bool,
        generate_schema_instances: bool,
        auto_complete_schema_instances: bool,
        generate_report_for_approved_instances: bool,
        resource_types_blocking_auto_workflow: Optional[List[str]] = None,
        **kwargs
    ):
        """
        :keyword convert_inch_to_mm: Required.
        :paramtype convert_inch_to_mm: bool
        :keyword validate_measuring_tools: Required.
        :paramtype validate_measuring_tools: bool
        :keyword validate_measuring_tools_for_suppliers: Required.
        :paramtype validate_measuring_tools_for_suppliers: bool
        :keyword generate_schema_requirements: Required.
        :paramtype generate_schema_requirements: bool
        :keyword generate_schema_instances: Required.
        :paramtype generate_schema_instances: bool
        :keyword auto_complete_schema_instances: Required.
        :paramtype auto_complete_schema_instances: bool
        :keyword generate_report_for_approved_instances: Required.
        :paramtype generate_report_for_approved_instances: bool
        :keyword resource_types_blocking_auto_workflow:
        :paramtype resource_types_blocking_auto_workflow: list[str]
        """
        super().__init__(**kwargs)
        self.convert_inch_to_mm = convert_inch_to_mm
        self.validate_measuring_tools = validate_measuring_tools
        self.validate_measuring_tools_for_suppliers = validate_measuring_tools_for_suppliers
        self.generate_schema_requirements = generate_schema_requirements
        self.generate_schema_instances = generate_schema_instances
        self.auto_complete_schema_instances = auto_complete_schema_instances
        self.generate_report_for_approved_instances = generate_report_for_approved_instances
        self.resource_types_blocking_auto_workflow = resource_types_blocking_auto_workflow


class UpdateMeasuringToolRequest(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """UpdateMeasuringToolRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar name: Required.
    :vartype name: str
    :ivar manufacturer: Required.
    :vartype manufacturer: str
    :ivar type_id: Required.
    :vartype type_id: str
    :ivar sub_type_id:
    :vartype sub_type_id: str
    :ivar unit_id:
    :vartype unit_id: str
    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar min:
    :vartype min: float
    :ivar max:
    :vartype max: float
    :ivar serial_number:
    :vartype serial_number: str
    :ivar default_location:
    :vartype default_location: str
    :ivar precision:
    :vartype precision: str
    """

    _validation = {
        "name": {"required": True, "min_length": 1},
        "manufacturer": {"required": True, "min_length": 1},
        "type_id": {"required": True},
    }

    _attribute_map = {
        "name": {"key": "name", "type": "str"},
        "manufacturer": {"key": "manufacturer", "type": "str"},
        "type_id": {"key": "typeId", "type": "str"},
        "sub_type_id": {"key": "subTypeId", "type": "str"},
        "unit_id": {"key": "unitId", "type": "str"},
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "min": {"key": "min", "type": "float"},
        "max": {"key": "max", "type": "float"},
        "serial_number": {"key": "serialNumber", "type": "str"},
        "default_location": {"key": "defaultLocation", "type": "str"},
        "precision": {"key": "precision", "type": "str"},
    }

    def __init__(
        self,
        *,
        name: str,
        manufacturer: str,
        type_id: str,
        sub_type_id: Optional[str] = None,
        unit_id: Optional[str] = None,
        calibration_interval: Optional[int] = None,
        min: Optional[float] = None,  # pylint: disable=redefined-builtin
        max: Optional[float] = None,  # pylint: disable=redefined-builtin
        serial_number: Optional[str] = None,
        default_location: Optional[str] = None,
        precision: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword name: Required.
        :paramtype name: str
        :keyword manufacturer: Required.
        :paramtype manufacturer: str
        :keyword type_id: Required.
        :paramtype type_id: str
        :keyword sub_type_id:
        :paramtype sub_type_id: str
        :keyword unit_id:
        :paramtype unit_id: str
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword min:
        :paramtype min: float
        :keyword max:
        :paramtype max: float
        :keyword serial_number:
        :paramtype serial_number: str
        :keyword default_location:
        :paramtype default_location: str
        :keyword precision:
        :paramtype precision: str
        """
        super().__init__(**kwargs)
        self.name = name
        self.manufacturer = manufacturer
        self.type_id = type_id
        self.sub_type_id = sub_type_id
        self.unit_id = unit_id
        self.calibration_interval = calibration_interval
        self.min = min
        self.max = max
        self.serial_number = serial_number
        self.default_location = default_location
        self.precision = precision


class UpdateMeasuringToolSubTypeRequest(_serialization.Model):
    """UpdateMeasuringToolSubTypeRequest.

    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar max_number_of_usages_between_calibration:
    :vartype max_number_of_usages_between_calibration: int
    """

    _attribute_map = {
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "max_number_of_usages_between_calibration": {"key": "maxNumberOfUsagesBetweenCalibration", "type": "int"},
    }

    def __init__(
        self,
        *,
        calibration_interval: Optional[int] = None,
        max_number_of_usages_between_calibration: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword max_number_of_usages_between_calibration:
        :paramtype max_number_of_usages_between_calibration: int
        """
        super().__init__(**kwargs)
        self.calibration_interval = calibration_interval
        self.max_number_of_usages_between_calibration = max_number_of_usages_between_calibration


class UpdateMeasuringToolTypeRequest(_serialization.Model):
    """UpdateMeasuringToolTypeRequest.

    :ivar calibration_interval:
    :vartype calibration_interval: int
    :ivar max_number_of_usages_between_calibration:
    :vartype max_number_of_usages_between_calibration: int
    """

    _attribute_map = {
        "calibration_interval": {"key": "calibrationInterval", "type": "int"},
        "max_number_of_usages_between_calibration": {"key": "maxNumberOfUsagesBetweenCalibration", "type": "int"},
    }

    def __init__(
        self,
        *,
        calibration_interval: Optional[int] = None,
        max_number_of_usages_between_calibration: Optional[int] = None,
        **kwargs
    ):
        """
        :keyword calibration_interval:
        :paramtype calibration_interval: int
        :keyword max_number_of_usages_between_calibration:
        :paramtype max_number_of_usages_between_calibration: int
        """
        super().__init__(**kwargs)
        self.calibration_interval = calibration_interval
        self.max_number_of_usages_between_calibration = max_number_of_usages_between_calibration


class UpdateSchemaGroupedElementDto(_serialization.Model):
    """UpdateSchemaGroupedElementDto.

    All required parameters must be populated in order to send to Azure.

    :ivar balloon_id: Required.
    :vartype balloon_id: str
    :ivar frequency: Required. Known values are: "All", "FirstArticle", "NFirst", "NPercent",
     "ISO2859", "Nth", and "None".
    :vartype frequency: str or ~ignos.api.client.models.MeasurementFrequency
    :ivar frequency_parameter:
    :vartype frequency_parameter: int
    :ivar include_in_customer_documentation: Required.
    :vartype include_in_customer_documentation: bool
    :ivar can_copy:
    :vartype can_copy: bool
    """

    _validation = {
        "balloon_id": {"required": True, "min_length": 1},
        "frequency": {"required": True},
        "include_in_customer_documentation": {"required": True},
    }

    _attribute_map = {
        "balloon_id": {"key": "balloonId", "type": "str"},
        "frequency": {"key": "frequency", "type": "str"},
        "frequency_parameter": {"key": "frequencyParameter", "type": "int"},
        "include_in_customer_documentation": {"key": "includeInCustomerDocumentation", "type": "bool"},
        "can_copy": {"key": "canCopy", "type": "bool"},
    }

    def __init__(
        self,
        *,
        balloon_id: str,
        frequency: Union[str, "_models.MeasurementFrequency"],
        include_in_customer_documentation: bool,
        frequency_parameter: Optional[int] = None,
        can_copy: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword balloon_id: Required.
        :paramtype balloon_id: str
        :keyword frequency: Required. Known values are: "All", "FirstArticle", "NFirst", "NPercent",
         "ISO2859", "Nth", and "None".
        :paramtype frequency: str or ~ignos.api.client.models.MeasurementFrequency
        :keyword frequency_parameter:
        :paramtype frequency_parameter: int
        :keyword include_in_customer_documentation: Required.
        :paramtype include_in_customer_documentation: bool
        :keyword can_copy:
        :paramtype can_copy: bool
        """
        super().__init__(**kwargs)
        self.balloon_id = balloon_id
        self.frequency = frequency
        self.frequency_parameter = frequency_parameter
        self.include_in_customer_documentation = include_in_customer_documentation
        self.can_copy = can_copy


class UpdateSchemaGroupedElementsRequest(_serialization.Model):
    """UpdateSchemaGroupedElementsRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar grouped_elements: Required.
    :vartype grouped_elements: list[~ignos.api.client.models.UpdateSchemaGroupedElementDto]
    """

    _validation = {
        "grouped_elements": {"required": True},
    }

    _attribute_map = {
        "grouped_elements": {"key": "groupedElements", "type": "[UpdateSchemaGroupedElementDto]"},
    }

    def __init__(self, *, grouped_elements: List["_models.UpdateSchemaGroupedElementDto"], **kwargs):
        """
        :keyword grouped_elements: Required.
        :paramtype grouped_elements: list[~ignos.api.client.models.UpdateSchemaGroupedElementDto]
        """
        super().__init__(**kwargs)
        self.grouped_elements = grouped_elements


class UpdateWhitelistedMeasuringTool(_serialization.Model):
    """UpdateWhitelistedMeasuringTool.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar value: Required.
    :vartype value: str
    :ivar description: Required.
    :vartype description: str
    """

    _validation = {
        "id": {"required": True},
        "value": {"required": True, "min_length": 1},
        "description": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "value": {"key": "value", "type": "str"},
        "description": {"key": "description", "type": "str"},
    }

    def __init__(self, *, id: str, value: str, description: str, **kwargs):  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword value: Required.
        :paramtype value: str
        :keyword description: Required.
        :paramtype description: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.value = value
        self.description = description


class UpdateWorkorderOperationEventTimestamps(_serialization.Model):
    """UpdateWorkorderOperationEventTimestamps.

    :ivar event_id:
    :vartype event_id: str
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    """

    _attribute_map = {
        "event_id": {"key": "eventId", "type": "str"},
        "start_time": {"key": "startTime", "type": "iso-8601"},
        "end_time": {"key": "endTime", "type": "iso-8601"},
    }

    def __init__(
        self,
        *,
        event_id: Optional[str] = None,
        start_time: Optional[datetime.datetime] = None,
        end_time: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword event_id:
        :paramtype event_id: str
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        """
        super().__init__(**kwargs)
        self.event_id = event_id
        self.start_time = start_time
        self.end_time = end_time


class UploadDrawingRequest(_serialization.Model):
    """UploadDrawingRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar upload_key: Required.
    :vartype upload_key: str
    :ivar filename: Required.
    :vartype filename: str
    """

    _validation = {
        "upload_key": {"required": True, "min_length": 1},
        "filename": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "upload_key": {"key": "uploadKey", "type": "str"},
        "filename": {"key": "filename", "type": "str"},
    }

    def __init__(self, *, upload_key: str, filename: str, **kwargs):
        """
        :keyword upload_key: Required.
        :paramtype upload_key: str
        :keyword filename: Required.
        :paramtype filename: str
        """
        super().__init__(**kwargs)
        self.upload_key = upload_key
        self.filename = filename


class UploadInfoDto(_serialization.Model):
    """UploadInfoDto.

    :ivar base_url:
    :vartype base_url: str
    :ivar key:
    :vartype key: str
    :ivar access_key:
    :vartype access_key: str
    """

    _attribute_map = {
        "base_url": {"key": "baseUrl", "type": "str"},
        "key": {"key": "key", "type": "str"},
        "access_key": {"key": "accessKey", "type": "str"},
    }

    def __init__(
        self, *, base_url: Optional[str] = None, key: Optional[str] = None, access_key: Optional[str] = None, **kwargs
    ):
        """
        :keyword base_url:
        :paramtype base_url: str
        :keyword key:
        :paramtype key: str
        :keyword access_key:
        :paramtype access_key: str
        """
        super().__init__(**kwargs)
        self.base_url = base_url
        self.key = key
        self.access_key = access_key


class UploadRequest(_serialization.Model):
    """UploadRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar upload_key: Required.
    :vartype upload_key: str
    :ivar filename: Required.
    :vartype filename: str
    """

    _validation = {
        "upload_key": {"required": True, "min_length": 1},
        "filename": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "upload_key": {"key": "uploadKey", "type": "str"},
        "filename": {"key": "filename", "type": "str"},
    }

    def __init__(self, *, upload_key: str, filename: str, **kwargs):
        """
        :keyword upload_key: Required.
        :paramtype upload_key: str
        :keyword filename: Required.
        :paramtype filename: str
        """
        super().__init__(**kwargs)
        self.upload_key = upload_key
        self.filename = filename


class UpsertCustomerOrderRequest(_serialization.Model):
    """UpsertCustomerOrderRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar external_order_number: External ordernumber. (ie: What your customer calls this order.).
    :vartype external_order_number: str
    :ivar status: Required. Known values are: "Draft", "Ready", "Ongoing", "Completed", and
     "Deleted".
    :vartype status: str or ~ignos.api.client.models.CustomerOrderStatus
    :ivar customer: Customer info. Required.
    :vartype customer: ~ignos.api.client.models.CustomerDto
    :ivar order_lines: Required.
    :vartype order_lines: list[~ignos.api.client.models.CustomerOrderLineDto]
    """

    _validation = {
        "status": {"required": True},
        "customer": {"required": True},
        "order_lines": {"required": True},
    }

    _attribute_map = {
        "external_order_number": {"key": "externalOrderNumber", "type": "str"},
        "status": {"key": "status", "type": "str"},
        "customer": {"key": "customer", "type": "CustomerDto"},
        "order_lines": {"key": "orderLines", "type": "[CustomerOrderLineDto]"},
    }

    def __init__(
        self,
        *,
        status: Union[str, "_models.CustomerOrderStatus"],
        customer: "_models.CustomerDto",
        order_lines: List["_models.CustomerOrderLineDto"],
        external_order_number: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword external_order_number: External ordernumber. (ie: What your customer calls this
         order.).
        :paramtype external_order_number: str
        :keyword status: Required. Known values are: "Draft", "Ready", "Ongoing", "Completed", and
         "Deleted".
        :paramtype status: str or ~ignos.api.client.models.CustomerOrderStatus
        :keyword customer: Customer info. Required.
        :paramtype customer: ~ignos.api.client.models.CustomerDto
        :keyword order_lines: Required.
        :paramtype order_lines: list[~ignos.api.client.models.CustomerOrderLineDto]
        """
        super().__init__(**kwargs)
        self.external_order_number = external_order_number
        self.status = status
        self.customer = customer
        self.order_lines = order_lines


class UpsertCustomerRequest(_serialization.Model):
    """UpsertCustomerRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar name: Required.
    :vartype name: str
    :ivar group_id:
    :vartype group_id: str
    :ivar group_name:
    :vartype group_name: str
    """

    _validation = {
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "name": {"key": "name", "type": "str"},
        "group_id": {"key": "groupId", "type": "str"},
        "group_name": {"key": "groupName", "type": "str"},
    }

    def __init__(self, *, name: str, group_id: Optional[str] = None, group_name: Optional[str] = None, **kwargs):
        """
        :keyword name: Required.
        :paramtype name: str
        :keyword group_id:
        :paramtype group_id: str
        :keyword group_name:
        :paramtype group_name: str
        """
        super().__init__(**kwargs)
        self.name = name
        self.group_id = group_id
        self.group_name = group_name


class UpsertSupplierToMeasurementFormInstanceRequest(_serialization.Model):
    """UpsertSupplierToMeasurementFormInstanceRequest.

    :ivar procurement_order:
    :vartype procurement_order: str
    :ivar procurement_line:
    :vartype procurement_line: int
    :ivar external_order_number:
    :vartype external_order_number: str
    """

    _attribute_map = {
        "procurement_order": {"key": "procurementOrder", "type": "str"},
        "procurement_line": {"key": "procurementLine", "type": "int"},
        "external_order_number": {"key": "externalOrderNumber", "type": "str"},
    }

    def __init__(
        self,
        *,
        procurement_order: Optional[str] = None,
        procurement_line: Optional[int] = None,
        external_order_number: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword procurement_order:
        :paramtype procurement_order: str
        :keyword procurement_line:
        :paramtype procurement_line: int
        :keyword external_order_number:
        :paramtype external_order_number: str
        """
        super().__init__(**kwargs)
        self.procurement_order = procurement_order
        self.procurement_line = procurement_line
        self.external_order_number = external_order_number


class UpsertWorkorder(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """UpsertWorkorder.

    All required parameters must be populated in order to send to Azure.

    :ivar workorder: Required.
    :vartype workorder: str
    :ivar part: Required.
    :vartype part: ~ignos.api.client.models.PartDto
    :ivar quantity: Required.
    :vartype quantity: float
    :ivar unit:
    :vartype unit: str
    :ivar status: Required. Known values are: "Draft", "Ready", "Ongoing", "Completed", and
     "Deleted".
    :vartype status: str or ~ignos.api.client.models.WorkorderStatus
    :ivar operations: Required.
    :vartype operations: list[~ignos.api.client.models.WorkorderOperationDto]
    :ivar planned_start:
    :vartype planned_start: ~datetime.datetime
    :ivar planned_end:
    :vartype planned_end: ~datetime.datetime
    :ivar produced_quantity:
    :vartype produced_quantity: float
    :ivar scrapped_quantity:
    :vartype scrapped_quantity: float
    :ivar customer_order_reference:
    :vartype customer_order_reference: ~ignos.api.client.models.WorkorderCustomerOrderReferenceDto
    """

    _validation = {
        "workorder": {"required": True, "min_length": 1},
        "part": {"required": True},
        "quantity": {"required": True},
        "status": {"required": True},
        "operations": {"required": True},
    }

    _attribute_map = {
        "workorder": {"key": "workorder", "type": "str"},
        "part": {"key": "part", "type": "PartDto"},
        "quantity": {"key": "quantity", "type": "float"},
        "unit": {"key": "unit", "type": "str"},
        "status": {"key": "status", "type": "str"},
        "operations": {"key": "operations", "type": "[WorkorderOperationDto]"},
        "planned_start": {"key": "plannedStart", "type": "iso-8601"},
        "planned_end": {"key": "plannedEnd", "type": "iso-8601"},
        "produced_quantity": {"key": "producedQuantity", "type": "float"},
        "scrapped_quantity": {"key": "scrappedQuantity", "type": "float"},
        "customer_order_reference": {"key": "customerOrderReference", "type": "WorkorderCustomerOrderReferenceDto"},
    }

    def __init__(
        self,
        *,
        workorder: str,
        part: "_models.PartDto",
        quantity: float,
        status: Union[str, "_models.WorkorderStatus"],
        operations: List["_models.WorkorderOperationDto"],
        unit: Optional[str] = None,
        planned_start: Optional[datetime.datetime] = None,
        planned_end: Optional[datetime.datetime] = None,
        produced_quantity: Optional[float] = None,
        scrapped_quantity: Optional[float] = None,
        customer_order_reference: Optional["_models.WorkorderCustomerOrderReferenceDto"] = None,
        **kwargs
    ):
        """
        :keyword workorder: Required.
        :paramtype workorder: str
        :keyword part: Required.
        :paramtype part: ~ignos.api.client.models.PartDto
        :keyword quantity: Required.
        :paramtype quantity: float
        :keyword unit:
        :paramtype unit: str
        :keyword status: Required. Known values are: "Draft", "Ready", "Ongoing", "Completed", and
         "Deleted".
        :paramtype status: str or ~ignos.api.client.models.WorkorderStatus
        :keyword operations: Required.
        :paramtype operations: list[~ignos.api.client.models.WorkorderOperationDto]
        :keyword planned_start:
        :paramtype planned_start: ~datetime.datetime
        :keyword planned_end:
        :paramtype planned_end: ~datetime.datetime
        :keyword produced_quantity:
        :paramtype produced_quantity: float
        :keyword scrapped_quantity:
        :paramtype scrapped_quantity: float
        :keyword customer_order_reference:
        :paramtype customer_order_reference:
         ~ignos.api.client.models.WorkorderCustomerOrderReferenceDto
        """
        super().__init__(**kwargs)
        self.workorder = workorder
        self.part = part
        self.quantity = quantity
        self.unit = unit
        self.status = status
        self.operations = operations
        self.planned_start = planned_start
        self.planned_end = planned_end
        self.produced_quantity = produced_quantity
        self.scrapped_quantity = scrapped_quantity
        self.customer_order_reference = customer_order_reference


class UpsertWorkorderTracesRequest(_serialization.Model):
    """UpsertWorkorderTracesRequest.

    All required parameters must be populated in order to send to Azure.

    :ivar traces: Required.
    :vartype traces: list[~ignos.api.client.models.WorkorderTraceItemDto]
    """

    _validation = {
        "traces": {"required": True},
    }

    _attribute_map = {
        "traces": {"key": "traces", "type": "[WorkorderTraceItemDto]"},
    }

    def __init__(self, *, traces: List["_models.WorkorderTraceItemDto"], **kwargs):
        """
        :keyword traces: Required.
        :paramtype traces: list[~ignos.api.client.models.WorkorderTraceItemDto]
        """
        super().__init__(**kwargs)
        self.traces = traces


class UserAppDto(_serialization.Model):
    """UserAppDto.

    All required parameters must be populated in order to send to Azure.

    :ivar key: Required.
    :vartype key: str
    :ivar name: Required.
    :vartype name: str
    :ivar description:
    :vartype description: str
    """

    _validation = {
        "key": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "key": {"key": "key", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "description": {"key": "description", "type": "str"},
    }

    def __init__(self, *, key: str, name: str, description: Optional[str] = None, **kwargs):
        """
        :keyword key: Required.
        :paramtype key: str
        :keyword name: Required.
        :paramtype name: str
        :keyword description:
        :paramtype description: str
        """
        super().__init__(**kwargs)
        self.key = key
        self.name = name
        self.description = description


class UserDetailsDto(_serialization.Model):
    """UserDetailsDto.

    :ivar id:
    :vartype id: str
    :ivar full_name:
    :vartype full_name: str
    :ivar upn:
    :vartype upn: str
    :ivar roles:
    :vartype roles: list[str]
    :ivar given_name:
    :vartype given_name: str
    :ivar sur_name:
    :vartype sur_name: str
    :ivar tenant_id:
    :vartype tenant_id: str
    :ivar customer_id:
    :vartype customer_id: str
    :ivar is_external_user:
    :vartype is_external_user: bool
    """

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "full_name": {"key": "fullName", "type": "str"},
        "upn": {"key": "upn", "type": "str"},
        "roles": {"key": "roles", "type": "[str]"},
        "given_name": {"key": "givenName", "type": "str"},
        "sur_name": {"key": "surName", "type": "str"},
        "tenant_id": {"key": "tenantId", "type": "str"},
        "customer_id": {"key": "customerId", "type": "str"},
        "is_external_user": {"key": "isExternalUser", "type": "bool"},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        full_name: Optional[str] = None,
        upn: Optional[str] = None,
        roles: Optional[List[str]] = None,
        given_name: Optional[str] = None,
        sur_name: Optional[str] = None,
        tenant_id: Optional[str] = None,
        customer_id: Optional[str] = None,
        is_external_user: Optional[bool] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword full_name:
        :paramtype full_name: str
        :keyword upn:
        :paramtype upn: str
        :keyword roles:
        :paramtype roles: list[str]
        :keyword given_name:
        :paramtype given_name: str
        :keyword sur_name:
        :paramtype sur_name: str
        :keyword tenant_id:
        :paramtype tenant_id: str
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword is_external_user:
        :paramtype is_external_user: bool
        """
        super().__init__(**kwargs)
        self.id = id
        self.full_name = full_name
        self.upn = upn
        self.roles = roles
        self.given_name = given_name
        self.sur_name = sur_name
        self.tenant_id = tenant_id
        self.customer_id = customer_id
        self.is_external_user = is_external_user


class UserDto(_serialization.Model):
    """UserDto.

    :ivar id:
    :vartype id: str
    :ivar full_name:
    :vartype full_name: str
    :ivar upn:
    :vartype upn: str
    """

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "full_name": {"key": "fullName", "type": "str"},
        "upn": {"key": "upn", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        full_name: Optional[str] = None,
        upn: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword full_name:
        :paramtype full_name: str
        :keyword upn:
        :paramtype upn: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.full_name = full_name
        self.upn = upn


class UserDtoPagedResult(_serialization.Model):
    """UserDtoPagedResult.

    All required parameters must be populated in order to send to Azure.

    :ivar results: Required.
    :vartype results: list[~ignos.api.client.models.UserDto]
    :ivar continuation_token:
    :vartype continuation_token: str
    """

    _validation = {
        "results": {"required": True},
    }

    _attribute_map = {
        "results": {"key": "results", "type": "[UserDto]"},
        "continuation_token": {"key": "continuationToken", "type": "str"},
    }

    def __init__(self, *, results: List["_models.UserDto"], continuation_token: Optional[str] = None, **kwargs):
        """
        :keyword results: Required.
        :paramtype results: list[~ignos.api.client.models.UserDto]
        :keyword continuation_token:
        :paramtype continuation_token: str
        """
        super().__init__(**kwargs)
        self.results = results
        self.continuation_token = continuation_token


class UtilizationDetailsDto(_serialization.Model):
    """UtilizationDetailsDto.

    All required parameters must be populated in order to send to Azure.

    :ivar states: Required.
    :vartype states: list[~ignos.api.client.models.StateDto]
    """

    _validation = {
        "states": {"required": True},
    }

    _attribute_map = {
        "states": {"key": "states", "type": "[StateDto]"},
    }

    def __init__(self, *, states: List["_models.StateDto"], **kwargs):
        """
        :keyword states: Required.
        :paramtype states: list[~ignos.api.client.models.StateDto]
        """
        super().__init__(**kwargs)
        self.states = states


class UtilizationDto(_serialization.Model):
    """UtilizationDto.

    :ivar machines:
    :vartype machines: list[~ignos.api.client.models.MachineUtilizationDto]
    """

    _attribute_map = {
        "machines": {"key": "machines", "type": "[MachineUtilizationDto]"},
    }

    def __init__(self, *, machines: Optional[List["_models.MachineUtilizationDto"]] = None, **kwargs):
        """
        :keyword machines:
        :paramtype machines: list[~ignos.api.client.models.MachineUtilizationDto]
        """
        super().__init__(**kwargs)
        self.machines = machines


class UtilizationWorkorderDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """UtilizationWorkorderDto.

    :ivar id:
    :vartype id: str
    :ivar operation:
    :vartype operation: int
    :ivar is_setup:
    :vartype is_setup: bool
    :ivar part_number:
    :vartype part_number: str
    :ivar part_name:
    :vartype part_name: str
    :ivar customer:
    :vartype customer: ~ignos.api.client.models.CustomerDto
    :ivar customer_order:
    :vartype customer_order: str
    :ivar start_time:
    :vartype start_time: ~datetime.datetime
    :ivar workorder_utilization:
    :vartype workorder_utilization: float
    :ivar compared_to_average:
    :vartype compared_to_average: float
    :ivar workorder_description:
    :vartype workorder_description: str
    :ivar operation_description:
    :vartype operation_description: str
    """

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "operation": {"key": "operation", "type": "int"},
        "is_setup": {"key": "isSetup", "type": "bool"},
        "part_number": {"key": "partNumber", "type": "str"},
        "part_name": {"key": "partName", "type": "str"},
        "customer": {"key": "customer", "type": "CustomerDto"},
        "customer_order": {"key": "customerOrder", "type": "str"},
        "start_time": {"key": "startTime", "type": "iso-8601"},
        "workorder_utilization": {"key": "workorderUtilization", "type": "float"},
        "compared_to_average": {"key": "comparedToAverage", "type": "float"},
        "workorder_description": {"key": "workorderDescription", "type": "str"},
        "operation_description": {"key": "operationDescription", "type": "str"},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        operation: Optional[int] = None,
        is_setup: Optional[bool] = None,
        part_number: Optional[str] = None,
        part_name: Optional[str] = None,
        customer: Optional["_models.CustomerDto"] = None,
        customer_order: Optional[str] = None,
        start_time: Optional[datetime.datetime] = None,
        workorder_utilization: Optional[float] = None,
        compared_to_average: Optional[float] = None,
        workorder_description: Optional[str] = None,
        operation_description: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword operation:
        :paramtype operation: int
        :keyword is_setup:
        :paramtype is_setup: bool
        :keyword part_number:
        :paramtype part_number: str
        :keyword part_name:
        :paramtype part_name: str
        :keyword customer:
        :paramtype customer: ~ignos.api.client.models.CustomerDto
        :keyword customer_order:
        :paramtype customer_order: str
        :keyword start_time:
        :paramtype start_time: ~datetime.datetime
        :keyword workorder_utilization:
        :paramtype workorder_utilization: float
        :keyword compared_to_average:
        :paramtype compared_to_average: float
        :keyword workorder_description:
        :paramtype workorder_description: str
        :keyword operation_description:
        :paramtype operation_description: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.operation = operation
        self.is_setup = is_setup
        self.part_number = part_number
        self.part_name = part_name
        self.customer = customer
        self.customer_order = customer_order
        self.start_time = start_time
        self.workorder_utilization = workorder_utilization
        self.compared_to_average = compared_to_average
        self.workorder_description = workorder_description
        self.operation_description = operation_description


class ValidationRuleDto(_serialization.Model):
    """ValidationRuleDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name: Required.
    :vartype name: str
    """

    _validation = {
        "id": {"required": True, "min_length": 1},
        "name": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
    }

    def __init__(self, *, id: str, name: str, **kwargs):  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name: Required.
        :paramtype name: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name


class WhitelistMeasuringTool(_serialization.Model):
    """WhitelistMeasuringTool.

    All required parameters must be populated in order to send to Azure.

    :ivar value: Required.
    :vartype value: str
    :ivar description: Required.
    :vartype description: str
    """

    _validation = {
        "value": {"required": True, "min_length": 1},
        "description": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "value": {"key": "value", "type": "str"},
        "description": {"key": "description", "type": "str"},
    }

    def __init__(self, *, value: str, description: str, **kwargs):
        """
        :keyword value: Required.
        :paramtype value: str
        :keyword description: Required.
        :paramtype description: str
        """
        super().__init__(**kwargs)
        self.value = value
        self.description = description


class WorkorderCustomerOrderReferenceDto(_serialization.Model):
    """WorkorderCustomerOrderReferenceDto.

    :ivar customer_order:
    :vartype customer_order: str
    :ivar customer_order_line:
    :vartype customer_order_line: int
    :ivar customer_id:
    :vartype customer_id: str
    :ivar customer_name:
    :vartype customer_name: str
    :ivar external_order_number:
    :vartype external_order_number: str
    """

    _attribute_map = {
        "customer_order": {"key": "customerOrder", "type": "str"},
        "customer_order_line": {"key": "customerOrderLine", "type": "int"},
        "customer_id": {"key": "customerId", "type": "str"},
        "customer_name": {"key": "customerName", "type": "str"},
        "external_order_number": {"key": "externalOrderNumber", "type": "str"},
    }

    def __init__(
        self,
        *,
        customer_order: Optional[str] = None,
        customer_order_line: Optional[int] = None,
        customer_id: Optional[str] = None,
        customer_name: Optional[str] = None,
        external_order_number: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword customer_order:
        :paramtype customer_order: str
        :keyword customer_order_line:
        :paramtype customer_order_line: int
        :keyword customer_id:
        :paramtype customer_id: str
        :keyword customer_name:
        :paramtype customer_name: str
        :keyword external_order_number:
        :paramtype external_order_number: str
        """
        super().__init__(**kwargs)
        self.customer_order = customer_order
        self.customer_order_line = customer_order_line
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.external_order_number = external_order_number


class WorkorderDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """WorkorderDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id:
    :vartype id: str
    :ivar part: Required.
    :vartype part: ~ignos.api.client.models.PartDto
    :ivar quantity: Required.
    :vartype quantity: float
    :ivar unit:
    :vartype unit: str
    :ivar status: Required. Known values are: "Draft", "Ready", "Ongoing", "Completed", and
     "Deleted".
    :vartype status: str or ~ignos.api.client.models.WorkorderStatus
    :ivar operations: Required.
    :vartype operations: list[~ignos.api.client.models.WorkorderOperationDto]
    :ivar planned_start:
    :vartype planned_start: ~datetime.datetime
    :ivar planned_end:
    :vartype planned_end: ~datetime.datetime
    :ivar produced_quantity:
    :vartype produced_quantity: float
    :ivar scrapped_quantity:
    :vartype scrapped_quantity: float
    :ivar customer_order_reference:
    :vartype customer_order_reference: ~ignos.api.client.models.WorkorderCustomerOrderReferenceDto
    """

    _validation = {
        "part": {"required": True},
        "quantity": {"required": True},
        "status": {"required": True},
        "operations": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "part": {"key": "part", "type": "PartDto"},
        "quantity": {"key": "quantity", "type": "float"},
        "unit": {"key": "unit", "type": "str"},
        "status": {"key": "status", "type": "str"},
        "operations": {"key": "operations", "type": "[WorkorderOperationDto]"},
        "planned_start": {"key": "plannedStart", "type": "iso-8601"},
        "planned_end": {"key": "plannedEnd", "type": "iso-8601"},
        "produced_quantity": {"key": "producedQuantity", "type": "float"},
        "scrapped_quantity": {"key": "scrappedQuantity", "type": "float"},
        "customer_order_reference": {"key": "customerOrderReference", "type": "WorkorderCustomerOrderReferenceDto"},
    }

    def __init__(
        self,
        *,
        part: "_models.PartDto",
        quantity: float,
        status: Union[str, "_models.WorkorderStatus"],
        operations: List["_models.WorkorderOperationDto"],
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        unit: Optional[str] = None,
        planned_start: Optional[datetime.datetime] = None,
        planned_end: Optional[datetime.datetime] = None,
        produced_quantity: Optional[float] = None,
        scrapped_quantity: Optional[float] = None,
        customer_order_reference: Optional["_models.WorkorderCustomerOrderReferenceDto"] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword part: Required.
        :paramtype part: ~ignos.api.client.models.PartDto
        :keyword quantity: Required.
        :paramtype quantity: float
        :keyword unit:
        :paramtype unit: str
        :keyword status: Required. Known values are: "Draft", "Ready", "Ongoing", "Completed", and
         "Deleted".
        :paramtype status: str or ~ignos.api.client.models.WorkorderStatus
        :keyword operations: Required.
        :paramtype operations: list[~ignos.api.client.models.WorkorderOperationDto]
        :keyword planned_start:
        :paramtype planned_start: ~datetime.datetime
        :keyword planned_end:
        :paramtype planned_end: ~datetime.datetime
        :keyword produced_quantity:
        :paramtype produced_quantity: float
        :keyword scrapped_quantity:
        :paramtype scrapped_quantity: float
        :keyword customer_order_reference:
        :paramtype customer_order_reference:
         ~ignos.api.client.models.WorkorderCustomerOrderReferenceDto
        """
        super().__init__(**kwargs)
        self.id = id
        self.part = part
        self.quantity = quantity
        self.unit = unit
        self.status = status
        self.operations = operations
        self.planned_start = planned_start
        self.planned_end = planned_end
        self.produced_quantity = produced_quantity
        self.scrapped_quantity = scrapped_quantity
        self.customer_order_reference = customer_order_reference


class WorkorderHierarchyDto(_serialization.Model):
    """WorkorderHierarchyDto.

    All required parameters must be populated in order to send to Azure.

    :ivar workorder: Required.
    :vartype workorder: str
    :ivar quantity: Required.
    :vartype quantity: float
    :ivar total_quantity: Required.
    :vartype total_quantity: float
    :ivar workorders: Required.
    :vartype workorders: list[~ignos.api.client.models.WorkorderHierarchyDto]
    """

    _validation = {
        "workorder": {"required": True, "min_length": 1},
        "quantity": {"required": True},
        "total_quantity": {"required": True},
        "workorders": {"required": True},
    }

    _attribute_map = {
        "workorder": {"key": "workorder", "type": "str"},
        "quantity": {"key": "quantity", "type": "float"},
        "total_quantity": {"key": "totalQuantity", "type": "float"},
        "workorders": {"key": "workorders", "type": "[WorkorderHierarchyDto]"},
    }

    def __init__(
        self,
        *,
        workorder: str,
        quantity: float,
        total_quantity: float,
        workorders: List["_models.WorkorderHierarchyDto"],
        **kwargs
    ):
        """
        :keyword workorder: Required.
        :paramtype workorder: str
        :keyword quantity: Required.
        :paramtype quantity: float
        :keyword total_quantity: Required.
        :paramtype total_quantity: float
        :keyword workorders: Required.
        :paramtype workorders: list[~ignos.api.client.models.WorkorderHierarchyDto]
        """
        super().__init__(**kwargs)
        self.workorder = workorder
        self.quantity = quantity
        self.total_quantity = total_quantity
        self.workorders = workorders


class WorkorderImportTraceItemDto(_serialization.Model):
    """WorkorderImportTraceItemDto.

    All required parameters must be populated in order to send to Azure.

    :ivar sequence: Required.
    :vartype sequence: str
    :ivar serial_number:
    :vartype serial_number: str
    :ivar lot:
    :vartype lot: str
    :ivar active: Required.
    :vartype active: bool
    """

    _validation = {
        "sequence": {"required": True, "min_length": 1},
        "active": {"required": True},
    }

    _attribute_map = {
        "sequence": {"key": "sequence", "type": "str"},
        "serial_number": {"key": "serialNumber", "type": "str"},
        "lot": {"key": "lot", "type": "str"},
        "active": {"key": "active", "type": "bool"},
    }

    def __init__(
        self, *, sequence: str, active: bool, serial_number: Optional[str] = None, lot: Optional[str] = None, **kwargs
    ):
        """
        :keyword sequence: Required.
        :paramtype sequence: str
        :keyword serial_number:
        :paramtype serial_number: str
        :keyword lot:
        :paramtype lot: str
        :keyword active: Required.
        :paramtype active: bool
        """
        super().__init__(**kwargs)
        self.sequence = sequence
        self.serial_number = serial_number
        self.lot = lot
        self.active = active


class WorkorderListDto(_serialization.Model):
    """WorkorderListDto.

    All required parameters must be populated in order to send to Azure.

    :ivar id:
    :vartype id: str
    :ivar part: Required.
    :vartype part: ~ignos.api.client.models.PartDto
    :ivar quantity: Required.
    :vartype quantity: float
    :ivar unit:
    :vartype unit: str
    :ivar status: Required. Known values are: "Draft", "Ready", "Ongoing", "Completed", and
     "Deleted".
    :vartype status: str or ~ignos.api.client.models.WorkorderStatus
    :ivar planned_start:
    :vartype planned_start: ~datetime.datetime
    :ivar planned_end:
    :vartype planned_end: ~datetime.datetime
    :ivar produced_quantity:
    :vartype produced_quantity: float
    :ivar scrapped_quantity:
    :vartype scrapped_quantity: float
    :ivar customer_order_reference:
    :vartype customer_order_reference: ~ignos.api.client.models.WorkorderCustomerOrderReferenceDto
    """

    _validation = {
        "part": {"required": True},
        "quantity": {"required": True},
        "status": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "part": {"key": "part", "type": "PartDto"},
        "quantity": {"key": "quantity", "type": "float"},
        "unit": {"key": "unit", "type": "str"},
        "status": {"key": "status", "type": "str"},
        "planned_start": {"key": "plannedStart", "type": "iso-8601"},
        "planned_end": {"key": "plannedEnd", "type": "iso-8601"},
        "produced_quantity": {"key": "producedQuantity", "type": "float"},
        "scrapped_quantity": {"key": "scrappedQuantity", "type": "float"},
        "customer_order_reference": {"key": "customerOrderReference", "type": "WorkorderCustomerOrderReferenceDto"},
    }

    def __init__(
        self,
        *,
        part: "_models.PartDto",
        quantity: float,
        status: Union[str, "_models.WorkorderStatus"],
        id: Optional[str] = None,  # pylint: disable=redefined-builtin
        unit: Optional[str] = None,
        planned_start: Optional[datetime.datetime] = None,
        planned_end: Optional[datetime.datetime] = None,
        produced_quantity: Optional[float] = None,
        scrapped_quantity: Optional[float] = None,
        customer_order_reference: Optional["_models.WorkorderCustomerOrderReferenceDto"] = None,
        **kwargs
    ):
        """
        :keyword id:
        :paramtype id: str
        :keyword part: Required.
        :paramtype part: ~ignos.api.client.models.PartDto
        :keyword quantity: Required.
        :paramtype quantity: float
        :keyword unit:
        :paramtype unit: str
        :keyword status: Required. Known values are: "Draft", "Ready", "Ongoing", "Completed", and
         "Deleted".
        :paramtype status: str or ~ignos.api.client.models.WorkorderStatus
        :keyword planned_start:
        :paramtype planned_start: ~datetime.datetime
        :keyword planned_end:
        :paramtype planned_end: ~datetime.datetime
        :keyword produced_quantity:
        :paramtype produced_quantity: float
        :keyword scrapped_quantity:
        :paramtype scrapped_quantity: float
        :keyword customer_order_reference:
        :paramtype customer_order_reference:
         ~ignos.api.client.models.WorkorderCustomerOrderReferenceDto
        """
        super().__init__(**kwargs)
        self.id = id
        self.part = part
        self.quantity = quantity
        self.unit = unit
        self.status = status
        self.planned_start = planned_start
        self.planned_end = planned_end
        self.produced_quantity = produced_quantity
        self.scrapped_quantity = scrapped_quantity
        self.customer_order_reference = customer_order_reference


class WorkorderListDtoPagedResult(_serialization.Model):
    """WorkorderListDtoPagedResult.

    All required parameters must be populated in order to send to Azure.

    :ivar results: Required.
    :vartype results: list[~ignos.api.client.models.WorkorderListDto]
    :ivar continuation_token:
    :vartype continuation_token: str
    """

    _validation = {
        "results": {"required": True},
    }

    _attribute_map = {
        "results": {"key": "results", "type": "[WorkorderListDto]"},
        "continuation_token": {"key": "continuationToken", "type": "str"},
    }

    def __init__(
        self, *, results: List["_models.WorkorderListDto"], continuation_token: Optional[str] = None, **kwargs
    ):
        """
        :keyword results: Required.
        :paramtype results: list[~ignos.api.client.models.WorkorderListDto]
        :keyword continuation_token:
        :paramtype continuation_token: str
        """
        super().__init__(**kwargs)
        self.results = results
        self.continuation_token = continuation_token


class WorkorderMaterialDto(_serialization.Model):
    """WorkorderMaterialDto.

    All required parameters must be populated in order to send to Azure.

    :ivar material_line:
    :vartype material_line: int
    :ivar status: Required. Known values are: "Unknown", "NotStarted", "Partial", and "Completed".
    :vartype status: str or ~ignos.api.client.models.MaterialStatus
    :ivar material: Required.
    :vartype material: ~ignos.api.client.models.PartDto
    :ivar quantity_per_part: Required.
    :vartype quantity_per_part: float
    :ivar fixed_quantity: Required.
    :vartype fixed_quantity: bool
    :ivar used_quantity:
    :vartype used_quantity: float
    :ivar unit:
    :vartype unit: str
    """

    _validation = {
        "status": {"required": True},
        "material": {"required": True},
        "quantity_per_part": {"required": True},
        "fixed_quantity": {"required": True},
    }

    _attribute_map = {
        "material_line": {"key": "materialLine", "type": "int"},
        "status": {"key": "status", "type": "str"},
        "material": {"key": "material", "type": "PartDto"},
        "quantity_per_part": {"key": "quantityPerPart", "type": "float"},
        "fixed_quantity": {"key": "fixedQuantity", "type": "bool"},
        "used_quantity": {"key": "usedQuantity", "type": "float"},
        "unit": {"key": "unit", "type": "str"},
    }

    def __init__(
        self,
        *,
        status: Union[str, "_models.MaterialStatus"],
        material: "_models.PartDto",
        quantity_per_part: float,
        fixed_quantity: bool,
        material_line: Optional[int] = None,
        used_quantity: Optional[float] = None,
        unit: Optional[str] = None,
        **kwargs
    ):
        """
        :keyword material_line:
        :paramtype material_line: int
        :keyword status: Required. Known values are: "Unknown", "NotStarted", "Partial", and
         "Completed".
        :paramtype status: str or ~ignos.api.client.models.MaterialStatus
        :keyword material: Required.
        :paramtype material: ~ignos.api.client.models.PartDto
        :keyword quantity_per_part: Required.
        :paramtype quantity_per_part: float
        :keyword fixed_quantity: Required.
        :paramtype fixed_quantity: bool
        :keyword used_quantity:
        :paramtype used_quantity: float
        :keyword unit:
        :paramtype unit: str
        """
        super().__init__(**kwargs)
        self.material_line = material_line
        self.status = status
        self.material = material
        self.quantity_per_part = quantity_per_part
        self.fixed_quantity = fixed_quantity
        self.used_quantity = used_quantity
        self.unit = unit


class WorkorderOperationDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """WorkorderOperationDto.

    All required parameters must be populated in order to send to Azure.

    :ivar operation: Required.
    :vartype operation: int
    :ivar description:
    :vartype description: str
    :ivar planned_setup_time: Required.
    :vartype planned_setup_time: float
    :ivar planned_production_time_per_part: Required.
    :vartype planned_production_time_per_part: float
    :ivar fixed_time:
    :vartype fixed_time: bool
    :ivar resource: Required.
    :vartype resource: ~ignos.api.client.models.ResourceDto
    :ivar planned_start:
    :vartype planned_start: ~datetime.datetime
    :ivar planned_end:
    :vartype planned_end: ~datetime.datetime
    :ivar status: Required. Known values are: "NotReady", "Ready", "Ongoing", and "Completed".
    :vartype status: str or ~ignos.api.client.models.OperationStatus
    :ivar produced_quantity: Required.
    :vartype produced_quantity: float
    :ivar scrapped_quantity: Required.
    :vartype scrapped_quantity: float
    :ivar used_production_time: Required.
    :vartype used_production_time: float
    :ivar used_setup_time: Required.
    :vartype used_setup_time: float
    :ivar materials: Required.
    :vartype materials: list[~ignos.api.client.models.WorkorderMaterialDto]
    """

    _validation = {
        "operation": {"required": True},
        "planned_setup_time": {"required": True},
        "planned_production_time_per_part": {"required": True},
        "resource": {"required": True},
        "status": {"required": True},
        "produced_quantity": {"required": True},
        "scrapped_quantity": {"required": True},
        "used_production_time": {"required": True},
        "used_setup_time": {"required": True},
        "materials": {"required": True},
    }

    _attribute_map = {
        "operation": {"key": "operation", "type": "int"},
        "description": {"key": "description", "type": "str"},
        "planned_setup_time": {"key": "plannedSetupTime", "type": "float"},
        "planned_production_time_per_part": {"key": "plannedProductionTimePerPart", "type": "float"},
        "fixed_time": {"key": "fixedTime", "type": "bool"},
        "resource": {"key": "resource", "type": "ResourceDto"},
        "planned_start": {"key": "plannedStart", "type": "iso-8601"},
        "planned_end": {"key": "plannedEnd", "type": "iso-8601"},
        "status": {"key": "status", "type": "str"},
        "produced_quantity": {"key": "producedQuantity", "type": "float"},
        "scrapped_quantity": {"key": "scrappedQuantity", "type": "float"},
        "used_production_time": {"key": "usedProductionTime", "type": "float"},
        "used_setup_time": {"key": "usedSetupTime", "type": "float"},
        "materials": {"key": "materials", "type": "[WorkorderMaterialDto]"},
    }

    def __init__(
        self,
        *,
        operation: int,
        planned_setup_time: float,
        planned_production_time_per_part: float,
        resource: "_models.ResourceDto",
        status: Union[str, "_models.OperationStatus"],
        produced_quantity: float,
        scrapped_quantity: float,
        used_production_time: float,
        used_setup_time: float,
        materials: List["_models.WorkorderMaterialDto"],
        description: Optional[str] = None,
        fixed_time: Optional[bool] = None,
        planned_start: Optional[datetime.datetime] = None,
        planned_end: Optional[datetime.datetime] = None,
        **kwargs
    ):
        """
        :keyword operation: Required.
        :paramtype operation: int
        :keyword description:
        :paramtype description: str
        :keyword planned_setup_time: Required.
        :paramtype planned_setup_time: float
        :keyword planned_production_time_per_part: Required.
        :paramtype planned_production_time_per_part: float
        :keyword fixed_time:
        :paramtype fixed_time: bool
        :keyword resource: Required.
        :paramtype resource: ~ignos.api.client.models.ResourceDto
        :keyword planned_start:
        :paramtype planned_start: ~datetime.datetime
        :keyword planned_end:
        :paramtype planned_end: ~datetime.datetime
        :keyword status: Required. Known values are: "NotReady", "Ready", "Ongoing", and "Completed".
        :paramtype status: str or ~ignos.api.client.models.OperationStatus
        :keyword produced_quantity: Required.
        :paramtype produced_quantity: float
        :keyword scrapped_quantity: Required.
        :paramtype scrapped_quantity: float
        :keyword used_production_time: Required.
        :paramtype used_production_time: float
        :keyword used_setup_time: Required.
        :paramtype used_setup_time: float
        :keyword materials: Required.
        :paramtype materials: list[~ignos.api.client.models.WorkorderMaterialDto]
        """
        super().__init__(**kwargs)
        self.operation = operation
        self.description = description
        self.planned_setup_time = planned_setup_time
        self.planned_production_time_per_part = planned_production_time_per_part
        self.fixed_time = fixed_time
        self.resource = resource
        self.planned_start = planned_start
        self.planned_end = planned_end
        self.status = status
        self.produced_quantity = produced_quantity
        self.scrapped_quantity = scrapped_quantity
        self.used_production_time = used_production_time
        self.used_setup_time = used_setup_time
        self.materials = materials


class WorkorderOperationEventDto(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """WorkorderOperationEventDto.

    All required parameters must be populated in order to send to Azure.

    :ivar event_id: Required.
    :vartype event_id: str
    :ivar external_id:
    :vartype external_id: str
    :ivar workorder: Required.
    :vartype workorder: str
    :ivar operation: Required.
    :vartype operation: int
    :ivar start_time: Required.
    :vartype start_time: ~datetime.datetime
    :ivar end_time:
    :vartype end_time: ~datetime.datetime
    :ivar is_setup: Required.
    :vartype is_setup: bool
    :ivar employee:
    :vartype employee: ~ignos.api.client.models.EmployeeDto
    :ivar resource_id: Required.
    :vartype resource_id: str
    :ivar description:
    :vartype description: str
    :ivar part:
    :vartype part: ~ignos.api.client.models.PartDto
    """

    _validation = {
        "event_id": {"required": True, "min_length": 1},
        "workorder": {"required": True, "min_length": 1},
        "operation": {"required": True},
        "start_time": {"required": True},
        "is_setup": {"required": True},
        "resource_id": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "event_id": {"key": "eventId", "type": "str"},
        "external_id": {"key": "externalId", "type": "str"},
        "workorder": {"key": "workorder", "type": "str"},
        "operation": {"key": "operation", "type": "int"},
        "start_time": {"key": "startTime", "type": "iso-8601"},
        "end_time": {"key": "endTime", "type": "iso-8601"},
        "is_setup": {"key": "isSetup", "type": "bool"},
        "employee": {"key": "employee", "type": "EmployeeDto"},
        "resource_id": {"key": "resourceId", "type": "str"},
        "description": {"key": "description", "type": "str"},
        "part": {"key": "part", "type": "PartDto"},
    }

    def __init__(
        self,
        *,
        event_id: str,
        workorder: str,
        operation: int,
        start_time: datetime.datetime,
        is_setup: bool,
        resource_id: str,
        external_id: Optional[str] = None,
        end_time: Optional[datetime.datetime] = None,
        employee: Optional["_models.EmployeeDto"] = None,
        description: Optional[str] = None,
        part: Optional["_models.PartDto"] = None,
        **kwargs
    ):
        """
        :keyword event_id: Required.
        :paramtype event_id: str
        :keyword external_id:
        :paramtype external_id: str
        :keyword workorder: Required.
        :paramtype workorder: str
        :keyword operation: Required.
        :paramtype operation: int
        :keyword start_time: Required.
        :paramtype start_time: ~datetime.datetime
        :keyword end_time:
        :paramtype end_time: ~datetime.datetime
        :keyword is_setup: Required.
        :paramtype is_setup: bool
        :keyword employee:
        :paramtype employee: ~ignos.api.client.models.EmployeeDto
        :keyword resource_id: Required.
        :paramtype resource_id: str
        :keyword description:
        :paramtype description: str
        :keyword part:
        :paramtype part: ~ignos.api.client.models.PartDto
        """
        super().__init__(**kwargs)
        self.event_id = event_id
        self.external_id = external_id
        self.workorder = workorder
        self.operation = operation
        self.start_time = start_time
        self.end_time = end_time
        self.is_setup = is_setup
        self.employee = employee
        self.resource_id = resource_id
        self.description = description
        self.part = part


class WorkorderTraceItemDto(_serialization.Model):
    """WorkorderTraceItemDto.

    All required parameters must be populated in order to send to Azure.

    :ivar sequence: Required.
    :vartype sequence: str
    :ivar serial_number:
    :vartype serial_number: str
    :ivar lot:
    :vartype lot: str
    """

    _validation = {
        "sequence": {"required": True, "min_length": 1},
    }

    _attribute_map = {
        "sequence": {"key": "sequence", "type": "str"},
        "serial_number": {"key": "serialNumber", "type": "str"},
        "lot": {"key": "lot", "type": "str"},
    }

    def __init__(self, *, sequence: str, serial_number: Optional[str] = None, lot: Optional[str] = None, **kwargs):
        """
        :keyword sequence: Required.
        :paramtype sequence: str
        :keyword serial_number:
        :paramtype serial_number: str
        :keyword lot:
        :paramtype lot: str
        """
        super().__init__(**kwargs)
        self.sequence = sequence
        self.serial_number = serial_number
        self.lot = lot
